package de.uka.algo.generator.util;

import java.awt.Color;
import java.util.HashMap;
import java.util.Random;

public class ColorMap<Key> {

	HashMap<Key,Color> map;
	Random rand;
	
	public ColorMap() {
		this.map = new HashMap<Key,Color>();
		this.rand = new Random();
	}
	
	public Color getColor(Key k) {
		if (this.map.containsKey(k)) {
			return this.map.get(k);
		} else {
			// create new random color
			Color c;
			do {
				int r = rand.nextInt(256);
				int g = rand.nextInt(256);
				int b = rand.nextInt(256);
				c = new Color(r, g, b);
			} while (this.map.containsValue(c));
			
			this.map.put(k, c);
			return c;
		}
	}
	
	
	public String getHexColor(Key k) {
		Color c = this.getColor(k);
		String h = Integer.toHexString(c.getRGB());
		return "#" + h.substring(2,h.length());
	}
	
}
