package de.uka.algo.generator.util;

public class Pair<Element> {
    
    public final Element x;
    public final Element y;
    
    /**
     * Construct a Pair from two elements.
     * @param x
     * @param y
     */
    public Pair(Element x, Element y) {
        super();
        this.x = x;
        this.y = y;
    }


    
    @Override
    /**
     * Two pairs are equal if their elements
     * are equal (irrespective of their order).
     */
    public boolean equals(Object other) {
        if (!(other instanceof Pair)) {
            return false;
        } else {
            Pair<Element> otherPair = (Pair<Element>) other;
            return ((otherPair.x.equals(this.x))
                    && (otherPair.y.equals(this.y)))
                    || ((otherPair.x.equals(this.y))
                    && (otherPair.y.equals(this.x)));
        }

    }
    
    /**
     * Write pair as string.
     */
    public String toString() {
    	return "(" + this.x.toString() +"," + this.y.toString() + ")";
    }
    
    
    public int hashCode() {
    	return this.x.hashCode() * this.y.hashCode();
    }

}
