/* 
 * Integration: May 2, 2006 (katz)
 * Reviewed: May 2, 2006 (katz)
 *
 * Copyright 2004-2006.  --- All rights reserved. 
 * Algorithmic Group, Karlsruhe, Germany.
 */
package de.uka.algo.clustering;

/**
 * A ClusteringReference has a reference to a clustering as well as an accessing
 * method. This class can be extended to provide this often used functionality.
 * 
 * @author Bastian Katz, mailto:katz@ira.uka.de
 */
public abstract class ClusteringReference {

	/* ===== fields ==== */
	/* the underlying clustering, protected to allow fast access */
	protected Clustering clustering;

	/* ===== constructor ===== */
	
	/**
	 * Instantiates a new ClusteringReference for a given Clustering.
	 * 
	 * @param aClustering
	 *            the clustering
	 */
	protected ClusteringReference(Clustering aClustering) {
		this.clustering = aClustering;
	}

	/* ===== getters and setters ===== */
	
	/**
	 * Getter method for the assigned clustering
	 * 
	 * @return the clustering
	 */
	public Clustering getClustering() {
		return clustering;
	}
}