/*
 * Created on Aug 24, 2004
 * Reviewed 1.2 (Jan 9, 2005)
 *
 * Copyright 2004.  --- All rights reserved. 
 * Algorithmic Group, Karlsruhe, Germany.
 */
package de.uka.algo.clustering.algorithms;

import de.uka.algo.clustering.Clustering;

/**
 * An {@link Algorithm} is a class performing an algorithm on clusterings. There is no
 * general restriction to clusterings passed to a clusterer. Thus, every
 * clusterer needs to be precisely specified, particulary with regard to the
 * question how 'free' nodes (not assigned to clusters) and existing clusters
 * are dealt with.
 * 
 * @author Bastian Katz
 */
public interface Algorithm {

    /**
     * Performs the algorithm to change the clustering.
     * 
     * @param aClustering
     */
    public abstract void run(Clustering aClustering);
}