/*
 * Created on Jan 8, 2005
 * Reviewed 1.1 (Jan 8, 2005)
 *
 * Copyright 2004.  --- All rights reserved. 
 * Algorithmic Group, Karlsruhe, Germany.
 */
package de.uka.algo.clustering.algorithms;

import de.uka.algo.clustering.Clustering;
import de.uka.algo.util.GYCursor;
import de.uka.algo.util.GYList;

/**
 * A ClustererList performs a set of algorithms.
 * 
 * @author Bastian Katz
 */
public class AlgorithmList implements Algorithm {

    /** the list of clusterers to call */
    private GYList<Algorithm> algorithms = null;

    /**
     * Instantiates a new (empty) ClustererList.
     */
    public AlgorithmList() {
        algorithms = new GYList<Algorithm>();
    }

    /**
     * Adds a clustering algorithm to the list.
     * 
     * @param aClusterer the clusterer to add
     */
    public void addAlgorithm(Algorithm anAlgorithm) {
        algorithms.addLast(anAlgorithm);
    }

    /*
     * (non-Javadoc)
     * 
     * @see de.uka.algo.clustering.stages.Clusterer#doCluster(de.uka.algo.clustering.Clustering)
     */
    public void run(Clustering aClustering) {
        for (GYCursor<Algorithm> el = algorithms.elements(); el.ok(); el.next()) {
            el.active().run(aClustering);
        }
    }

}