/*
 * Created on Aug 31, 2004
 * Reviewed 1.2 (Jan 9, 2005)
 *
 * Copyright 2004.  --- All rights reserved. 
 * Algorithmic Group, Karlsruhe, Germany.
 */
package de.uka.algo.clustering.algorithms;

import y.base.Graph;
import y.base.NodeCursor;
import de.uka.algo.clustering.Cluster;
import de.uka.algo.clustering.Clustering;
import de.uka.algo.graphs.GraphInterpretation;

/**
 * @author Bastian Katz
 *  
 */
public abstract class Cutter implements Algorithm {

    public void run(Clustering aClustering) {
        Cluster a = aClustering.resetLargeCluster();

        /* find cut */
        NodeCursor r = getCut(aClustering.getGraph(),
                aClustering.getInterpretation());

        /* split */
        if (r.size() != aClustering.getGraph().nodeCount() && r.size() != 0) {
            aClustering.split(a, r);
        }
    }

	protected abstract NodeCursor getCut(Graph graph, GraphInterpretation interpretation);	
}