package de.uka.algo.clustering.algorithms.greedy;

import y.base.NodeList;
import de.uka.algo.clustering.Cluster;
import de.uka.algo.clustering.Clustering;
import de.uka.algo.clustering.index.Index;
import de.uka.algo.clustering.index.IndexFactory;

public class EmulationPredictor extends Predictor {

	private Index index;
	private Clustering clustering;

	public EmulationPredictor(IndexFactory factory, Clustering clustering) {
		this.index = factory.getIndex(clustering); 
		this.clustering = clustering;
	}
	
	public MergeResult getChangeOnMerge(Cluster a, Cluster b) {
		NodeList nl = new NodeList(b.members());
		double result = -index.getValue();
		Cluster v = clustering.merge(a,b);
		result+=index.getValue();
		Cluster x =clustering.split(v, nl.nodes());
		return new MergeResult(v,x,result);
	}
	
	public static class Factory implements PredictorFactory {
		IndexFactory factory;
		public Factory(IndexFactory factory) {
			this.factory = factory;
		}
		
		public Predictor predictor(Clustering cl) {
			return new EmulationPredictor(factory, cl);
		}		
	}
}
