package de.uka.algo.clustering.algorithms.modules;

import de.uka.algo.clustering.Clustering;
import de.uka.algo.clustering.algorithms.Algorithm;
import de.uka.algo.clustering.visualization.Graph2DExtractor;
import de.uka.algo.clustering.visualization.VisualizingModule;

/**
 * @author Bastian Katz
 */

public abstract class AlgorithmModule extends VisualizingModule {

	private boolean extractClustering;

	public AlgorithmModule(String arg0, String arg1, String arg2,
			boolean extractClustering, int handleWeights) {
		super(arg0, arg1, arg2, extractClustering ? 1 : 0,
				handleWeights, GROUPS_KEEP, false);
		this.extractClustering = extractClustering;
	}

	protected abstract Algorithm algorithm();

	public Graph2DExtractor getExtractor() {
		if (!extractClustering){
			throw new RuntimeException("error: ");
		}
		return getExtractor(0); 
	}
	
	protected final Clustering coreRun() {
		Clustering clustering = null;
		if (extractClustering) {
			clustering = getChosenClustering(0);
		} else {
			clustering = getDefaultClustering();
		}
		algorithm().run(clustering);
		return clustering;
	}
}