package de.uka.algo.clustering.algorithms.modules;

import java.util.Iterator;
import java.util.LinkedList;

import y.option.OptionHandler;
import de.uka.algo.clustering.index.IndexFactory;
import de.uka.algo.clustering.index.IndexRegistration;
import de.uka.algo.clustering.index.MixedIndex;

public abstract class IndexAlgorithmModule extends AlgorithmModule {

	public IndexAlgorithmModule(String arg0, String arg1, String arg2, boolean extractClustering, int handleWeights) {
		super(arg0, arg1, arg2, extractClustering, handleWeights);
	}

	protected final IndexFactory getIndexFactory() {		
		OptionHandler op = getOptionHandler();
		op.useSection("Indizes");
		LinkedList<IndexFactory> facs = new LinkedList<IndexFactory>();
		for (Iterator<IndexFactory> it = IndexRegistration.getIndizes().iterator(); it.hasNext();) {
			IndexFactory ifac = it.next();
			if (op.getDouble(ifac.toString())!= 0.0) facs.add(ifac);
		}
		if (facs.size()==1) return facs.element();
		IndexFactory[] factories = new IndexFactory[facs.size()];
		double[] weights = new double[facs.size()];

		int i = 0;
		for (Iterator<IndexFactory> it = facs.iterator(); it.hasNext();) {
			factories[i] = it.next();
			weights[i] = op.getDouble(factories[i].toString());
			i++;
		}
		return new MixedIndex.Factory(op.getBool("geometric mean"), factories, weights);
		
	}
	
	protected OptionHandler createOptionHandler() {
		OptionHandler op = new OptionHandler("");
		op.useSection("Indizes");
		for (Iterator<IndexFactory> it = IndexRegistration.getIndizes().iterator(); it.hasNext();) {
			IndexFactory ifac = it.next();
			op.addDouble(ifac.toString(), 0.0, 0.0, 1.0);
		}
		op.addBool("geometric mean", false);
		op.addOptionHandler(super.createOptionHandler(), "");
		return op;
	}
}
