/*
 * created May 4, 2006
 *
 * Copyright 2006.  --- All rights reserved. 
 * Algorithmic Group, Karlsruhe, Germany.
 *
 */
package de.uka.algo.clustering.comparison;

/**
 * this interface should be implemented when creating new comparison measures. A
 * comparison measure calculates the distance between two clusterings where 0
 * stands for equality and 1 for "maximal" distance.
 * 
 * @author Daniel Delling
 * 
 */
public interface Comparator {

	/**
	 * return the comparison value.
	 * 
	 * @return
	 */
	public abstract double getValue();

	public abstract String toString();
}
