package de.uka.algo.clustering.comparison;

import de.uka.algo.clustering.Clustering;

/**
 * An ComparatorFactory is a factory providing comparators for two given
 * clustering, which allows to design clustering algorithms somehow
 * 'generically' taking a factory as parameter and, for instance, optimizing it.
 * 
 * @author Daniel Delling
 * 
 */
public interface ComparatorFactory {

	public abstract Comparator getComparator(Clustering a, Clustering b);

	// should implement toString();
}