package de.uka.algo.clustering.comparison;

import java.util.LinkedList;

import y.base.YList;

public class ComparatorRegistration {
	
	private static String[] headings = { "quality-based", "node-based, counting",
			"node-based, overlap", "node-based, information theoretic",
			"graph-based, counting", "graph-based, overlap",
			"graph-based, information-theoretic", "user-defined" };

	private static YList[] factories = new YList[ComparatorTypes.values().length];
			
	public static enum ComparatorTypes {
		qualityBased, nodeBasedCounting,
		nodeBasedOverlap, nodeBasedInformationTheoretic,
		graphBasedCounting, graphBasedOverlap,
		graphBasedInformationTheoretic, userDefined
	}
	
	public static String getSectionName(ComparatorTypes s) {
		return headings[s.ordinal()];
	}
	
	public static void addComparator(ComparatorFactory cf, ComparatorTypes s) {
		if (factories[s.ordinal()]==null) {
			factories[s.ordinal()] = new YList();
		}
		factories[s.ordinal()].addLast(cf);
	}
	public static void addComparator(ComparatorFactory cf) {
		addComparator(cf, ComparatorTypes.userDefined);
	}

	@SuppressWarnings("unchecked")
	public static LinkedList<ComparatorFactory> getComparatorFactories(ComparatorTypes s) {
		if (factories[s.ordinal()]==null) {
			factories[s.ordinal()] = new YList();
		}
		return new LinkedList<ComparatorFactory>(factories[s.ordinal()]);
	}
	
	
}
