package de.uka.algo.clustering.comparison.modules;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.table.AbstractTableModel;

import de.uka.algo.clustering.comparison.ComparatorRegistration;
import de.uka.algo.clustering.comparison.ComparatorRegistration.ComparatorTypes;
import de.uka.algo.clustering.visualization.FacadeModule;

public class ComparatorPopupModule extends FacadeModule {

	JFrame frame;

	public ComparatorPopupModule() {
		super("", "", "", 2, WEIGHTS_ASK, GROUPS_KEEP, false);
	}

	@SuppressWarnings("synthetic-access")
	protected final void core() {
		frame = new JFrame("Comparators");
		frame.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		JPanel outer = new JPanel();
		JScrollPane pp = new JScrollPane(outer);
		outer.setLayout(new BoxLayout(outer, BoxLayout.X_AXIS));
		for (int k = 0; k < 2; k++) {
			JPanel pane = new JPanel();
			pane.setLayout(new BoxLayout(pane, BoxLayout.Y_AXIS));

			for (int i = k*4; i < 4+k*4; i++) {
				JPanel pnl = new JPanel();
				JTable p = new JTable(new MyTableModel(ComparatorTypes.values()[i]));
				p.getColumn("Comparator").setPreferredWidth(260);
				p.getColumn("Value").setPreferredWidth(160);
				p.doLayout();
				p.setBorder(BorderFactory.createEmptyBorder(10, 0, 0, 0));
				pnl.add(p);
				pane.add(pnl);
			}
			outer.add(pane);
		}
		frame.getContentPane().add(pp);
		frame.pack();
		frame.setVisible(true);
	}

	private class MyTableModel extends AbstractTableModel {
		private static final long serialVersionUID = -1091576109554578925L;

		private ComparatorTypes id;

		private String[][] values;
		private MyTableModel(ComparatorTypes id) {
			this.id = id;
			double value = 0.0;
			
			long rounding = 1000000000*1000;
			values = new String[ComparatorRegistration.getComparatorFactories(id).size()][2];
			for (int i = 0; i < ComparatorRegistration.getComparatorFactories(id).size(); i++) {
				values[i][0] = ComparatorRegistration.getComparatorFactories(id).get(i).toString();
				value = ComparatorRegistration.getComparatorFactories(id).get(i).getComparator(
						getChosenClustering(0),
						getChosenClustering(1)).getValue();
				values[i][1] = "" + (Math.round(value*rounding)/(double)rounding);
			}
		}

		public String getColumnName(int col) {
			if (col == 0)
				return "Comparator";
			return "Value";
		}

		public int getRowCount() {
			return ComparatorRegistration.getComparatorFactories(id).size() + 1;
		}

		public int getColumnCount() {
			return 2;
		}

		public Object getValueAt(int row, int col) {
			if (row == 0) {
				return (col == 0) ? "<html><b><u>" + ComparatorRegistration.getSectionName(id)
						+ "<u></b></html>" : "";
			}
			return values[row - 1][col];
		}

		public boolean isCellEditable(int row, int col) {
			return false;
		}
	}

	@Override
	protected String inputName(int i) {
		return "Clustering #" + i;
	}

}
