/*
 * created May 12, 2006
 *
 * Copyright 2006.  --- All rights reserved. 
 * Algorithmic Group, Karlsruhe, Germany.
 *
 */
package de.uka.algo.clustering.edgeweighters;

import y.base.EdgeMap;
import y.base.Graph;
import de.uka.algo.clustering.Cluster;
import de.uka.algo.clustering.Clustering;
import de.uka.algo.graphs.GraphInterpretation;
import de.uka.algo.graphs.WeightedGraph;
import de.uka.algo.util.GYCursor;

/**
 * edgeWeighter manipulate a given clustering. If the underlying graph is
 * unweighted, it will be weighted afterwards. If it is already weighted, the
 * weights of (some) edges will be modified.
 * 
 * @author Daniel Delling
 * 
 */
public abstract class EdgeWeighter {

	
	public final Clustering changeWeightsOnClustering(Clustering cl){
		Graph g = cl.getGraph();
		GraphInterpretation gi = new WeightedGraph(g, changeEdges(cl));
		Clustering result = new Clustering(g,gi);
		for(GYCursor<Cluster> cc = cl.clusters(); cc.ok(); cc.next()){
			result.newCluster(cc.active().members());
		}		
		return result;
	}
	
	public abstract EdgeMap changeEdges(Clustering cl);
	
}
