/*
 * created May 18, 2006
 *
 * Copyright 2006.  --- All rights reserved. 
 * Algorithmic Group, Karlsruhe, Germany.
 *
 */
package de.uka.algo.clustering.edgeweighters.modules;

import y.option.OptionHandler;
import de.uka.algo.clustering.Clustering;
import de.uka.algo.clustering.edgeweighters.EdgeWeighter;
import de.uka.algo.clustering.visualization.EdgeWeightVisualizer;
import de.uka.algo.clustering.visualization.FacadeModule;

public abstract class EdgeWeighterModule extends FacadeModule {

	private static final String PRECISION = "round weights";
	
	public EdgeWeighterModule(String arg0, String arg1, String arg2) {
		super(arg0, arg1, arg2, 1, WEIGHTS_USE, GROUPS_KEEP, false);
	}
	
	public abstract EdgeWeighter getEdgeWeighter();
	
	@Override
	protected void core() {
		Clustering cl = getEdgeWeighter().changeWeightsOnClustering(getChosenClustering(0));
		new EdgeWeightVisualizer().visualize(cl, getOptionHandler().getBool(PRECISION));
	}

	@Override
	protected OptionHandler createOptionHandler() {
		OptionHandler result = super.createOptionHandler();
		result.addBool(PRECISION, true);
		return result;
	}
	
}
