/*
 * Created on 28.4.06
 *
 * Copyright 2006.  --- All rights reserved. 
 * Algorithmic Group, Karlsruhe, Germany.
 */
package de.uka.algo.clustering.generators.modules;

import y.base.NodeCursor;
import y.view.Graph2D;
import de.uka.algo.clustering.Clustering;
import de.uka.algo.clustering.generators.ClusteredGraph;
import de.uka.algo.clustering.generators.EmbeddedClusteredGraph;
import de.uka.algo.clustering.visualization.VisualizingModule;

/**
 * @author Daniel Delling
 */

public abstract class ClusteredGraphModule extends VisualizingModule {

	public ClusteredGraphModule(String arg0, String arg1, String arg2) {
		super(arg0, arg1, arg2, 0, WEIGHTS_USE, GROUPS_KILL, false);
	}

	protected abstract ClusteredGraph clusteredGraph(Graph2D g);

	protected final Clustering coreRun() {
		Graph2D toCluster = getGraph2D();
		ClusteredGraph c = clusteredGraph(toCluster);
		if(c instanceof EmbeddedClusteredGraph) {
			EmbeddedClusteredGraph ec = (EmbeddedClusteredGraph)c;
			for(NodeCursor nc = toCluster.nodes(); nc.ok(); nc.next()){
				toCluster.setCenter(nc.node(), ec.getPositionAsPoint(nc.node()));
			}
		}
		return c;
	}
}
