/*
 * Created on Oct 21, 2004
 * Reviewed 1.2 (November 1, 2004)
 *
 * Copyright 2004.  --- All rights reserved. 
 * Algorithmic Group, Karlsruhe, Germany.
 */
package de.uka.algo.clustering.index;

import de.uka.algo.clustering.Clustering;
import de.uka.algo.clustering.index.Index;

/**
 * An IndexFactory is a factory providing indizes for a given clustering, which
 * allows to design clustering algorithms somehow 'generically' taking a factory
 * as parameter and, for instance, optimizing it.
 * 
 * @author Bastian Katz
 */
public interface IndexFactory {

    /**
     * Returns an Index for the given clustering.
     * 
     * @param clustering
     *            the clustering
     * @return an instance of the respective Index
     */
    public abstract Index getIndex(Clustering clustering);
}