/*
 * created May 9, 2006
 *
 * Copyright 2006.  --- All rights reserved. 
 * Algorithmic Group, Karlsruhe, Germany.
 *
 */
package de.uka.algo.clustering.io.modules;

import java.io.File;
import java.util.LinkedList;

import javax.swing.JFileChooser;
import javax.swing.JFrame;

import de.uka.algo.clustering.Clustering;
import de.uka.algo.clustering.io.ClusteringIOHandler;
import de.uka.algo.clustering.visualization.FacadeModule;

public class WriteModule extends FacadeModule {

	private static final int CLUSTERINGS = 3;
	
	public WriteModule() {
		super("Write Clusterings", "Daniel Delling", "", CLUSTERINGS, WEIGHTS_USE, GROUPS_KEEP, true);
	}

	@Override
	protected void core() {
		LinkedList<Clustering> clusterings = new LinkedList<Clustering>();	
		for (int i = 0; i<CLUSTERINGS; i++) {
			Clustering clustering = getChosenClustering(i);
			if (clustering!=null) clusterings.add(clustering);
		}
	    JFileChooser chooser = new JFileChooser();
	    chooser.addChoosableFileFilter(new MyFilter());
	    int returnVal = chooser.showSaveDialog(new JFrame());
	    String fileName = null;
	    if(returnVal == JFileChooser.APPROVE_OPTION) {
	       fileName = chooser.getSelectedFile().getAbsolutePath(); 
	    } else {
	    	return;
	    }
	    if(!fileName.endsWith(".graphml")){
	    	fileName += ".graphml";
	    }
		ClusteringIOHandler io = new ClusteringIOHandler();
		io.write(clusterings, fileName);
	}

	class MyFilter extends javax.swing.filechooser.FileFilter {
        public boolean accept(File file) {
            String filename = file.getName();
    	    if(file.isDirectory()) {
    			return true;
    	    }
            return filename.endsWith(".graphml");
        }
        public String getDescription() {
            return "*.graphml";
        }
    }
}
