/*
 * Created on Aug 21, 2004
 * Reviewed 1.3 (Mar 26, 2005)
 *
 * Copyright 2004.  --- All rights reserved. 
 * Algorithmic Group, Karlsruhe, Germany.
 */
package de.uka.algo.graphs;

import y.base.Edge;

/**
 * Classes implementing GraphInterpretationListener can be notified of
 * changing edge weights in a graph's interpretation.
 * 
 * @author Bastian Katz
 */
public interface GraphInterpretationListener {
	
	/**
	 * This method is called to signal that an edge weight has changed.
	 * 
	 * @param edge the edge
	 * @param oldWeight the previous weight
	 * @param newWeigth the new edge weight
	 */
	public abstract void weightChangeEvent(Edge edge, double oldWeight,
			double newWeigth);
	
	public abstract void newWeightsEvent();
}
