package de.uka.algo.dynclustering.algos;

import java.util.List;

import org.apache.commons.lang.IncompleteArgumentException;

import y.base.Edge;
import y.base.Node;
import y.base.NodeCursor;
import de.uka.algo.clustering.Cluster;
import de.uka.algo.dynclustering.algos.base.AlgorithmFactory;
import de.uka.algo.dynclustering.algos.base.DynamicClusteringAlgorithm;
import de.uka.algo.dynclustering.graphs.DynamicGraph;
import de.uka.algo.dynclustering.util.RunTimer.TimeUnit;

public class OneClustering extends DynamicClusteringAlgorithm {
	
	public static class Factory implements AlgorithmFactory {

		public DynamicClusteringAlgorithm getAlgorithm(DynamicGraph dynGraph) {
			return new OneClustering(dynGraph);
		}

		public void setParams(List<Object> params) throws IncompleteArgumentException {
			// no params
		}
		
	};
	
	protected Cluster oneCluster;
	
	private static final String NAME = "OneClustering";

	public OneClustering(DynamicGraph dynGraph) {
		super(dynGraph);
		// TODO Auto-generated constructor stub
	}

	@Override
	public String toString() {
		return this.id();
	}

	@Override
	protected void addEvent(boolean notificationTime, Cluster to, NodeCursor nc) {
		// TODO Auto-generated method stub

	}

	@Override
	protected void deleteEvent(boolean notificationTime, Cluster deletedCluster) {
		// TODO Auto-generated method stub

	}

	@Override
	protected void edgeCreationEvent(Edge newEdge) {
		// ignored
	}

	@Override
	protected void edgeRemovalEvent(boolean notificationTime, Edge edgeToRemove) {
		// ignored
	}

	@Override
	protected void extractEvent(boolean notificationTime, Cluster from, NodeCursor nc) {
		// ignored

	}

	@Override
	protected void mergeEvent(boolean notificationTime, Cluster a, Cluster b) {
		// ignored

	}

	@Override
	protected void moveEvent(boolean notificationTime, Cluster from, Cluster to, NodeCursor nc) {
		// ignored

	}

	@Override
	protected void newClusterEvent(boolean notificationTime, Cluster newCluster) {
		// ignored

	}

	@Override
	protected void newWeightsEvent() {
		// ignored

	}

	@Override
	protected void nodeCreationEvent(Node newNode) {
		this.timer.start();
		//
		if (this.oneCluster == null) {
			this.oneCluster = this.clustering.newCluster(newNode);
		} else {
			this.clustering.add(this.oneCluster, newNode);
		}
		//
		this.timer.stop();
	}

	@Override
	protected void nodeRemovalEvent(boolean notificationTime, Node nodeToRemove) {
		// do nothing
	}

	@Override
	protected void policyChanged(boolean policy) {
		// ignored

	}

	@Override
	protected void resetEvent(boolean notificationTime) {
		// ignored

	}

	@Override
	protected void resetLargeClusterEvent(boolean notificationTime, Cluster c) {
		// ignored

	}

	@Override
	protected void resetSingletonsEvent(boolean notificationTime) {
		// ignored

	}

	@Override
	protected void splitEvent(boolean notificationTime, Cluster a, Cluster b) {
		// ignored

	}

	@Override
	protected void weightChangedEvent(Edge e, double oldWeight, double newWeight) {
		// ignored
	}

	public void onTimeStepEvent() {
		// do nothing
		
		// DEBUG
		System.out.println(">> " + this.id() + " done after " + this.timer.read(TimeUnit.MilliSeconds) + " [ms]");
		// DEBUG
	}

	@Override
	public String id() {
		return NAME + ":" +  this.uniqueID;
	}


}
