package de.uka.algo.dynclustering.algos;



import y.base.Edge;
import y.base.Node;
import y.base.NodeCursor;
import de.uka.algo.clustering.Cluster;
import de.uka.algo.dynclustering.algos.base.AlgorithmFactory;
import de.uka.algo.dynclustering.algos.base.DynamicClusteringAlgorithm;
import de.uka.algo.dynclustering.graphs.DynamicGraph;
import de.uka.algo.dynclustering.util.RunTimer.TimeUnit;

public class Singleton extends DynamicClusteringAlgorithm {
	
	public static class Factory implements AlgorithmFactory {

		public DynamicClusteringAlgorithm getAlgorithm(DynamicGraph dynGraph) {
			return new Singleton(dynGraph);
		}

	};
	
	private static final String NAME = "Singleton";

	public Singleton(DynamicGraph dynGraph) {
		super(dynGraph);
	}

	@Override
	public String toString() {
		return "Singleton";
	}

	@Override
	protected void addEvent(boolean notificationTime, Cluster to, NodeCursor nc) {
		// ignored

	}

	@Override
	protected void deleteEvent(boolean notificationTime, Cluster deletedCluster) {
		// ignored

	}

	@Override
	protected void edgeCreationEvent(Edge newEdge) {
		// ignored

	}

	@Override
	protected void edgeRemovalEvent(boolean notificationTime, Edge edgeToRemove) {
		// ignored

	}

	@Override
	protected void extractEvent(boolean notificationTime, Cluster from, NodeCursor nc) {
		// ignored

	}

	@Override
	protected void mergeEvent(boolean notificationTime, Cluster a, Cluster b) {
		// ignored

	}

	@Override
	protected void moveEvent(boolean notificationTime, Cluster from, Cluster to, NodeCursor nc) {
		// ignored

	}

	@Override
	protected void newClusterEvent(boolean notificationTime, Cluster newCluster) {
		// ignored

	}

	@Override
	protected void newWeightsEvent() {
		// ignored

	}

	@Override
	protected void nodeCreationEvent(Node newNode) {
		timer.start();
		//
		this.clustering.newCluster(newNode);
		//
		timer.stop();
	}

	@Override
	protected void nodeRemovalEvent(boolean notificationTime, Node nodeToRemove) {
	}

	@Override
	protected void policyChanged(boolean policy) {
		// ignored

	}

	@Override
	protected void resetEvent(boolean notificationTime) {
		// ignored

	}

	@Override
	protected void resetLargeClusterEvent(boolean notificationTime, Cluster c) {
		// ignored

	}

	@Override
	protected void resetSingletonsEvent(boolean notificationTime) {
		// ignored

	}

	@Override
	protected void splitEvent(boolean notificationTime, Cluster a, Cluster b) {
		// ignored

	}

	@Override
	protected void weightChangedEvent(Edge e, double oldWeight, double newWeight) {
		// ignored

	}

	public void onTimeStepEvent() {
		// nothing to do
		
		// DEBUG
		System.out.println(">> " + this.id() + " done after " + this.timer.read(TimeUnit.MilliSeconds) + " [ms]");
		// DEBUG
		
	}

	@Override
	public String id() {
		return NAME + ":" + this.uniqueID;
	}

}
