package de.uka.algo.dynclustering.algos.base;


import de.uka.algo.dynclustering.graphs.DynamicGraph;

/**
 * Abstract factory for DynamicClusteringAlgorithms.
 * The factory can be used when the algorithm and its parameters must be selected
 * but the DynamicGraph is not yet available.
 * @author Christian Staudt
 *
 */
public interface AlgorithmFactory {

	/**
	 * Instantiate the algorithm with the given parameters.
	 * @param dynGraph
	 * @return
	 */
	public DynamicClusteringAlgorithm getAlgorithm(DynamicGraph dynGraph);
	
	
}
