package de.uka.algo.dynclustering.algos.newman;

import java.util.Map;

import y.base.Node;
import y.base.NodeCursor;
import de.uka.algo.clustering.Clustering;
import de.uka.algo.graphs.GraphInterpretation;

public class BacktrackAdapter extends de.uka.algo.clustering.algorithms.newman.internal.UpdateStrategy {
	
	protected DynBacktrackStrategy backtrackStrategy;
	
	public BacktrackAdapter(DynBacktrackStrategy strategy) {
		this.backtrackStrategy = strategy;
	}

	@Override
	public void prepareClustering(Clustering cl, GraphInterpretation oldGraph) {
		// stop listening
		this.backtrackStrategy.listening = false;
		
		cl.resetSingletons();
		
		Map<Node,Node> partitionMap = this.backtrackStrategy.getPartitionMap();
		for (NodeCursor nc = cl.getGraph().nodes(); nc.ok(); nc.next()) {
			Node representative = partitionMap.get(nc.node());
			cl.merge(nc.node(), representative);
		}
		
		// start listening
		this.backtrackStrategy.listening = true;
	}

}
