package de.uka.algo.dynclustering.algos.newman;

import y.base.Edge;
import y.base.Node;
import de.uka.algo.clustering.Cluster;
import de.uka.algo.clustering.Clustering;
import de.uka.algo.dynclustering.update.UpdateStrategy;
import de.uka.algo.graphs.GraphInterpretation;


/**
 * Resets the clusters of all affected nodes to singletons.
 * 
 * @author Christian Staudt
 *
 */
@Deprecated
public class DynStonePitStrategy extends UpdateStrategy {
	
	public void onEdgeCreation(Edge uv) {
		this.resetAffected(uv);
	}

	public void onEdgeRemoval(Edge uv) {
		this.resetAffected(uv);
	}

	public void onNodeCreation(Node v) {
		// TODO Auto-generated method stub

	}

	public void onNodeRemoval(Node v) {
		// TODO Auto-generated method stub

	}

	public void prepareClustering(Clustering cl, GraphInterpretation oldGraph) {
		cl.pool2Singletons();
	}
	
	protected void resetAffected(Edge uv) {
		Cluster cu = this.zeta.getCluster(uv.source());
		Cluster cv = this.zeta.getCluster(uv.target());
		if (cu != null) {
			this.zeta.delete(cu);
		}
		if (cu != cv && cv != null) {
			this.zeta.delete(cv);
		}
	}

	public String id() {
		return "StonePit";
	}

	public void onMerge(Cluster c1, Cluster c2) {
		// TODO Auto-generated method stub
		
	}

	public void onSplit(Cluster a, Cluster b) {
		// TODO Auto-generated method stub
		
	}

	public void onWeightChange(Edge uv, double oldW, double newW) {
		this.resetAffected(uv);
	}

}
