package de.uka.algo.dynclustering.algos.newman;

import y.base.Node;
import de.uka.algo.clustering.Cluster;
import de.uka.algo.clustering.Clustering;
import de.uka.algo.clustering.algorithms.newman.internal.UpdateStrategy;
import de.uka.algo.dynclustering.update.SubsetStrategy;
import de.uka.algo.graphs.GraphInterpretation;

public class FreeingAdapter extends UpdateStrategy {
	
	protected SubsetStrategy subsetStrategy;
	
	public FreeingAdapter(SubsetStrategy subsetStrategy) {
		this.subsetStrategy = subsetStrategy;
	}

	@Override
	/**
	 * Free marked nodes.
	 * 
	 */
	public void prepareClustering(Clustering cl, GraphInterpretation oldGraph) {
		for (Node u : this.subsetStrategy.getMarkedNodes()) {
			Cluster C = cl.getCluster(u);
			if (C != null) {
				cl.extract(C, u);
			}
		}
		cl.pool2Singletons();
	}

}
