package de.uka.algo.dynclustering.algos.newman;

import y.base.Node;
import y.base.NodeCursor;
import de.uka.algo.clustering.Clustering;
import de.uka.algo.dynclustering.util.unionfind.UnionFind;

public class UFClusteringConverter {
	
	/**
	 * Resets the clustering according to the union find data structure.
	 * @param zeta
	 * @param unionFind
	 */
	public static void convert(Clustering zeta, UnionFind<Node> unionFind) {
		zeta.resetSingletons();
		// iterate over nodes and merge node with its representative
		for (NodeCursor nc = zeta.getGraph().nodes(); nc.ok(); nc.next()) {
			Node u = nc.node();
			Node v = unionFind.find(u);
			zeta.merge(u, v);
		}
	}

}
