package de.uka.algo.dynclustering.base;

import y.base.Edge;
import y.base.Node;
import de.uka.algo.clustering.Cluster;
import de.uka.algo.clustering.Clustering;
import de.uka.algo.graphs.GraphInterpretation;

/**
 * An interface for classes which are not graph listeners but need to react to
 * changes in the graph.
 * 
 * @author Christian Staudt
 *
 */
public interface GraphEventHandler {

	public abstract void onEdgeCreation(Edge uv);

	public abstract void onEdgeRemoval(Edge uv);

	public abstract void onNodeCreation(Node v);

	public abstract void onNodeRemoval(Node v);

	public abstract void onWeightChange(Edge uv, double oldW, double newW);

}