package de.uka.algo.dynclustering.eval;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.HashMap;

import de.uka.algo.generator.standalone.graph.journaling.ClusteringJournal;
import de.uka.algo.generator.standalone.graph.journaling.ClusteringOperation;

/**
 * Takes a clustering journal and extracts useful information.
 * 
 * @author Christian Staudt
 *
 */
public class ClusteringHistory implements Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1091827294492197751L;
	
	private ClusteringJournal cJournal;
	
	public ClusteringHistory(ClusteringJournal cJournal) {
		this.cJournal = cJournal;
	}
	
	
	
	public ArrayList<Integer> listCurrentMergeCount() {
		int mergeCount = 0;
		ArrayList<Integer> list = new ArrayList<Integer>();
		for (ClusteringOperation op : this.cJournal) {
			switch (op.type) {
			case NextStep:
				list.add(mergeCount);
				break;
			case Merge:
				mergeCount++;
				break;
			case MergeDone:
				mergeCount--;
				break;
			}
		}
		return list;
	}
	
	public ArrayList<Integer> listCurrentSplitCount() {
		int splitCount = 0;
		ArrayList<Integer> list = new ArrayList<Integer>();
		for (ClusteringOperation op : this.cJournal) {
			switch (op.type) {
			case NextStep:
				list.add(splitCount);
				break;
			case Split:
				splitCount++;
				break;
			case SplitDone:
				splitCount--;
				break;
			}
		}
		return list;
	}

}
