package de.uka.algo.dynclustering.eval;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;


public class Serializer {
	
	public void serializeResults(Results results, String path) {
		FileOutputStream fos = null;
		ObjectOutputStream oos = null;

		try {
			fos = new FileOutputStream(path);
			oos = new ObjectOutputStream(fos);
			
			oos.writeObject(results);
			oos.close();
			
			// DEBUG
			System.out.println(">> results serialized to " + path);
			// DEBUG
			
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public Results deserializeResults(String path) {
		
		FileInputStream fis = null;
		ObjectInputStream ois = null;
		Results results = null;
		
		try {
			fis = new FileInputStream(path);
			ois = new ObjectInputStream(fis);
			
			results = (Results) ois.readObject();
			
			// DEBUG
			System.out.println(">> results deserialized from " + path);
			// DEBUG
			
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} finally {
			// remove file?
		}
		

		return results;
	}
	
	
	
	public void serializeArgs(FakeEvaluationFrontend fakeFrontend, String path) {
		
		// DEBUG
		printCurrentDir();
		// DEBUG
		
		FileOutputStream fos = null;
		ObjectOutputStream oos = null;

		try {
			fos = new FileOutputStream(path);
			oos = new ObjectOutputStream(fos);
			
			oos.writeObject(fakeFrontend);
			oos.close();
			
			// DEBUG
			System.out.println(">> args serialized to " + path);
			// DEBUG
			
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public FakeEvaluationFrontend deserializeArgs(String path) {
		FileInputStream fis = null;
		ObjectInputStream ois = null;
		FakeEvaluationFrontend fakeFrontend = null;
		
		try {
			fis = new FileInputStream(path);
			ois = new ObjectInputStream(fis);
			
			fakeFrontend = (FakeEvaluationFrontend) ois.readObject();
			
			// DEBUG
			System.out.println(">> args deserialized from " + path);
			// DEBUG
			
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} finally {
			// remove file?
		}
		

		return fakeFrontend;
	}
	
	
	private void printCurrentDir() {
	     File dir1 = new File (".");
	     File dir2 = new File ("..");
	     try {
	       System.out.println ("Current dir : " + dir1.getCanonicalPath());
	       System.out.println ("Parent  dir : " + dir2.getCanonicalPath());
	       }
	     catch(Exception e) {
	       e.printStackTrace();
	       }
		
	}

}
