package de.uka.algo.dynclustering.eval;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

public class StartEvaluation {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		
		String argPath = args[0]; // path to the serialized arguments
		String resultPath = args[1]; // path to serialize the results to
		
		Serializer serializer = new Serializer();
		
		// deserialize the arguments
		FakeEvaluationFrontend fakeFrontend = serializer.deserializeArgs(argPath);
		
		EvaluationFrontend2 evalFrontend = new EvaluationFrontend2();
		
		for (HashMap<String, ArrayList<Object>> argStore : fakeFrontend.algoStoreList) {
			StartEvaluation.transferAlgoArgs(argStore, evalFrontend);
		}
		StartEvaluation.transferEvalArg(fakeFrontend.evalStore, evalFrontend);
		
		evalFrontend.run();
		// get evaluation
		Evaluation2 eval = evalFrontend.getEvaluation();

		
		Results results = eval.getResults();
		// serialize the results
		serializer.serializeResults(results, resultPath);
		
	}
	
	/**
	 * Transfer the deserialized arguments to the real evaluation frontend.
	 * @param argStore
	 * @param evalFrontend
	 */
	public static void transferAlgoArgs(HashMap<String, ArrayList<Object>> argStore, EvaluationFrontend2 evalFrontend) {
		
		ArrayList<Object> list = null;

		
		// algos
		
		list = argStore.get("Randomly");
		evalFrontend.useRandomly((Boolean) list.get(0));
		
		list = argStore.get("OneClustering");
		evalFrontend.useOneClustering((Boolean) list.get(0));
		
		list = argStore.get("Singleton");
		evalFrontend.useSingleton((Boolean) list.get(0));
		
		list = argStore.get("StaticNewman");
		evalFrontend.useStaticNewman((Boolean) list.get(0));
		
		list = argStore.get("StaticNewman2");
		evalFrontend.useStaticNewman2((Boolean) list.get(0));
		
		list  = argStore.get("StaticBlondel");
		evalFrontend.useStaticBlondel((Boolean) list.get(0), (Integer) list.get(1), (Integer) list.get(2)); 
		
		list  = argStore.get("TDStaticBlondel");
		evalFrontend.useTDStaticBlondel((Boolean) list.get(0), (Integer) list.get(1), (Integer) list.get(2), (Double) list.get(3)); 
		
		list = argStore.get("Blondel");
		evalFrontend.useBlondel((Boolean) list.get(0), (Integer) list.get(1), (Integer) list.get(2), (Integer) list.get(3), (Integer) list.get(4), (Integer) list.get(5), (Integer) list.get(6), (Integer) list.get(7), (Double) list.get(8), (Double) list.get(8));

		list = argStore.get("Newman");
		evalFrontend.useNewman((Boolean) list.get(0), (Integer) list.get(1), (Integer) list.get(2), (Integer) list.get(3), (Integer) list.get(4), (Double) list.get(5), (Double) list.get(6));
		
		list = argStore.get("Newman2");
		evalFrontend.useNewman2((Boolean) list.get(0), (Integer) list.get(1), (Integer) list.get(2), (Integer) list.get(3), (Integer) list.get(4), (Double) list.get(5), (Double) list.get(6));
		
		list = argStore.get("PartialILP");
		evalFrontend.usePartialILP((Boolean) list.get(0), (Integer) list.get(1), (Integer) list.get(2), (Integer) list.get(3), (Integer) list.get(4), (Integer) list.get(5), (Integer) list.get(6), (Integer) list.get(7), (Double) list.get(8), (Double) list.get(9));
	
		list = argStore.get("EOO");
		evalFrontend.useEOO((Boolean) list.get(0), (Integer) list.get(1), (Integer) list.get(2), (Integer) list.get(3), (Boolean) list.get(4), (Boolean) list.get(5), (Boolean) list.get(6));
		
		list = argStore.get("Reference");
		evalFrontend.useReference((Boolean) list.get(0));
		

		
	
	}
	
	
	public static void transferEvalArg(HashMap<String, ArrayList<Object>> argStore, EvaluationFrontend2 evalFrontend) {
		ArrayList<Object> list = null;
		
		
		list = argStore.get("Graph");
		evalFrontend.setGraph((String) list.get(0));
		
		list = argStore.get("TimeStepAggregation");
		evalFrontend.timeStepAggregation = (Integer) list.get(0);
		
		// quality
		
		list = argStore.get("Coverage");
		evalFrontend.useCoverage((Boolean) list.get(0));
		
		list = argStore.get("Modularity");
		evalFrontend.useModularity((Boolean) list.get(0));
		
		list = argStore.get("SignificanceCoverage");
		evalFrontend.useSignificanceCoverage((Boolean) list.get(0));
		
		list = argStore.get("Performance");
		evalFrontend.usePerformance((Boolean) list.get(0));
		
		list = argStore.get("SignificancePerformance");
		evalFrontend.useSignificancePerformance((Boolean) list.get(0));
		
		list = argStore.get("InterClusterConductance");
		evalFrontend.useInterClusterConductance((Boolean) list.get(0));
		
		list = argStore.get("IntraClusterConductance");
		evalFrontend.useIntraClusterConductance((Boolean) list.get(0));
		
		// distance
		
		list = argStore.get("Rand");
		evalFrontend.useRand((Boolean) list.get(0), (Boolean) list.get(1));
		
		list = argStore.get("FredJain");
		evalFrontend.useFredJain((Boolean) list.get(0), (Boolean) list.get(1));
		
		list = argStore.get("Jaccard");
		evalFrontend.useJaccard((Boolean) list.get(0), (Boolean) list.get(1));
		
		list = argStore.get("FowlkesMallows");
		evalFrontend.useFowlkesMallows((Boolean) list.get(0), (Boolean) list.get(1));
		
		list = argStore.get("MaximumMatch");
		evalFrontend.useMaximumMatch((Boolean) list.get(0), (Boolean) list.get(1));
	}
}
