package de.uka.algo.dynclustering.input;

import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.ArrayList;

import de.uka.algo.generator.standalone.graph.journaling.ClusteringJournal;


public class ClusteringJournalFileImporter {

	public static ClusteringJournal importFile(String filePath) {
		
		
		try {
			File file = new File(filePath);
			FileInputStream fStream = new FileInputStream(file);
			DataInputStream dStream = new DataInputStream(fStream);
			
			int graphOpLength = dStream.readInt();
			int graphArgLength = dStream.readInt();
			
			// skip bytes
			dStream.skip(graphOpLength + 4 * graphArgLength);
			
			int opLength = dStream.readInt();
			int intArgLength = dStream.readInt();
			int doubleArgLength = dStream.readInt();
			
			ArrayList<Byte> ops = new ArrayList<Byte>();
			ArrayList<Integer> intArgs = new ArrayList<Integer>();
			ArrayList<Double> doubleArgs = new ArrayList<Double>();
			
			for (int i = 0; i < opLength; ++i) {
				ops.add(dStream.readByte());
			}
			
			for (int i = 0; i < intArgLength; ++i) {
				intArgs.add(dStream.readInt());
			}
			
			for (int i = 0; i < doubleArgLength; ++i) {
				doubleArgs.add(dStream.readDouble());
			}
			
			ClusteringJournal cJournal = new ClusteringJournal();
			cJournal.opCodes = ops;
			cJournal.intArgs = intArgs;
			cJournal.doubleArgs = doubleArgs;
			
			return cJournal;
			
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}

		return null;
	}
	
}
