package de.uka.algo.dynclustering.input;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.HashMap;

import de.uka.algo.dynclustering.graphs.DynamicGraph;
import de.uka.algo.dynclustering.graphs.EmailGraph;

public class EmailFileImporter implements GraphImporter {
	
	private int timeStepAggregation;
	
	public EmailFileImporter(int timeStepAggregation) {
		this.timeStepAggregation = timeStepAggregation;
	}

	public DynamicGraph importFile(String filePath) {
		
		try {
			File file = new File(filePath);
			FileInputStream fStream = new FileInputStream(file);
			BufferedReader reader = new BufferedReader(new InputStreamReader(fStream));
			
			return new EmailGraph(reader, this.timeStepAggregation);
			
		} catch (IOException ex) {
			ex.printStackTrace();
		}
		
		
		return null;
	}

}
