package de.uka.algo.dynclustering.input;

import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.ArrayList;



import de.uka.algo.dynclustering.graphs.DynamicGraph;
import de.uka.algo.dynclustering.graphs.GeneratedGraph;
import de.uka.algo.generator.standalone.graph.journaling.GraphJournal;

public class GraphJournalFileImporter implements GraphImporter {

	public DynamicGraph importFile(String filePath) {

		try {
			File file = new File(filePath);
			FileInputStream fStream = new FileInputStream(file);
			DataInputStream dStream = new DataInputStream(fStream);
			
			int opLength = dStream.readInt();
			int argLength = dStream.readInt();
			
			ArrayList<Byte> ops = new ArrayList<Byte>();
			ArrayList<Integer> args = new ArrayList<Integer>();
			
			for (int i = 0; i < opLength; ++i) {
				ops.add(dStream.readByte());
			}
			
			for (int i = 0; i < argLength; ++i) {
				args.add(dStream.readInt());
			}
			
			GraphJournal journal = new GraphJournal();
			journal.opCodes = ops;
			journal.arguments = args;
			
			return new GeneratedGraph(journal);
			
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}

		return null;
	}

}
