package de.uka.algo.dynclustering.test;

import java.util.ArrayList;

import de.uka.algo.dynclustering.eval.ClusteringHistory;
import de.uka.algo.dynclustering.eval.Evaluation;
import de.uka.algo.dynclustering.eval.EvaluationFrontend;
import de.uka.algo.dynclustering.eval.Results;
import de.uka.algo.dynclustering.util.Round;

public class FrontendTest {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		EvaluationFrontend evalFrontend = new EvaluationFrontend();
		evalFrontend.useStaticNewman(false);
		evalFrontend.useRandomly(false);
		evalFrontend.useReference(false);
		evalFrontend.useSingleton(false);
		evalFrontend.useOneClustering(false);
		evalFrontend.usePartialILP(false, 2, 1, 1, 1, 0, 5, 0, 0, 0);
		evalFrontend.useStaticBlondel(true, 1, 1);
		
		evalFrontend.useNewman(false, 4, 1, 0, 10, 1, 1);
		evalFrontend.useNewman2(false, 4, 1, 0, 10, 1, 1);

		evalFrontend.useBlondel(false, 1, 1, 1, 3, 1, 10, 0, 0, 0);
		evalFrontend.useEOO(false, 1, 1, 10, true, true, true);
		
		evalFrontend.useModularity(true);
		evalFrontend.useCoverage(true);
		
		evalFrontend.useMaximumMatch(false, false);
		evalFrontend.useFredJain(true, true);
		
		evalFrontend.setGraph("input/conservative/G_t1000_n100_k10.graphj");
		
		
		Results results = evalFrontend.run();
		Evaluation eval = evalFrontend.getEvaluation();
		ClusteringHistory cHistory = eval.getClusteringHistory();
		System.out.println("merge count: "  + cHistory.listCurrentMergeCount());
		System.out.println("split count: "  + cHistory.listCurrentSplitCount());

		for (String name : eval.getAlgoNames()) {
			ArrayList<Double> runtimes = results.listMeasure(name, "Runtime");
			double sum = 0.0;
			for (double r : runtimes) {
				sum += r;
			}
			System.out.println("Runtime for " + name + ": " + Round.round(sum,2) + " ms");
			
			System.out.println(results.listMeasure(name, "Modularity"));
			System.out.println(results.listMeasure(name, "Coverage"));

		}
		
		
	}

}
