package de.uka.algo.dynclustering.test;

import java.util.ArrayList;

import de.uka.algo.dynclustering.eval.ClusteringHistory;
import de.uka.algo.dynclustering.eval.Evaluation;
import de.uka.algo.dynclustering.eval.EvaluationFrontend;
import de.uka.algo.dynclustering.eval.FakeEvaluationFrontend;
import de.uka.algo.dynclustering.eval.Results;
import de.uka.algo.dynclustering.eval.Serializer;
import de.uka.algo.dynclustering.eval.StartEvaluation;
import de.uka.algo.dynclustering.util.Round;

public class FrontendTest2 {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		FakeEvaluationFrontend fakeFrontend = new FakeEvaluationFrontend();

		fakeFrontend.useStaticNewman(false);
		fakeFrontend.useStaticNewman2(false);
		fakeFrontend.useRandomly(false);
		fakeFrontend.useReference(false);
		fakeFrontend.useSingleton(false);
		fakeFrontend.useOneClustering(false);
		fakeFrontend.usePartialILP(false, 2, 1, 1, 1, 0, 5, 0, 0, 0);
		fakeFrontend.useStaticBlondel(false, 1, 1);
		fakeFrontend.useNewman(false, 4, 1, 0, 10, 1, 1);
		fakeFrontend.useNewman2(false, 4, 1, 0, 10, 1, 1);
		fakeFrontend.useBlondel(false, 1, 1, 1, 3, 1, 10, 0, 0, 0);
		fakeFrontend.useEOO(false, 1, 1, 10, true, true, true);
		fakeFrontend.useTDStaticBlondel(true, 1, 1, 0.5);

	
		
		fakeFrontend.nextTurn();
		
		fakeFrontend.useStaticNewman(false);
		fakeFrontend.useStaticNewman2(false);
		fakeFrontend.useRandomly(false);
		fakeFrontend.useReference(false);
		fakeFrontend.useSingleton(false);
		fakeFrontend.useOneClustering(false);
		fakeFrontend.usePartialILP(false, 2, 1, 1, 1, 0, 5, 0, 0, 0);
		fakeFrontend.useStaticBlondel(true, 1, 1);
		fakeFrontend.useNewman(false, 4, 1, 0, 10, 1, 1);
		fakeFrontend.useNewman2(false, 4, 1, 0, 10, 1, 1);
		fakeFrontend.useBlondel(false, 1, 1, 1, 3, 1, 10, 0, 0, 0);
		fakeFrontend.useEOO(false, 1, 1, 10, true, true, true);
		fakeFrontend.useTDStaticBlondel(false, 1, 1, 0.5);
		
		fakeFrontend.nextTurn();
		
		// eval
		
		fakeFrontend.useModularity(true);
		fakeFrontend.useCoverage(true);
		fakeFrontend.usePerformance(true);
		fakeFrontend.useSignificanceCoverage(false);
		fakeFrontend.useSignificancePerformance(false);
		fakeFrontend.useInterClusterConductance(false);
		fakeFrontend.useIntraClusterConductance(false);
		
		fakeFrontend.useRand(false, false);
		fakeFrontend.useJaccard(false, false);
		fakeFrontend.useMaximumMatch(false, false);
		fakeFrontend.useFredJain(true, true);
		fakeFrontend.useFowlkesMallows(false, false);
		
		fakeFrontend.setGraph("/algoDaten/dynClustGraphs/FromRepository/input/mini/G_t100_n10_k2_eta10.graphj");
		fakeFrontend.setTimeStepAggregation(100);

		
		Serializer serializer = new Serializer();
		serializer.serializeArgs(fakeFrontend, "tmp/args.ser");
		
		String[] startArgs = {"tmp/args.ser", "tmp/results.ser"};
		StartEvaluation.main(startArgs);
		
//		for (String name : eval.getAlgoNames()) {
//			ArrayList<Double> runtimes = results.listMeasure(name, "Runtime");
//			double sum = 0.0;
//			for (double r : runtimes) {
//				sum += r;
//			}
//			System.out.println("Runtime for " + name + ": " + Round.round(sum,2) + " ms");
//			
//			System.out.println(results.listMeasure(name, "Modularity"));
//			System.out.println(results.listMeasure(name, "Coverage"));
//
//		}
		
		
	}

}
