package de.uka.algo.dynclustering.update;


import de.uka.algo.clustering.Clustering;
import de.uka.algo.dynclustering.algos.base.DynamicClusteringAlgorithm;
import de.uka.algo.dynclustering.base.ClusterEventHandler;
import de.uka.algo.dynclustering.base.GraphEventHandler;
import de.uka.algo.dynclustering.graphs.DynamicGraph;

public abstract class UpdateStrategy implements GraphEventHandler, ClusterEventHandler {
	
	protected DynamicClusteringAlgorithm algo;
	protected DynamicGraph dynGraph;
	protected Clustering zeta;
	public boolean listening;

	/***
	 * Must be called before usage in a DynamicClusteringAlgorithm.
	 * @param algo
	 */
	public void initialize(DynamicClusteringAlgorithm algo) {
		this.algo = algo;
		this.dynGraph = algo.getGraph();
		this.zeta = algo.getClustering();
		this.listening = true;
	}

	public abstract String id();

	public String toString() {
		return this.id();
	}
	


}
