package de.uka.algo.dynclustering.util;

import java.util.ArrayList;

public class ArgUtility {
	
	public enum DataType {SINGLE, LIST}
	public enum Multiplicity {One, ZeroOne, ZeroN, OneN};
	
	String optPrefix;
	String kvSeparator;
	String listPrefix;
	String listSeparator;
	String listSuffix;
	
	String[] args;
	
	

	
	
	public String getOptPrefix() {
		return optPrefix;
	}

	public void setOptPrefix(String optPrefix) {
		this.optPrefix = optPrefix;
	}

	public String getKvSeparator() {
		return kvSeparator;
	}

	public void setKvSeparator(String kvSeparator) {
		this.kvSeparator = kvSeparator;
	}

	public String getListPrefix() {
		return listPrefix;
	}

	public void setListPrefix(String listPrefix) {
		this.listPrefix = listPrefix;
	}

	public String getListSeparator() {
		return listSeparator;
	}

	public void setListSeparator(String listSeparator) {
		this.listSeparator = listSeparator;
	}

	public String getListSuffix() {
		return listSuffix;
	}

	public void setListSuffix(String listSuffix) {
		this.listSuffix = listSuffix;
	}

	public String[] getArgs() {
		return args;
	}

	public void setArgs(String[] args) {
		this.args = args;
	}

	public void addFlag(String key) {
		
	}
	
	public void addKeyValue(String key, String separator, DataType type) {
		
	}
	
	public Boolean hasFlag(String key) {
		if (this.searchArgs(key) != null) {
			return true;
		} else return false;
	}
	
	public Integer getInteger(String key) {
		String kv = this.searchArgs(key);
		
		if (kv == null) {
			return null;
		} else {
			String value = kv.split(this.kvSeparator)[1];
			return Integer.parseInt(value);
		}
	}
	
	public Long getLong(String key) {
		String value = this.searchArgs(key);
		return Long.parseLong(value);
	}
	
	public Float getFloat(String key) {
		String value = this.searchArgs(key);
		return Float.parseFloat(value);
	}
	
	public Double getDouble(String key) {
		String value = this.searchArgs(key);
		return Double.parseDouble(value);
	}
	
	public String getString(String key) {
		String s = this.searchArgs(key);
		String[] kv = s.split(this.kvSeparator);
		String value = kv[1];
		return value;
	}
	
	public ArrayList<Integer> getIntegerList(String key) {
		String s = this.searchArgs(key);
		String[] elements = this.parseList(s);
		ArrayList<Integer> result = new ArrayList<Integer>();
		for (String e : elements) {
			result.add(Integer.parseInt(e));
		}
		return result;
	}
	
	public ArrayList<Double> getDoubleList(String key) {
		String s = this.searchArgs(key);
		String[] elements = this.parseList(s);
		ArrayList<Double> result = new ArrayList<Double>();
		for (String e : elements) {
			result.add(Double.parseDouble(e));
		}
		return result;
	}
	
	public ArrayList<String> getStringList(String key) {
		String s = this.searchArgs(key);
		String[] kv = s.split(this.kvSeparator);
		String[] elements = this.parseList(kv[1]);
		ArrayList<String> result = new ArrayList<String>();
		for (String e : elements) {
			result.add(e);
		}
		return result;
	}
	
	
	private String[] parseList(String s) {
		s = s.substring(1, s.length()-1); // strip list prefix/suffix
		String[] elements = s.split(this.listSeparator);
		return elements;
	}
	
	/**
	 * Return argument beginning with optPrefix and	
	 * @param key	the option key
	 * @return	argument
	 */
	private String searchArgs(String key) {
		String prefix = this.optPrefix + key;
		for (String s : this.args) {
			if (s.startsWith(prefix)) {
				return s;
			}
		}
		return null;
	}

}
