package de.uka.algo.dynclustering.util;

import java.util.ArrayList;
import java.util.HashMap;

import de.uka.algo.math.linalg.generic.Matrix;
import de.uka.algo.math.linalg.generic.MatrixAdapter;


/**
 * A square matrix of doubles implemented with nested HashMaps
 * @author Christian Staudt
 *
 */
public class HashSquareMatrix extends MatrixAdapter {
	
	private HashMap<Integer,HashMap<Integer,Double>> map = new HashMap<Integer,HashMap<Integer,Double>>();
	private int last = -1; // index of the last row/column
	

	public int extend() {
		this.last += 1;
		return this.last;
	}

	public void set(int row, int column, double value) {
		if (! this.map.containsKey(row)) {
			this.map.put(row, new HashMap<Integer,Double>());
		}
		this.map.get(row).put(column, value);
	}
	
	@Override
	public double get(int row, int column) throws IndexOutOfBoundsException {
		if (this.map.containsKey(row) && this.map.get(row).containsKey(column)) {
			return this.map.get(row).get(column);
		} else return 0.0;
	}

	@Override
	public Matrix getFastMatrix() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public int rows() {
		return this.last + 1 ;
	}
	
	@Override
	public int columns() {
		return this.last + 1;
	}
	

}
