package de.uka.algo.traversal;

import y.base.Node;

public interface GraphTraversal {
	
	/**
	 * Check whether the traversal can continue.
	 * @return
	 */
	public boolean ok();
	
	/**
	 * Continue traversal to the next node.
	 */
	public void next();
	
	/**
	 * @return		the current node
	 */
	public Node node();
	
	/**
	 * 
	 * @return 	the number of nodes visited
	 */
	public int count();
	
	
	/**
	 * 
	 * @return	the current distance from the source nodes
	 */
	public int distance();
	
	public void reset();

	
	
}
