package de.uka.algo.traversal;


import y.base.Edge;
import y.base.Node;


/**
 * This abstract class describes common internal operations
 * for graph traversal algorithms ( @see TraversalPriority )
 * @author Christian Staudt
 *
 */
public abstract class GraphTraversalImplementation implements GraphTraversal {
	
	
	protected abstract void jumpTo(Node u);
	
	protected abstract void traverse(Edge uv);
	
	protected abstract void enqueue(Node u);
	
	protected abstract Node dequeue();
	
	protected abstract void expand(Node u);
	



}
