package de.uka.algo.traversal.implementations;

import java.util.Set;

import de.uka.algo.traversal.MultiSourceTraversal;
import de.uka.algo.traversal.PriorityTraversal;
import de.uka.algo.traversal.priorities.TraversalPriority;

import y.base.Node;

public class MultiSourcePrioritySearch extends PriorityTraversal implements MultiSourceTraversal {

	public MultiSourcePrioritySearch(TraversalPriority priority) {
		super(priority);
	}

	public void from(Set<Node> S) {
		this.reset();
		for (Node s : S) {
			this.jumpTo(s);
		}
	}
	
	public String toString() {
		return "MSPS(" + this.priority + ")";
	}


}
