package de.uka.algo.traversal.priorities;


import y.base.Edge;
import y.base.Node;

/**
 * Compares nodes according to their degree.
 * @author Christian Staudt
 *
 */
public class DegreePriority implements TraversalPriority {
	
	double degW; // weighting factor
	
	
	public DegreePriority(double degW) {
		this.degW = degW;
	}

	public int compare(Node u, Node v) {
		double uVal = u.degree() * this.degW;
		double vVal = v.degree() * this.degW;
			
		if (uVal < vVal) {
			return -1;
		} else if (uVal == vVal) {
			return 0;
		} else {
			return 1;
		}
	}

	public void onDequeue(Node u) {
		// TODO Auto-generated method stub
		
	}

	public void onEnqueue(Node u) {
		// TODO Auto-generated method stub
		
	}

	public void onExpand(Node u) {
		// TODO Auto-generated method stub
		
	}

	public void onReset() {
		// TODO Auto-generated method stub
		
	}


	public void onJumpTo(Node u) {
		// TODO Auto-generated method stub
		
	}

	public void onTraverse(Edge uv) {
		// TODO Auto-generated method stub
		
	}
	
	public String toString() {
		return "Degree";
	}
	
	

}
