package de.uka.algo.traversal.priorities;




import de.uka.algo.dynclustering.eval.GlobalVars;
import y.base.Graph;


/**
 * Weights distance and degree so that smaller distance is always 
 * preferred, but lower degreee is preferred among nodes with equal distance.
 * @author Christian Staudt
 *
 */
public class DistanceBeforeDegreePriority extends DistanceDegreePriority {
	
	Graph graph;
	
	public DistanceBeforeDegreePriority() {
		/**
		 * The trick is to weight the distance with n
		 */
		super(GlobalVars.n, 1);
	}
	
	public void onReset() {
		// update distanceWeight
		this.distW = GlobalVars.n;
	}
	
	public String toString() {
		return "DistanceBeforeDegree";
	}
	
}