package de.uka.algo.traversal.priorities;

import y.base.Edge;
import y.base.Node;

import java.util.HashMap;
import java.util.Map;


/**
 * StackPriority makes a priority queue behave like a stack (LIFO).
 * @author Christian Staudt
 *
 */
public class StackPriority implements TraversalPriority {
	//TODO: test
	
	int queueSize; // current size of the queue
	Map<Node,Integer> priorityMap;
	
	public StackPriority() {
		this.queueSize = 0;
		this.priorityMap = new HashMap<Node,Integer>();
	}

	public void onDequeue(Node u) {
		this.queueSize--;
		this.priorityMap.remove(u);
	}

	public void onEnqueue(Node u) {
		this.queueSize++;
		this.priorityMap.put(u, -1 * this.queueSize);
	}

	public void onExpand(Node u) {
		// TODO Auto-generated method stub

	}

	public void onJumpTo(Node u) {
		// TODO Auto-generated method stub

	}

	public void onReset() {
		this.queueSize = 0;
		this.priorityMap.clear();
	}

	public void onTraverse(Edge uv) {
		// TODO Auto-generated method stub

	}
 
	public int compare(Node u, Node v) {
		Integer uPriority = this.priorityMap.get(u);
		Integer vPriority = this.priorityMap.get(v);
		if (uPriority <= vPriority) {
			return -1;
		} else if (uPriority == vPriority) {
			return 0;
		} else {
			return 1;
		}
	}

}
