package de.uka.algo.traversal.test;

import java.util.HashSet;
import java.util.Set;

import y.base.Node;
import y.base.NodeCursor;

import de.uka.algo.dynclustering.graphs.DynamicGraph;
import de.uka.algo.dynclustering.input.GraphJournalFileImporter;
import de.uka.algo.traversal.SingleSourceTraversal;
import de.uka.algo.traversal.Unweighted;
import de.uka.algo.traversal.implementations.BreadthFirstSearch;
import de.uka.algo.traversal.implementations.MultiSourceBFS;
import de.uka.algo.traversal.implementations.MultiSourcePrioritySearch;
import de.uka.algo.traversal.priorities.DistanceDegreePriority;
import de.uka.algo.traversal.priorities.StackPriority;
import de.uka.algo.traversal.priorities.TargetDistancePriority;
import de.uka.algo.traversal.priorities.TraversalPriority;

public class TraversalTest {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		
		DynamicGraph dynGraph = new GraphJournalFileImporter().importFile("/Users/cls/workspace/dynamicClustering/input/G_n60_t400_k3.graphj");
		while (dynGraph.hasNextChange()) {
			dynGraph.nextChange();
		}

//		NodeCursor c = dynGraph.nodes();
//		c.toLast();
////		Node target = c.node();
		
//		TraversalPriority tp = new TargetDistancePriority(target, new Unweighted());

		MultiSourceBFS search = new MultiSourceBFS();
		
		/// single source
		
		
		// multi source
		Set<Node> S = new HashSet<Node>();
		int i=0;
		for (NodeCursor nc = dynGraph.nodes(); nc.ok() && i < 2; nc.next()) {
			S.add(nc.node());
			++i;
		}
		System.out.println(S);
		
		int j = 0;
		Node aNode = dynGraph.nodes().node();
		HashSet<Node> returned = new HashSet<Node>();
		
		for (search.from(S); search.ok() && (search.distance() <= 8); search.next()) {
			++j;
			assert ! returned.contains(search.node());
			System.out.println(search.distance() + ":" + search.node());
		}
		
		
	}

}
