/*
 * created Oct 17, 2006
 *
 * Copyright 2006.  --- All rights reserved. 
 * Algorithmic Group, Karlsruhe, Germany.
 *
 */
package de.uka.algo.clustering.algorithms;

import de.uka.algo.clustering.index.IndexFactory;

/**
 * minimizes a clustering locally by moving single nodes from one cluster to
 * another, isolating single nodes or merging two clusters
 * 
 * @author Daniel Delling
 */


public class ElementalOperationMinimizer extends ElementalOperationOptimizer {

	/**
	 * minimiziing a given clustering
	 * @param quality quality indices
	 * @param shift allow shifts
	 * @param merge allow merges
	 * @param split allow splits (normally you should not allow splits)
	 * @param maximalOperations (number of maximal operations)
	 */
	public ElementalOperationMinimizer(IndexFactory quality, boolean shift, boolean merge,
			boolean split, int maximalOperations) {
		super(quality, shift, merge, split);
		maximumMovements = maximalOperations;
		startOptValue = 10.0;
	}

	public ElementalOperationMinimizer(IndexFactory quality) {
		super(quality);
	}

	@Override
	boolean accept(double a, double b) {
		return a<b;
	}

	@Override
	boolean better(double a, double b) {
		return a<b;
	}
	

}
