/*
 * Created on Jan 8, 2005
 * Reviewed 1.2 (Jan 9, 2005)
 *
 * Copyright 2004.  --- All rights reserved. 
 * Algorithmic Group, Karlsruhe, Germany.
 */
package de.uka.algo.clustering.algorithms;

import de.uka.algo.clustering.Clustering;

/**
 * The SingletonClusterer implements the clustering algorithm resetting the
 * clustering to the trivial clustering with a cluster for each node before
 * calling the core.
 * 
 * @author Bastian Katz
 */
public final class Singletons implements Algorithm {

    /** 
     * Resets the clustering such that every node forms a singleton cluster.
     * 
     * @param aClustering the clustering to reset
     */
    public void run(Clustering aClustering) {
        aClustering.resetSingletons();
    }
}
