/**
 * Created on 12.11.2007
 */
package de.uka.algo.clustering.algorithms.betweenness.edgechoosing;

import y.base.EdgeList;
import y.base.EdgeMap;
import y.base.Graph;
import de.uka.algo.clustering.Clustering;

/**
 * Strategy to choose the edges that should be removed
 * during the betweenness clustering
 * 
 * @author Ulrich Geilmann
 */
public interface EdgeChooser {
	/**
	 * Hide edges from a graph
	 * @param graph
	 * 	The graph
	 * @param map
	 * 	The centralities of the edges
	 * @param clustering
	 * 	The actual clustering
	 * @return
	 * 	a list of edges that were hidden
	 */
	public abstract EdgeList chooseEdge (Graph graph, EdgeMap map, Clustering clustering);
}
