/**
 * Created on 19.11.2007
 */
package de.uka.algo.clustering.algorithms.betweenness.edgechoosing;

import java.util.Comparator;

import y.base.Edge;
import y.base.EdgeMap;

/**
 * Compare edges by the double values in a given EdgeMap
 * @author Ulrich Geilmann
 *
 */
public class EdgeComparator implements Comparator<Edge> {

	/**
	 * @param map
	 * 	EdgeMap storing the double-values that will be compared
	 */
	public EdgeComparator (EdgeMap map) {
		vals = map;
	}
	private EdgeMap vals;
	
	/*
	 * @see java.util.Comparator#compare(java.lang.Object, java.lang.Object)
	 */
	public int compare(Edge e1, Edge e2) {
		double diff = vals.getDouble(e1) - vals.getDouble(e2);
		if (diff < 0)
			return -1;
		else if (diff > 0)
			return 1;
		return 0;
	}


}
