/**
 * Created on 12.11.2007
 */
package de.uka.algo.clustering.algorithms.betweenness.edgechoosing;

import de.uka.algo.clustering.Clustering;
import y.base.Edge;
import y.base.EdgeCursor;
import y.base.EdgeList;
import y.base.EdgeMap;
import y.base.Graph;

/**
 * Hide only one edge with the highest centrality
 *
 * @author Ulrich Geilmann
 */
public class SingleEdgeChooser implements EdgeChooser {

	/*
	 * @see de.uka.algo.clustering.betweenness.util.EdgeChooser#chooseEdge(y.base.Graph, y.base.EdgeMap, de.uka.algo.clustering.Clustering)
	 */
	public EdgeList chooseEdge(Graph graph, EdgeMap map, Clustering clustering) {
		double max = Double.NEGATIVE_INFINITY;
		Edge e = null;
		for (EdgeCursor cursor = graph.edges(); cursor.ok(); cursor.next()) {
			double d = map.getDouble(cursor.edge());
			if (d > max) {
				e = cursor.edge();
				max = d;
			}
		}
		graph.hide(e);
		return new EdgeList(e);
	}
}
