/**
 * 
 */
package de.uka.algo.clustering.algorithms.blondel;

import y.base.Edge;
import y.base.Node;
import y.base.NodeCursor;
import y.base.NodeList;
import de.uka.algo.clustering.Cluster;
import de.uka.algo.clustering.Clustering;
import de.uka.algo.clustering.ClusteringListener;

/**
 * @author robert
 * graph listener suffices, nevermind...
 */
public class BlondelBaseListener extends ClusteringListener {

	private NodeList initialBadNodesList;
	
	/**
	 * 
	 */
	protected BlondelBaseListener(Clustering baseClustering) {
		super(baseClustering);
		initialBadNodesList = new NodeList();
//		System.out.println("its me, the listener");
	}
	
	public NodeList getInitialBadNodes(){
		return initialBadNodesList;
	}
	
	public void tagAsValid(){
		//reset all lists!
		initialBadNodesList.clear();
	}

	@Override
	protected void addEvent(boolean notificationTime, Cluster to, NodeCursor nc) {
		// interests no sausage
	}

	@Override
	protected void deleteEvent(boolean notificationTime, Cluster deletedCluster) {
		// interests no sausage
	}

	@Override
	protected void edgeCreationEvent(Edge newEdge) {
		if (!initialBadNodesList.contains(newEdge.source())){
			initialBadNodesList.add(newEdge.source());
		}
		if (!initialBadNodesList.contains(newEdge.target())){
			initialBadNodesList.add(newEdge.target());
		}
	}

	@Override
	protected void edgeRemovalEvent(boolean notificationTime, Edge edgeToRemove) {
		if (notificationTime == ClusteringListener.PRE){
			if (!initialBadNodesList.contains(edgeToRemove.source())){
				initialBadNodesList.add(edgeToRemove.source());
			}
			if (!initialBadNodesList.contains(edgeToRemove.target())){
				initialBadNodesList.add(edgeToRemove.target());
			}
//			System.out.println("You know I'm listening: edge deleted!");
		}
	}

	@Override
	protected void extractEvent(boolean notificationTime, Cluster from, NodeCursor nc) {
		// interests no sausage	
	}

	@Override
	protected String id() {
		return (this.toString());
	}

	@Override
	protected void mergeEvent(boolean notificationTime, Cluster a, Cluster b) {
		// interests no sausage		
	}

	@Override
	protected void moveEvent(boolean notificationTime, Cluster from, Cluster to, NodeCursor nc) {
		// interests no sausage		
	}

	@Override
	protected void newClusterEvent(boolean notificationTime, Cluster newCluster) {
		// interests no sausage		
	}

	@Override
	protected void newWeightsEvent() {
		throw new RuntimeException("Not implemented, should not happen!");
	}

	@Override
	protected void nodeCreationEvent(Node newNode) {
		if (!initialBadNodesList.contains(newNode)){
			initialBadNodesList.add(newNode);
//			getClustering().newCluster(newNode);
		}
		
	}

	@Override
	protected void nodeRemovalEvent(boolean notificationTime, Node nodeToRemove) {
		// otherwise entirely implicitly dealt with....
//		if (!initialBadNodesList.contains(nodeToRemove)){
//		}
	}

	@Override
	protected void policyChanged(boolean policy) {
		// ummm,... dunno
	}

	@Override
	protected void resetEvent(boolean notificationTime) {
		// interests no sausage	
	}

	@Override
	protected void resetLargeClusterEvent(boolean notificationTime, Cluster c) {
		// interests no sausage	
	}

	@Override
	protected void resetSingletonsEvent(boolean notificationTime) {
		// interests no sausage	
	}

	@Override
	protected void splitEvent(boolean notificationTime, Cluster a, Cluster b) {
		// interests no sausage	
	}

	@Override
	protected void weightChangedEvent(Edge e, double oldWeight, double newWeight) {
		if (!initialBadNodesList.contains(e.source())){
			initialBadNodesList.add(e.source());
		}
		if (!initialBadNodesList.contains(e.target())){
			initialBadNodesList.add(e.target());
		}		
	}

}
