package de.uka.algo.clustering.algorithms.modules;

import y.option.OptionHandler;
import de.uka.algo.clustering.algorithms.Algorithm;
import de.uka.algo.clustering.algorithms.EdgeHeapModularity;
import de.uka.algo.clustering.algorithms.Singletons;

public class EdgeHeapModularityModule extends AlgorithmModule {
	
	private static final String REFRESH_COUNT = "merges before refresh";
	private static final String ONLYUPDATE = "build upon given clustering";
	private static final String ENABLEBACKTRACK = "backtrackable merges";

	public EdgeHeapModularityModule() {
		super("Cluster by contracting edges in modularity order", "Robert Goerke", "", true, WEIGHTS_ASK);
	}

	@Override
	protected Algorithm algorithm() {
		OptionHandler op = getOptionHandler();
		op.useSection("EdgeHeapModularity");
		EdgeHeapModularity eh = new EdgeHeapModularity();
		eh.setRefreshCount(op.getInt(REFRESH_COUNT));
		eh.setAllowUpdate(op.getBool(ONLYUPDATE));
		eh.setBacktrackable(op.getBool(ENABLEBACKTRACK));
		return eh;
	}

	@Override
	protected OptionHandler createOptionHandler() {
		OptionHandler op = new OptionHandler("");
		op.useSection("EdgeHeapModularity");
		op.addInt(REFRESH_COUNT,10,1,getGraph2D().N());
		op.addBool(ONLYUPDATE, false);
		op.addBool(ENABLEBACKTRACK, false);
		op.addOptionHandler(super.createOptionHandler(), "");
		return op;
	}
}
