/*
 * Created on May 28, 2008. 
 *  
 * Copyright 2008. --- All rights reserved. 
 * Algorithmic Group, Karlsruhe, Germany. 
 * 
 * Project: extension
 */
package de.uka.algo.clustering.algorithms.modules;

import y.option.OptionHandler;
import de.uka.algo.clustering.algorithms.Algorithm;
import de.uka.algo.clustering.linearprogram.ExactModularityCplex;
import de.uka.algo.clustering.linearprogram.ExactModularityLPSolve;

/**
 * @author marco
 * 
 */
public class ExactModularityModule extends AlgorithmModule {

	private static final String ILP_M_METRIC = "metric model";
	private static final String ILP_M_SOLVER = "solver";
	private static final String[] ILP_M_SOLVERS = { "LP-Solve", "Cplex" };
	private static final String CONSIDEREDGEWEIGTHS = "Consider Edge Weigths";

	/**
	 * @param arg0
	 * @param arg1
	 * @param arg2
	 * @param extractClustering
	 * @param handleWeights
	 */
	public ExactModularityModule() {
		super("ILP Modularity", "Marco Gaertler",
				"Clusters nodes using modularity.", false, WEIGHTS_ASK);
		// TODO Auto-generated constructor stub
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see de.uka.algo.clustering.algorithms.modules.AlgorithmModule#algorithm()
	 */
	@Override
	protected Algorithm algorithm() {
		OptionHandler op = getOptionHandler();
		op.useSection("Exact Modularity");
		switch( op.getEnum(ILP_M_SOLVER) ){
		case 0:
			return new ExactModularityLPSolve(op.getBool(ILP_M_METRIC), op.getBool(CONSIDEREDGEWEIGTHS));
		case 1:
		default: 
			return new ExactModularityCplex(op.getBool(ILP_M_METRIC), 0, op.getBool(CONSIDEREDGEWEIGTHS));
		}
	}
	
	@Override
	protected OptionHandler createOptionHandler() {
		OptionHandler op = new OptionHandler("");
		op.useSection("Exact Modularity");
        op.addBool(ILP_M_METRIC, true);
        op.addEnum(ILP_M_SOLVER, ILP_M_SOLVERS, 1);
		op.addBool(CONSIDEREDGEWEIGTHS, false);
        op.addOptionHandler(super.createOptionHandler(), "");
		return op;
	}


}
