package de.uka.algo.clustering.algorithms.modules;

import y.option.OptionHandler;
import de.uka.algo.clustering.algorithms.Algorithm;
import de.uka.algo.clustering.algorithms.GMC;

public class GMCModule extends IndexAlgorithmModule {

	
	public GMCModule() {
		super("GMC", "Bastian Katz", "", false, WEIGHTS_ASK);
	}
	
	@Override
	protected Algorithm algorithm() {
		OptionHandler op = getOptionHandler();
		op.useSection("GMC");
		int dimension = op.getInt("dimension");
		return new GMC(dimension, getIndexFactory());
	}

	@Override
	protected OptionHandler createOptionHandler() {
		OptionHandler op = new OptionHandler("");
		op.useSection("GMC");
		op.addInt("dimension", 5,1, 100);
		op.addOptionHandler(super.createOptionHandler(), "");
		return op;
	}
	

}
