package de.uka.algo.clustering.algorithms.modules;

import y.option.OptionHandler;
import de.uka.algo.clustering.algorithms.Algorithm;
import de.uka.algo.clustering.algorithms.greedy.EmulationPredictor;
import de.uka.algo.clustering.algorithms.greedy.Greedy;

public class GreedyModule extends IndexAlgorithmModule {

	private static final String FAST = "Don't refresh all values";


	public GreedyModule() {
		super("Slow Greedy Merging", "Bastian Katz", "", false, WEIGHTS_ASK);
	}

	@Override
	protected Algorithm algorithm() {		
		OptionHandler op = getOptionHandler();
		return new Greedy(new EmulationPredictor.Factory(getIndexFactory()), op.getBool(FAST));
	} 
	

	protected OptionHandler createOptionHandler() {
		OptionHandler op = super.createOptionHandler();
		op.addBool(FAST, true);
		return op;
	}



}
