/*
 * Created on 27.06.2004
 */
package de.uka.algo.clustering.algorithms.modules;

import y.option.OptionHandler;
import de.uka.algo.clustering.algorithms.Algorithm;
import de.uka.algo.clustering.algorithms.ICC;
import de.uka.algo.graphs.cut.ConductanceCutter;

/**
 * @author Bastian Katz
 */
public class ICCModule extends AlgorithmModule {

	private static final String COMPLEX_CUTTING = "complex cutting";
	private static final String THRESHOLD = "threshold";
	private static final String CUTTING_STRATEGY = "cutting strategy";
	public ICCModule() {
		super("ICC", "Bastian Katz", "Clusters nodes using the ICC algorithm.",
				false, WEIGHTS_ASK);
	}

	@Override
	protected Algorithm algorithm() {
		OptionHandler op = getOptionHandler();
		op.useSection("ICC");
		ConductanceCutter.ConductanceStrategies strategy = ConductanceCutter.ConductanceStrategies
				.values()[op.getEnum(CUTTING_STRATEGY)];
		double threshold = op.getDouble(THRESHOLD);
		boolean complex = op.getBool(COMPLEX_CUTTING);
		return new ICC(threshold, strategy, complex);
	}

	@Override
	protected OptionHandler createOptionHandler() {
		OptionHandler op = new OptionHandler("");
		op.useSection("ICC");
		op.addBool(COMPLEX_CUTTING, false);
		op.addDouble(THRESHOLD, 0.1, 0, 0.5, 4);
		op.addEnum(CUTTING_STRATEGY, ConductanceCutter.ConductanceStrategies
				.values(), 0);
		op.addOptionHandler(super.createOptionHandler(), "");
		return op;
	}
}
