package de.uka.algo.clustering.algorithms.modules;

import y.option.OptionHandler;
import de.uka.algo.clustering.algorithms.Algorithm;
import de.uka.algo.clustering.algorithms.MCL;

public class MCLModule extends AlgorithmModule {

    private static final String MCL_ELEMENTEXPONENT = "element power";
    private static final String MCL_MATRIXEXPONENT = "matrix power";
    private static final String[] MCL_MODI = {"CLASSIC (parameter omitted)", "DEGREE LIMIT: x*DEGREE", "DEGREE LIMIT: x*MAXDEGREE", "CONSTANT DEGREE LIMIT: x"};

	
	public MCLModule() {
		super("MCL", "Bastian Katz", "", false, WEIGHTS_ASK);
	}

	@Override
	protected Algorithm algorithm() {
		OptionHandler op = getOptionHandler();
		op.useSection("MCL");
		return new MCL(op.getInt(MCL_MATRIXEXPONENT), op.getDouble(MCL_ELEMENTEXPONENT), op.getEnum("modus"), op.getInt("x"));
	}

	@Override
	protected OptionHandler createOptionHandler() {
		OptionHandler op = new OptionHandler("");
		op.useSection("MCL");
        op.addInt(MCL_MATRIXEXPONENT, 2,2,4);
        op.addDouble(MCL_ELEMENTEXPONENT, 1.5, 0.0, 5.0, 3);
        op.addEnum("modus", MCL_MODI, 3);
        op.addInt("x", 25);
        op.addOptionHandler(super.createOptionHandler(), "");
		return op;
	}

	
}
