package de.uka.algo.clustering.algorithms.modules;

import y.option.OptionHandler;
import de.uka.algo.clustering.algorithms.Algorithm;
import de.uka.algo.clustering.algorithms.RandomClusterer;

public class RandomClustererModule extends AlgorithmModule {

	private final static String ID = "Random Clusterer";
	private final static String MINCL = "minimal clusters";
	private final static String MAXCL = "maximal clusters";
	
	public RandomClustererModule() {
		super("Random Clusterer", "Daniel Delling", "", false, WEIGHTS_IGNORE);
	}
	

	@Override
	protected Algorithm algorithm() {
		OptionHandler op = getOptionHandler();
		op.useSection(ID);
		int mincl = op.getInt(MINCL);
		int maxcl = op.getInt(MAXCL);
		return new RandomClusterer(mincl,maxcl);
	}

	@Override
	protected OptionHandler createOptionHandler() {
		OptionHandler op = new OptionHandler("");
		op.useSection(ID);
		op.addInt(MINCL, 5);
		op.addInt(MAXCL, 5);
		op.addOptionHandler(super.createOptionHandler(), "");
		return op;
	}	
	

}





