package de.uka.algo.clustering.algorithms.modules;

import y.option.OptionHandler;
import de.uka.algo.clustering.algorithms.Algorithm;
import de.uka.algo.clustering.algorithms.RandomPermutationClusterer;

public class RandomPermutationClustererModule extends AlgorithmModule {

	private final static String ID = "Random Permutation Clusterer";
	
	public RandomPermutationClustererModule() {
		super("Random Permutation Clusterer", "Daniel Delling", "", true, WEIGHTS_IGNORE);
	}
	

	@Override
	protected Algorithm algorithm() {
		OptionHandler op = getOptionHandler();
		op.useSection(ID);
		int pf = op.getInt("number of swaps * n");
		return new RandomPermutationClusterer(pf);
	}

	@Override
	protected OptionHandler createOptionHandler() {
		OptionHandler op = new OptionHandler("");
		op.useSection(ID);
		op.addInt("number of swaps * n", 2);
		op.addOptionHandler(super.createOptionHandler(), "");
		return op;
	}	
	

}





