/*
 * Created on Apr 6, 2006
 *
 * Copyright 2005.  --- All rights reserved. 
 * Algorithmic Group, Karlsruhe, Germany.
 */
package de.uka.algo.clustering.algorithms.newman.internal;

import de.uka.algo.clustering.Cluster;
import de.uka.algo.clustering.Clustering;
import de.uka.algo.clustering.algorithms.newman.util.ClusterAdjacencyMatrix;
import de.uka.algo.clustering.algorithms.newman.util.FractionOfEdgeWeights;

public interface GenericDeltaQMatrix {

	/**
	 * 
	 * @param cl a (singleton) clustering
	 */
	public abstract void init(Clustering cl, ClusterAdjacencyMatrix adj,
			FractionOfEdgeWeights frac, boolean weighted);

	public abstract void merge(Cluster c1, Cluster c2, Cluster combinedCluster);

	public abstract void setPeakIsReached();

	public abstract void recomputeForAll();

	public abstract boolean isEmpty();

	public abstract Cluster getMaximumCluster1();

	public abstract Cluster getMaximumCluster2();

	public abstract double getMaximumValue();

	public abstract double getValue(Cluster c1, Cluster c2);

}