/*
 * Created on Feb 16, 2006
 *
 * Copyright 2005.  --- All rights reserved. 
 * Algorithmic Group, Karlsruhe, Germany.
 */
package de.uka.algo.clustering.algorithms.newman.internal;

import de.uka.algo.clustering.Cluster;
import de.uka.algo.clustering.Clustering;
import de.uka.algo.clustering.algorithms.newman.util.ClusterAdjacencyMatrix;
import de.uka.algo.clustering.algorithms.newman.util.FractionOfEdgeWeights;
import de.uka.algo.util.datastructures.Pair;

public interface QInterface {

	public abstract void init(Clustering c, FractionOfEdgeWeights frac,
			ClusterAdjacencyMatrix adj, boolean weighted);

	public abstract double getInitialDeltaQ(Cluster c1, Cluster c2);

	public abstract double getNonInitialDeltaQNotConnected(Cluster c1, Cluster c2);
	
	public abstract boolean needsFullComputation();
	
	public abstract void updateModularity(double diff);
	
	public abstract double getModularity();
	
	public abstract Pair<Double, Boolean> getUpdatedDeltaQ(Cluster c1,
				Cluster c2, Cluster merged,
				Cluster cc, double deltaQ1, double deltaQ2);
	
	public void setPeakIsReached();
}