/*
 * Created on Feb 16, 2006
 *
 * Copyright 2005.  --- All rights reserved. 
 * Algorithmic Group, Karlsruhe, Germany.
 */
package de.uka.algo.clustering.algorithms.newman.internal;

import de.uka.algo.clustering.Cluster;
import de.uka.algo.util.datastructures.Triple;

public interface QQInterface extends QInterface {
	public abstract double getInitialDeltaQValue(Cluster c1, Cluster c2);
	
	public abstract double getInitialDeltaQEValue(Cluster c1, Cluster c2);
	
	public abstract double getNonInitialDeltaValueNotConnected(Cluster c1, Cluster c2);
	
	public abstract double getNonInitialDeltaEValueNotConnected(Cluster c1, Cluster c2);

	public abstract void updateValue(double diff);
	
	public abstract void updateEValue(double diff);

	public abstract double getValue();
	
	public abstract double getEValue();
	

	/**
	 * @return value, expected value, "dontStore" flag
	 */
	public abstract Triple<Double, Double, Boolean> getUpdatedValues(Cluster c1,
			Cluster c2, Cluster merged,Cluster cc,
			double deltaValue1, double deltaValue2,
			double deltaEValue1, double deltaEValue2);
}