package de.uka.algo.clustering.algorithms.newman.internal;

import org.apache.log4j.Level;

import y.base.Node;
import y.base.NodeCursor;
import de.uka.algo.clustering.Cluster;
import de.uka.algo.clustering.Clustering;
import de.uka.algo.graphs.GraphInterpretation;

public class StonePitUpdateStrategy extends UpdateStrategy {
	static org.apache.log4j.Logger logger = org.apache.log4j.Logger
	.getLogger(StonePitUpdateStrategy.class);

	@Override
	public void prepareClustering(Clustering cl, GraphInterpretation oldGraph) {
		logger.setLevel(Level.INFO);
		logger.debug("preparing clustering");
		GraphDelta delta = new GraphDelta(oldGraph, cl.getInterpretation());
		for(NodeCursor nc = delta.getGraph().nodes(); nc.ok(); nc.next()) {
			Node n = nc.node();
			if(n.degree() > 0) {
				Node realnode = cl.getGraph().getNodeArray()[n.index()];
				Cluster c = cl.getCluster(realnode);
				if(c != null)
				{
					logger.debug("deleting cluster " + c.getIndex());
					cl.delete(c);
				}
			}
		}
		cl.pool2Singletons();
		delta = null;
	}
}
