/*
 * created May 4, 2006
 *
 * Copyright 2006.  --- All rights reserved. 
 * Algorithmic Group, Karlsruhe, Germany.
 *
 */
package de.uka.algo.clustering.comparison.graphbased;

import de.uka.algo.clustering.Clustering;
import de.uka.algo.clustering.comparison.ClusterEditingSetOperators;
import de.uka.algo.clustering.comparison.Comparator;
import de.uka.algo.clustering.comparison.ComparatorFactory;

public class EditingSetQuotient implements Comparator {

	private static final String ID = "Editing Set Quotient";
	ClusterEditingSetOperators ceso;
	
	public EditingSetQuotient(Clustering a, Clustering b){
		ceso = ClusterEditingSetOperators.getClusterEditingSetOperator(a,b);
	}
	
	
	public double getValue() {
		return 1-(double)ceso.getIntersectionClusterEditingSize()/(double)ceso.getUnionClusterEditingSize();
	}

	@Override
	public String toString() {
		return ID;
	}

	public static class Factory implements ComparatorFactory {
		public Comparator getComparator(Clustering a, Clustering b) {
			return new EditingSetQuotient(a, b);
		}		
		@Override
		public String toString() {
			return ID;
		}
	}

}
