/*
 * created May 4, 2006
 *
 * Copyright 2006.  --- All rights reserved. 
 * Algorithmic Group, Karlsruhe, Germany.
 *
 */
package de.uka.algo.clustering.comparison.graphbased.counting;

import de.uka.algo.clustering.Clustering;
import de.uka.algo.clustering.comparison.Comparator;
import de.uka.algo.clustering.comparison.ComparatorFactory;
import de.uka.algo.clustering.comparison.ConnectedCountingPairSet;

public class AdjustedRandGraphExt implements Comparator {

	private static final String ID = "adjusted Rand (g)";
	ConnectedCountingPairSet ccps;
	
	public AdjustedRandGraphExt(Clustering a, Clustering b){
		ccps = ConnectedCountingPairSet.getConnectedCountingPairSet(a,b);
	}
	
	
	public double getValue() {
		double t1 = ccps.getE11()+ccps.getE10();
		double t2 = ccps.getE11()+ccps.getE01();
		double t3 = t1*t2/(ccps.getNumberOfAllConnectedPairs());
		if((0.5*(t1+t2)-t3) == 0){
			return 1;
		} else {
			return 1-((ccps.getE11()-t3)/(0.5*(t1+t2)-t3));
		}
	}

	@Override
	public String toString() {
		return ID;
	}

	public static class Factory implements ComparatorFactory {
		public Comparator getComparator(Clustering a, Clustering b) {
			return new AdjustedRandGraphExt(a, b);
		}		
		@Override
		public String toString() {
			return ID;
		}
	}

}
