/*
 * created May 4, 2006
 *
 * Copyright 2006.  --- All rights reserved. 
 * Algorithmic Group, Karlsruhe, Germany.
 *
 */
package de.uka.algo.clustering.comparison.graphbased.counting;

import de.uka.algo.clustering.Clustering;
import de.uka.algo.clustering.comparison.Comparator;
import de.uka.algo.clustering.comparison.ComparatorFactory;
import de.uka.algo.clustering.comparison.ConnectedCountingPairSet;

public class JaccardGraphExt implements Comparator {

	private static final String ID = "Jaccard (g)";
	ConnectedCountingPairSet ccps;
	
	public JaccardGraphExt(Clustering a, Clustering b){
		ccps = ConnectedCountingPairSet.getConnectedCountingPairSet(a,b);
	}
		
	public double getValue() {
		if(ccps.getNumberOfAllConnectedPairs() == ccps.getE00()){
			return 0;
		} 
		return 1-(double)ccps.getE11()/(double)(ccps.getE11()+ccps.getE10()+ccps.getE01());					
	}

	
	@Override
	public String toString() {
		return ID;
	}

	public static class Factory implements ComparatorFactory {
		public Comparator getComparator(Clustering a, Clustering b) {
			return new JaccardGraphExt(a, b);
		}		
		@Override
		public String toString() {
			return ID;
		}
	}

}
