/*
 * created May 4, 2006
 *
 * Copyright 2006.  --- All rights reserved. 
 * Algorithmic Group, Karlsruhe, Germany.
 *
 */
package de.uka.algo.clustering.comparison.graphbased.counting;

import de.uka.algo.clustering.Clustering;
import de.uka.algo.clustering.comparison.Comparator;
import de.uka.algo.clustering.comparison.ComparatorFactory;
import de.uka.algo.clustering.comparison.ConnectedCountingPairSet;

/**
 * implements the graphbased Rand Measure:
 * 
 * (e_10+e_01)/m
 * 
 * @author Daniel Delling
 *
 */
public class RandGraphExt implements Comparator {

	private static final String ID = "Rand (g)";
	ConnectedCountingPairSet ccps;
	
	public RandGraphExt(Clustering a, Clustering b){
		ccps = ConnectedCountingPairSet.getConnectedCountingPairSet(a,b);
	}
	
	
	public double getValue() {
		return (double)(ccps.getE01()+ccps.getE10())/(double)(ccps.getNumberOfAllConnectedPairs());
	}

	
	@Override
	public String toString() {
		return ID;
	}

	public static class Factory implements ComparatorFactory {
		public Comparator getComparator(Clustering a, Clustering b) {
			return new RandGraphExt(a, b);
		}		
		@Override
		public String toString() {
			return ID;
		}
	}

}
