/*
 * created May 5, 2006
 *
 * Copyright 2006.  --- All rights reserved. 
 * Algorithmic Group, Karlsruhe, Germany.
 *
 */
package de.uka.algo.clustering.comparison.graphbased.informationTheory;

import de.uka.algo.clustering.Clustering;
import de.uka.algo.clustering.comparison.Comparator;
import de.uka.algo.clustering.comparison.ComparatorFactory;
import de.uka.algo.clustering.comparison.MutualEdgeInformation;

public class FredJainGraphExt implements Comparator {
	
	private static final String ID = "Fred & Jain (g)";
	private MutualEdgeInformation mei;
	private Clustering cl1;
	private Clustering cl2;

	public FredJainGraphExt(Clustering a, Clustering b){
		mei = MutualEdgeInformation.getMutualEdgeInformation(a,b);
		cl1 = a;
		cl2 = b;
	}
	
	public double getValue() {
		if(cl1.getEdgeEntropy()+cl2.getEdgeEntropy() == 0){
			return 0;
		} 
		return 1-2*mei.getMutualEdgeInfo()/(cl1.getEdgeEntropy()+cl2.getEdgeEntropy());		
	}

	@Override
	public String toString() {
		return ID;
	}

	public static class Factory implements ComparatorFactory {
		public Comparator getComparator(Clustering a, Clustering b) {
			return new FredJainGraphExt(a, b);
		}		
		@Override
		public String toString() {
			return ID;
		}
	}

}
