/*
 * created May 5, 2006
 *
 * Copyright 2006.  --- All rights reserved. 
 * Algorithmic Group, Karlsruhe, Germany.
 *
 */
package de.uka.algo.clustering.comparison.graphbased.informationTheory;

import de.uka.algo.clustering.Clustering;
import de.uka.algo.clustering.comparison.Comparator;
import de.uka.algo.clustering.comparison.ComparatorFactory;
import de.uka.algo.clustering.comparison.MutualEdgeInformation;

public class StrehlGoshGraphExt implements Comparator {
	
	private static final String ID = "Strehl & Gosh (g)";
	private MutualEdgeInformation mei;
	private Clustering cl1;
	private Clustering cl2;

	public StrehlGoshGraphExt(Clustering a, Clustering b){
		mei = MutualEdgeInformation.getMutualEdgeInformation(a,b);
		cl1 = a;
		cl2 = b;
	}
	
	public double getValue() {		
		double h1 = cl1.getEdgeEntropy();
		double h2 = cl2.getEdgeEntropy();
		if(h1*h2 != 0){
			return 1-mei.getMutualEdgeInfo()/Math.sqrt(h1*h2);
		} else if (h1+h2 == 0) {
			return 0;
		} else {
			return 1;
		}
	}

	@Override
	public String toString() {
		return ID;
	}

	public static class Factory implements ComparatorFactory {
		public Comparator getComparator(Clustering a, Clustering b) {
			return new StrehlGoshGraphExt(a, b);
		}		
		@Override
		public String toString() {
			return ID;
		}
	}

}
