/*
 * created May 4, 2006
 *
 * Copyright 2006.  --- All rights reserved. 
 * Algorithmic Group, Karlsruhe, Germany.
 *
 */
package de.uka.algo.clustering.comparison.nodebased.counting;

import de.uka.algo.clustering.Clustering;
import de.uka.algo.clustering.comparison.Comparator;
import de.uka.algo.clustering.comparison.ComparatorFactory;
import de.uka.algo.clustering.comparison.CountingPairSet;

/**
 * implements the Rand Measure:
 * 
 * 2(n_10+n_01)/(n(n-1))
 * 
 * @author Daniel Delling
 *
 */
public class Rand implements Comparator {

	private static final String ID = "Rand";
	CountingPairSet cps;
	
	public Rand(Clustering a, Clustering b){
		cps = CountingPairSet.getCountingPairSet(a,b);
	}
	
	
	public double getValue() {
		return (double)(cps.getN01()+cps.getN10())/(double)(cps.getNumberOfAllPairs());
	}

	
	@Override
	public String toString() {
		return ID;
	}

	public static class Factory implements ComparatorFactory {
		public Comparator getComparator(Clustering a, Clustering b) {
			return new Rand(a, b);
		}		
		@Override
		public String toString() {
			return ID;
		}
	}

}
