/*
 * created May 5, 2006
 *
 * Copyright 2006.  --- All rights reserved. 
 * Algorithmic Group, Karlsruhe, Germany.
 *
 */
package de.uka.algo.clustering.comparison.nodebased.informationTheory;

import de.uka.algo.clustering.Clustering;
import de.uka.algo.clustering.comparison.Comparator;
import de.uka.algo.clustering.comparison.ComparatorFactory;
import de.uka.algo.clustering.comparison.MutualInformation;

public class FredJain implements Comparator {
	
	private static final String ID = "Fred & Jain";
	private MutualInformation mi;
	private Clustering cl1;
	private Clustering cl2;

	public FredJain(Clustering a, Clustering b){
		mi = MutualInformation.getMutualInformation(a,b);
		cl1 = a;
		cl2 = b;
	}
	
	public double getValue() {
		double h1 = cl1.getEntropy();
		double h2 = cl2.getEntropy();
		if(h1+h2 == 0){
			return 0;
		} 
		return 1-2*mi.getMutualInfo()/(h1+h2);
	}

	@Override
	public String toString() {
		return ID;
	}

	public static class Factory implements ComparatorFactory {
		public Comparator getComparator(Clustering a, Clustering b) {
			return new FredJain(a, b);
		}		
		@Override
		public String toString() {
			return ID;
		}
	}

}
