/*
 * created May 4, 2006
 *
 * Copyright 2006.  --- All rights reserved. 
 * Algorithmic Group, Karlsruhe, Germany.
 *
 */
package de.uka.algo.clustering.comparison.nodebased.overlaps;

import de.uka.algo.clustering.Cluster;
import de.uka.algo.clustering.Clustering;
import de.uka.algo.clustering.comparison.Comparator;
import de.uka.algo.clustering.comparison.ComparatorFactory;
import de.uka.algo.clustering.comparison.ConfusionMatrix;
import de.uka.algo.util.GYCursor;

public class vanDongen implements Comparator {

	private static final String ID = "van Dongen norm";
	ConfusionMatrix cm;
	Clustering cl1;
	Clustering cl2;
	
	public vanDongen(Clustering a, Clustering b){
		cm = ConfusionMatrix.getConfusionMatrix(a,b);
		cl1 = a;
		cl2 = b;
	}
	
	
	
	public double getNonNormalizedValue() {
		int sum1 = 0;
		int sum2 = 0;
		for (GYCursor<Cluster> cc = cl1.clusters(); cc.ok(); cc.next()) {
			Cluster c = cc.active();
			sum1 += cm.getMaximumIntersectionToCluster(c);
		}
		for (GYCursor<Cluster> cc = cl2.clusters(); cc.ok(); cc.next()) {
			Cluster c = cc.active();
			sum2 += cm.getMaximumIntersectionToCluster(c);
		}
		return 2*cl1.getGraph().N()-sum1-sum2;
		
	}

	public double getValue() {
		return getNonNormalizedValue()/(2*cl1.getGraph().N());
	}

	@Override
	public String toString() {
		return ID;
	}

	public static class Factory implements ComparatorFactory {
		public Comparator getComparator(Clustering a, Clustering b) {
			return new vanDongen(a, b);
		}		
		@Override
		public String toString() {
			return ID;
		}
	}

}
