/*
 * created May 10, 2006
 *
 * Copyright 2006.  --- All rights reserved. 
 * Algorithmic Group, Karlsruhe, Germany.
 *
 */
package de.uka.algo.clustering.comparison.qualitybased;

import de.uka.algo.clustering.Clustering;
import de.uka.algo.clustering.comparison.Comparator;
import de.uka.algo.clustering.comparison.ComparatorFactory;
import de.uka.algo.clustering.index.IndexFactory;
import de.uka.algo.clustering.index.Modularity;

public class QualityDistance implements Comparator {

	private static final String IDMOD = "Absolute Modularity Distance";

	Clustering cl1 = null;
	Clustering cl2 = null;
	IndexFactory quality = null;
	
	
	public QualityDistance(Clustering a, Clustering b, IndexFactory quality){
		this.cl1 = a;
		this.cl2 = b;
		this.quality = quality;
	}
	
	public double getValue() {
		double valueCl1 = quality.getIndex(cl1).getValue();
		double valueCl2 = quality.getIndex(cl2).getValue();
		return Math.abs(valueCl1-valueCl2);
	}

	public static class FactoryModularity implements ComparatorFactory {
		public Comparator getComparator(Clustering a, Clustering b) {
			return new QualityDistance(a, b, new Modularity.Factory());
		}		
		@Override
		public String toString() {
			return IDMOD;
		}
	}

}
