/*
 * created May 12, 2006
 *
 * Copyright 2006.  --- All rights reserved. 
 * Algorithmic Group, Karlsruhe, Germany.
 *
 */
package de.uka.algo.clustering.edgeweighters;

import java.util.Random;

import y.base.Edge;
import y.base.EdgeCursor;
import y.base.EdgeMap;
import de.uka.algo.clustering.Clustering;

public class TypeSetter extends EdgeWeighter {

	private double intraMinValue;
	private double intraMaxValue;
	private double interMinValue;
	private double interMaxValue;
	private Random ran = new Random();
	
	public TypeSetter(double intraMin, double intraMax, double interMin, double interMax){
		this.interMaxValue = interMax;
		this.interMinValue = interMin;
		if(interMax < interMin){
			this.interMaxValue = interMin;
		}
		this.intraMaxValue = intraMax;
		this.intraMinValue = intraMin;
		if(intraMax < intraMin){
			this.intraMaxValue = intraMin;
		}
	}
	
	public EdgeMap changeEdges(Clustering cl) {
		EdgeMap em = cl.getGraph().createEdgeMap();
		double newWeight = 0.0;
		for(EdgeCursor ec = cl.getGraph().edges(); ec.ok(); ec.next()){
			Edge e = ec.edge();
			if(cl.isIntraClusterEdge(e)){
				newWeight = ran.nextDouble()*(intraMaxValue-intraMinValue)+intraMinValue;
				em.setDouble(e, newWeight);
			}
			if(cl.isInterClusterEdge(e)){
				newWeight = ran.nextDouble()*(interMaxValue-interMinValue)+interMinValue;
				em.setDouble(e, newWeight);
			}
		}
		return em;
	}
	
	
}
