/*
 * created May 18, 2006
 *
 * Copyright 2006.  --- All rights reserved. 
 * Algorithmic Group, Karlsruhe, Germany.
 *
 */
package de.uka.algo.clustering.edgeweighters.modules;

import y.option.OptionHandler;
import de.uka.algo.clustering.edgeweighters.DistanceWeighter;
import de.uka.algo.clustering.edgeweighters.EdgeWeighter;

public class DistanceModule extends EdgeWeighterModule {

	private final static String FACTOR= "strech factor";
	
	public DistanceModule() {
		super("DistanceWeighter", "Daniel Delling", "");
		// TODO Auto-generated constructor stub
	}

	@Override
	public EdgeWeighter getEdgeWeighter() {
		OptionHandler op = getOptionHandler();
		double factor = op.getDouble(FACTOR);
		return new DistanceWeighter(factor);
	}

	@Override
	protected OptionHandler createOptionHandler() {
		OptionHandler op = super.createOptionHandler();
		op.addDouble(FACTOR, 100);
		return op;
	}
	
	

}
