/*
 * created May 18, 2006
 *
 * Copyright 2006.  --- All rights reserved. 
 * Algorithmic Group, Karlsruhe, Germany.
 *
 */
package de.uka.algo.clustering.edgeweighters.modules;

import y.option.OptionHandler;
import de.uka.algo.clustering.edgeweighters.EdgeWeighter;
import de.uka.algo.clustering.edgeweighters.Scaler;

public class ScalerModule extends EdgeWeighterModule {

	private final static String INTRASCALE= "scale factor for intracluster edges";
	private final static String INTERSCALE= "scale factor for intercluster edges";
	
	public ScalerModule() {
		super("WeightScaler", "Daniel Delling", "");
		// TODO Auto-generated constructor stub
	}

	@Override
	public EdgeWeighter getEdgeWeighter() {
		OptionHandler op = getOptionHandler();
		double intra = op.getDouble(INTRASCALE);
		double inter = op.getDouble(INTERSCALE);
		return new Scaler(intra, inter);
	}

	@Override
	protected OptionHandler createOptionHandler() {
		OptionHandler op = super.createOptionHandler();
		op.addDouble(INTRASCALE, 2);
		op.addDouble(INTERSCALE, 0.5);
		return op;
	}
	
	

}
