/*
 * created May 18, 2006
 *
 * Copyright 2006.  --- All rights reserved. 
 * Algorithmic Group, Karlsruhe, Germany.
 *
 */
package de.uka.algo.clustering.edgeweighters.modules;

import y.option.OptionHandler;
import de.uka.algo.clustering.edgeweighters.EdgeWeighter;
import de.uka.algo.clustering.edgeweighters.TypeSetter;

public class TypeSetterModule extends EdgeWeighterModule {

	private final static String MININTRA= "minimum intracluster weight";
	private final static String MAXINTRA= "maximal intracluster weight";
	private final static String MININTER= "minimum intercluster weight";
	private final static String MAXINTER= "maximal intercluster weight";
	
	public TypeSetterModule() {
		super("TypeSetter", "Daniel Delling", "");
		// TODO Auto-generated constructor stub
	}

	@Override
	public EdgeWeighter getEdgeWeighter() {
		OptionHandler op = getOptionHandler();
		double minIntra = op.getDouble(MININTRA);
		double maxIntra = op.getDouble(MAXINTRA);
		double minInter = op.getDouble(MININTER);
		double maxInter = op.getDouble(MAXINTER);
		return new TypeSetter(minIntra,maxIntra,minInter,maxInter);
	}

	@Override
	protected OptionHandler createOptionHandler() {
		OptionHandler op = super.createOptionHandler();
		op.addDouble(MININTRA, 0.5);
		op.addDouble(MAXINTRA, 1.0);
		op.addDouble(MININTER, 0.0);
		op.addDouble(MAXINTER, 0.5);		
		return op;
	}
	
	

}
