/*
 * created May 10, 2006
 *
 * Copyright 2006.  --- All rights reserved. 
 * Algorithmic Group, Karlsruhe, Germany.
 *
 */
package de.uka.algo.clustering.generators.attractors;

import y.base.Graph;
import y.base.NodeCursor;

/**
 * Centerless Attractors are created like normal
 * {@link de.uka.algo.generators.attractors.Attractor attractors}. They only
 * differ in fact that the initial attractor nodes are removed in the centerless
 * version.
 * 
 * @author Daniel Delling
 * 
 */
public class CenterlessAttractor extends Attractor {

	/**
	 * initiates a centerless attractor
	 * 
	 * @param g
	 *            the graph the attractor is built in
	 * @param numberOfNodes
	 *            the number of nodes
	 * @param densityThreshold
	 *            the density of the graph
	 */
	public CenterlessAttractor(Graph g, int numberOfNodes, double densityThreshold) {
		super(g, numberOfNodes, densityThreshold);
		Graph graph = getGraph();
		for (NodeCursor nc = attractorNodes.nodes(); nc.ok(); nc.next()) {
			graph.removeNode(nc.node());
		}
	}

}
