/*
 * created Apr 28, 2006
 *
 * Copyright 2006.  --- All rights reserved. 
 * Algorithmic Group, Karlsruhe, Germany.
 * 
 */
package de.uka.algo.clustering.generators.modules;

import y.option.OptionHandler;
import y.view.Graph2D;
import de.uka.algo.clustering.generators.ClusteredGraph;
import de.uka.algo.clustering.generators.attractors.Attractor;
import de.uka.algo.clustering.generators.attractors.CenterlessAttractor;

public class AttractorModule extends ClusteredGraphModule {

	private static final String ID = "Attractor";
	
	public AttractorModule() {
		super(ID, "Daniel Delling", "");
	}
	
	@Override
	protected OptionHandler createOptionHandler() {
		OptionHandler op = new OptionHandler("");
		op.useSection(ID);
		op.addInt("nodes", 100);
		op.addDouble("density", 1);
		op.addBool("delete centers", false);
		op.addOptionHandler(super.createOptionHandler(), "");
		return op;
	}

	@Override
	protected ClusteredGraph clusteredGraph(Graph2D g) {
		OptionHandler op = getOptionHandler();
		op.useSection(ID);
		int nodes = op.getInt("nodes");
		double density = op.getDouble("density");
		boolean deleteCenter = op.getBool("delete centers");
		if(deleteCenter){
			return new CenterlessAttractor(g, nodes, density);
		} 
		return new Attractor(g, nodes, density);					
	}

	
}
