/*
 * created May 02, 2006
 *
 * Copyright 2006.  --- All rights reserved. 
 * Algorithmic Group, Karlsruhe, Germany.
 * 
 */
package de.uka.algo.clustering.generators.modules;

import y.option.OptionHandler;
import y.view.Graph2D;
import de.uka.algo.clustering.generators.ClusteredGraph;
import de.uka.algo.clustering.generators.randomCluster.EquiPartitionClusteredGraph;
import de.uka.algo.clustering.layout.Circle;
import de.uka.algo.clustering.visualization.NodeColorizer;

public class EquiPartitionModule extends ClusteredGraphModule {

	private static final String ID = "Gaussian Randomgraph";
	
	public EquiPartitionModule() {
		super(ID, "Daniel Delling", "");
		setDefaultLayouter(new Circle().toString());
		setDefaultVisualization(new NodeColorizer().toString());
	}
	
	@Override
	protected OptionHandler createOptionHandler() {
		OptionHandler op = new OptionHandler("");
		op.useSection(ID);
		op.addInt("number of clusters", 4);
		op.addInt("minimum size of a cluster", 20);
		op.addInt("maximal size of a cluster", 50);
		op.addDouble("pIn", 0.5);
		op.addDouble("pOut", 0.05);
		op.addOptionHandler(super.createOptionHandler(), "");
		return op;
	}

	@Override
	protected ClusteredGraph clusteredGraph(Graph2D g) {
		OptionHandler op = getOptionHandler();
		op.useSection(ID);
		int c = op.getInt("number of clusters");
		int min = op.getInt("minimum size of a cluster");
		int max = op.getInt("maximal size of a cluster");
		double pIn = op.getDouble("pIn");
		double pOut = op.getDouble("pOut");
		return new EquiPartitionClusteredGraph(g, c, min, max, pIn, pOut);		
	}
	
}
