/*
 * created Apr 28, 2006
 *
 * Copyright 2006.  --- All rights reserved. 
 * Algorithmic Group, Karlsruhe, Germany.
 * 
 */
package de.uka.algo.clustering.generators.modules;

import y.option.OptionHandler;
import y.view.Graph2D;
import de.uka.algo.clustering.generators.ClusteredGraph;
import de.uka.algo.clustering.generators.randomCluster.GaussianClusteredGraph;
import de.uka.algo.clustering.layout.Circle;
import de.uka.algo.clustering.visualization.NodeColorizer;

public class GaussianModule extends ClusteredGraphModule {

	private static final String ID = "Gaussian Randomgraph";
	
	public GaussianModule() {
		super(ID, "Daniel Delling", "");
		setDefaultLayouter(new Circle().toString());
		setDefaultVisualization(new NodeColorizer().toString());
	}
	
	@Override
	protected OptionHandler createOptionHandler() {
		OptionHandler op = new OptionHandler("");
		op.useSection(ID);
		op.addInt("nodes", 200);
		op.addDouble("pIn", 0.5);
		op.addDouble("pOut", 0.05);
		op.addOptionHandler(super.createOptionHandler(), "");
		return op;
	}

	@Override
	protected ClusteredGraph clusteredGraph(Graph2D g) {
		OptionHandler op = getOptionHandler();
		op.useSection(ID);
		int nodes = op.getInt("nodes");
		double pIn = op.getDouble("pIn");
		double pOut = op.getDouble("pOut");
		return new GaussianClusteredGraph(g, nodes, pIn, pOut);		
	}
	
}
