/*
 * created Apr 28, 2006
 *
 * Copyright 2006.  --- All rights reserved. 
 * Algorithmic Group, Karlsruhe, Germany.
 * 
 */
package de.uka.algo.clustering.generators.modules;

import y.option.OptionHandler;
import y.view.Graph2D;
import de.uka.algo.clustering.generators.ClusteredGraph;
import de.uka.algo.clustering.generators.randomCluster.SignificantGaussianClusteredGraph;
import de.uka.algo.clustering.layout.Circle;
import de.uka.algo.clustering.visualization.NodeColorizer;

public class SignificantGaussianModule extends ClusteredGraphModule {

	private static final String ID = "Significant Gaussian Randomgraph";
	
	public SignificantGaussianModule() {
		super(ID, "Daniel Delling", "");
		setDefaultLayouter(new Circle().toString());
		setDefaultVisualization(new NodeColorizer().toString());
	}
	
	@Override
	protected OptionHandler createOptionHandler() {
		OptionHandler op = new OptionHandler("");
		op.useSection(ID);
		op.addInt("nodes", 200);
		op.addDouble("pIn", 0.3);
		op.addDouble("rho", 0.2);
		op.addOptionHandler(super.createOptionHandler(), "");
		return op;
	}

	@Override
	protected ClusteredGraph clusteredGraph(Graph2D g) {
		OptionHandler op = getOptionHandler();
		op.useSection(ID);
		int nodes = op.getInt("nodes");
		double pIn = op.getDouble("pIn");
		double rho = op.getDouble("rho");
		return new SignificantGaussianClusteredGraph(g, nodes, pIn, rho);		
	}
	
}
