/*
 * Created Mar 8, 2006
 *
 * Copyright 2006.  --- All rights reserved. 
 * Algorithmic Group, Karlsruhe, Germany.
 */
package de.uka.algo.clustering.generators.randomCluster;

import y.base.Graph;
import de.uka.algo.clustering.generators.utils.PartitionGenerator;

/**
 * this class implements a Generator creating clustergraphs according to van
 * Dongen. The clustersizes represent cyclelengths in randomArrays
 * 
 * @author Daniel Delling
 * 
 */

public class DongenClusteredGraph extends RandomClusteredGraph {

	/**
	 * creates a RandomClustergraph according to van Dongen
	 * 
	 * @param g
	 *            the given graph
	 * @param nodes
	 *            number of nodes
	 * @param maxSize
	 *            maximum clusterSize
	 * @param pIn
	 *            probability that an IntraclusterEdge is created
	 * @param pOut
	 *            probability that an InterclusterEdge is created
	 */
	public DongenClusteredGraph(Graph g, int nodes, int maxSize,
			double pIn, double pOut) {
		super(g, PartitionGenerator.generatePermutationPartition(nodes,
				maxSize, 1), pIn, pOut);
	}

	@Override
	public String getID() {
		return "DongenClusterGraph";
	}

}
