/*
 * Created on Oct 7, 2004
 *
 * Copyright 2004.  --- All rights reserved. 
 * Algorithmic Group, Karlsruhe, Germany.
 */
package de.uka.algo.clustering.index;

import de.uka.algo.clustering.Clustering;

/**
 * @author Bastian Katz
 *  
 */
public final class PerformanceConventional extends Performance { 

	final static String INDEX_ID = "Conventional_Performance";
    protected PerformanceConventional(Clustering clustering) {
        super(clustering);
    }

    public double getValue(double m) {
        return weightPerformance(m, 1, 1);
    }

	public double getUnweightedValue() {
		return unweightedPerformance(1);
	}

	public double getValue() {
        return getValue(getMaxWeight());
    }

    public static class Factory implements IndexFactory {
        public Index getIndex(Clustering cl) {
            return new PerformanceConventional(cl);
        }
        
        @Override
		public String toString() {
            return INDEX_ID;
        }

    }

	@Override
	public String toString() {	
		return INDEX_ID;
	}

}