package de.uka.algo.clustering.visualization;

import java.util.HashMap;

import y.base.Node;
import y.base.NodeCursor;
import y.view.Graph2D;
import de.uka.algo.clustering.Cluster;
import de.uka.algo.clustering.Clustering;
import de.uka.algo.graphs.GraphInterpretation;

public class LabelExtractor extends Graph2DFacade implements
		Graph2DExtractor {
	
	public String toString() {
		return "Node Labels";
	}
	
	public Clustering extract(Graph2D graph, boolean useWeights) {
		Clustering result = new Clustering(graph, GraphInterpretation
				.getInterpretation(graph, useWeights));

		HashMap<String, Cluster> hm = new HashMap<String, Cluster>();
		for (NodeCursor nc = graph.nodes(); nc.ok(); nc.next()) {
			Node n = nc.node();
			if (!graph.getHierarchyManager().isNormalNode(n))
				continue;
			String c = (graph.getRealizer(n))
					.getLabelText();
			if (c.equals("")) {
				continue;
			}
			Cluster cl = hm.get(c);
			if (cl == null) {
				cl = result.newCluster(n);
				hm.put(c, cl);
			} else {
				result.add(cl, n);
			}
		}
		result.pool2Singletons();
		return result;
	}

}
