/**
 * Created on Dec 6, 2007
 */
package de.uka.algo.graphs.centralities.betweenness.sampling;

import y.base.Graph;
import y.base.NodeCursor;
import y.base.NodeList;

/**
 * Choose all the nodes of the Graph. This sampling method
 * results in an exact calculation of the betweenness
 * centrality
 * 
 * @author Ulrich Geilmann
 *
 */
public class ExactSampler implements Sampler {

	/* (non-Javadoc)
	 * @see de.uka.algo.clustering.betweenness.util.sampling.Sampler#sample(y.base.Graph)
	 */
	public NodeList sample(Graph g) {
		NodeList l = new NodeList();
		for (NodeCursor c = g.nodes(); c.ok(); c.next())
			l.add(c.node());
		return l;
	}

}
