/**
 * Created on 28.11.2007
 */
package de.uka.algo.graphs.centralities.betweenness.sampling;

import y.base.Graph;
import y.base.NodeList;

/**
 * A Sampler chooses the Nodes to become the roots for the
 * breadth first search to approximate the betweenness centrality.
 * 
 * @author Ulrich Geilmann
 */
public interface Sampler {

	/**
	 * Choose nodes to become the root-nodes for the BFS
	 * @param g
	 * 	The graph to choose the nodes from
	 * @return
	 * 	a NodeList containing the chosen nodes
	 */
	public abstract NodeList sample (Graph g);
	
}
