/*
 * Reviewed 1.6 (Mar 27, 2005)
 *
 * Copyright 2004.  --- All rights reserved. 
 * Algorithmic Group, Karlsruhe, Germany.
 */

package de.uka.algo.graphs.cut;

import de.uka.algo.graphs.GraphInterpretation;
import y.base.Graph;

/**
 * A Cutter is an algorithm cutting a graph.
 * 
 * @author Bastian Katz
 */
public abstract class GraphCutter {

	/**
	 * Performs the algorithm to find a cut of the given graph
	 * 
	 * @see Cut
	 * @param aGraph
	 *            the graph
	 * @return a Cut wrapping a node cursor iterating over the cut's inner nodes
	 */
	public abstract Cut getCut(Graph aGraph);

	/**
	 * Performs the algorithm to find a cut of the given graph
	 * 
	 * @see Cut
	 * @param aGraph
	 *            the graph
	 * @param anInterpretation
	 *            an interpretation of the graph
	 * @return a Cut wrapping a node cursor iterating over the cut's inner nodes
	 */
	public abstract Cut getCut(Graph aGraph, GraphInterpretation anInterpretation);

}