/*
 * Created on May 16, 2004
 * Reviewed 1.4 (Mar 31, 2005)
 *
 * Copyright 2004.  --- All rights reserved. 
 * Algorithmic Group, Karlsruhe, Germany.
 */
package de.uka.algo.graphs.linalg;

import de.uka.algo.graphs.GraphInterpretation;
import de.uka.algo.math.linalg.generic.VectorAdapter;
import y.base.Graph;

/**
 * The class GraphVector is an adapter class wrapping graphs to extend them by
 * some operations of 1D-matrices (vectors). It dynamically changes w/o notice
 * if the graph changes, i. e. adding a node may result in changing the size of
 * the GraphMatrix, changing the node order in permuting the entries.
 * 
 * @author Bastian Katz
 */
public abstract class GraphVector extends VectorAdapter {

    /** the underlying graph */
    protected Graph graph = null;

    /** The graph's interpretation */
    protected GraphInterpretation interpretation = null;

    /**
     * Instantiates a GraphMatrix of the given underlying graph with an interpretation. 
     * 
     * @param aGraph
     *            the graph
     * @param anInterpretation the graph's interpretation
     */
    public GraphVector(Graph aGraph, GraphInterpretation anInterpretation) {
        this.graph = aGraph;
        this.interpretation = anInterpretation;
    }
}