/*
 * Created on Oct 19, 2005
 *
 * Copyright 2005. --- All rights resevered. 
 * Algorithmic Group, Karlsruhe, Germany.
 * 
 * project: graphclustering
 * package: de.uka.algo.graphs.linalg
 */
package de.uka.algo.graphs.linalg;

import java.util.Iterator;

import de.uka.algo.math.linalg.generic.Cell2D;

/**
 * This class represents the transposed matrix of a given graph matrix.
 * 
 * Note that the class have not been tested extensively!
 * 
 * @author Marco Gaertler
 * 
 */
public class TransposedGraphMatrix extends GraphMatrix {

	GraphMatrix original;

	public TransposedGraphMatrix(GraphMatrix other) {
		super(other);
		original = other;
		if (prohibitedEV != null)
			prohibitedEV.clear();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see de.uka.algo.math.linalg.matrix.MatrixAdapter#rows()
	 */
	@Override
	public int rows() {
		return original.columns();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see de.uka.algo.math.linalg.matrix.MatrixAdapter#columns()
	 */
	@Override
	public int columns() {
		return original.rows();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see de.uka.algo.math.linalg.matrix.MatrixAdapter#get(int, int)
	 */
	@Override
	public double get(int row, int column) throws IndexOutOfBoundsException {
		return original.get(column, row);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see de.uka.algo.math.linalg.MatrixAdapter#nonZeros()
	 */
	@Override
	public Iterator<Cell2D> nonZeros() {
		final Iterator<Cell2D> iter = original.nonZeros();
		return new Iterator<Cell2D>() {
			public Cell2D next() {
				Cell2D current = new Cell2D(iter.next());
				current.transpose();
				return current;
			}

			public boolean hasNext() {
				return iter.hasNext();
			}

			public void remove() {
				throw new UnsupportedOperationException();

			}
		};
	}
}
