(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 7.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[    197040,       4450]
NotebookOptionsPosition[    191805,       4295]
NotebookOutlinePosition[    192250,       4314]
CellTagsIndexPosition[    192207,       4311]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.4952766933272743`*^9, 3.4952766955097723`*^9}}],

Cell[BoxData[{
 RowBox[{"<<", "PlotLegends`"}], "\[IndentingNewLine]", 
 RowBox[{"Needs", "[", "\"\<JLink`\>\"", "]"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.454157490325989*^9, 3.454157490652544*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"AutoGeneratedPackage", "\[Rule]", "Automatic"}], ";"}]], "Input",
 CellChangeTimes->{{3.452415769608761*^9, 3.452415774822329*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"cp", " ", "=", " ", 
   RowBox[{"StringReplace", "[", 
    RowBox[{
    "\"\<$ROOT/dynamicClustering/bin/:./libs/lpsolve55j.jar:$ROOT/base/:$ROOT/\
extension/:$ROOT/DynamicGraphGenerator/bin/:$ROOT/utils/:$ROOT/Javalibs/algo-\
common.jar:$ROOT/Javalibs/AppFramework.jar:$ROOT/Javalibs/avalon-framework.\
jar:$ROOT/Javalibs/batik-all.jar:$ROOT/Javalibs/batik.jar:$ROOT/Javalibs/\
buttonpanel.jar:$ROOT/Javalibs/collections-generic.jar:$ROOT/Javalibs/colt.\
jar:$ROOT/Javalibs/commons-cli.jar:$ROOT/Javalibs/commons-collections.jar:$\
ROOT/Javalibs/commons-configuration.jar:$ROOT/Javalibs/commons-io.jar:$ROOT/\
Javalibs/commons-lang.jar:$ROOT/Javalibs/commons-logging.jar:$ROOT/Javalibs/\
concurrent.jar:$ROOT/Javalibs/cplex.jar:$ROOT/Javalibs/fop.jar:$ROOT/Javalibs/\
gettext-commons.jar:$ROOT/Javalibs/gnu-bytecode.jar:$ROOT/Javalibs/graphml.\
jar:$ROOT/Javalibs/j3daudio.jar:$ROOT/Javalibs/j3dcore.jar:$ROOT/Javalibs/\
j3dutils.jar:$ROOT/Javalibs/jcommon.jar:$ROOT/Javalibs/jfreechart.jar:$ROOT/\
Javalibs/jmp.jar:$ROOT/Javalibs/joost.jar:$ROOT/Javalibs/jung-1.7.2.jar:$ROOT/\
Javalibs/junit.jar:$ROOT/Javalibs/l2fprod-common-tasks.jar:$ROOT/Javalibs/\
log4j-1.2.12.jar:$ROOT/Javalibs/lpsolve.jar:$ROOT/Javalibs/lpsolve55j.jar:$\
ROOT/Javalibs/mysql-connector-java-3.1.8-bin.jar:$ROOT/Javalibs/mysql-\
connector-java.jar:$ROOT/Javalibs/opencsv.jar:$ROOT/Javalibs/serializer.jar:$\
ROOT/Javalibs/swing-layout.jar:$ROOT/Javalibs/swing-worker.jar:$ROOT/Javalibs/\
swingx-2006_07_20.jar:$ROOT/Javalibs/vecmath.jar:$ROOT/Javalibs/xalan.jar:$\
ROOT/Javalibs/xercesImpl.jar:$ROOT/Javalibs/xmlgraphics-commons.jar:$ROOT/\
Javalibs/xnap-commons.jar:$ROOT/Javalibs/y.jar:$ROOT/Javalibs/yed-lite-1.5.\
jar:$ROOT/Javalibs/yed-lite.jar:$ROOT/Javalibs/yed.jar:$ROOT/Javalibs/yguard.\
jar:$ROOT/Javalibs/ysvg.jar:$ROOT/Javalibs/ywmf.jar:/sw/linux/cplex111/\
cplex111/lib/cplex.jar\>\"", ",", 
     RowBox[{"\"\<$ROOT\>\"", "\[Rule]", 
      RowBox[{
      "$HomeDirectory", " ", "<>", " ", 
       "\"\</clusteringWorkspaceTest\>\""}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.495276465922615*^9, 3.495276471807674*^9}}],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"RefreshJava", "[", "]"}], " ", ":=", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
     "commandLine", " ", "=", " ", 
      "\"\<java \
-Djava.library.path=/sw/linux/cplex111/cplex111/bin/x86-64_debian4.0_4.1/\>\"\
"}], ";", "\[IndentingNewLine]", 
     RowBox[{"ReinstallJava", "[", 
      RowBox[{
       RowBox[{"CommandLine", "\[Rule]", "commandLine"}], ",", " ", 
       RowBox[{"ClassPath", "\[Rule]", "cp"}]}], "]"}], ";"}], 
    "\[IndentingNewLine]", ")"}]}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.447174761124178*^9, 3.447174766946126*^9}, {
   3.447174799116618*^9, 3.447174837653049*^9}, {3.447174916627578*^9, 
   3.447174931667047*^9}, 3.447175187161536*^9, {3.44717534059626*^9, 
   3.447175341006271*^9}, {3.4471755633083363`*^9, 3.447175620136756*^9}, {
   3.447257372622566*^9, 3.44725737972992*^9}, {3.449919640111745*^9, 
   3.449919647049428*^9}, {3.4499910928718977`*^9, 3.4499911120776587`*^9}, {
   3.449991182620713*^9, 3.449991185902317*^9}, {3.4499927524532003`*^9, 
   3.4499927564788923`*^9}, {3.449992816864429*^9, 3.449992820194133*^9}, {
   3.449992878443159*^9, 3.4499928815296803`*^9}, {3.4499929910814753`*^9, 
   3.449993032812194*^9}, {3.4499931313708277`*^9, 3.44999313396161*^9}, {
   3.4500986946380787`*^9, 3.450098707988078*^9}, 3.4500988606609697`*^9, {
   3.450181997510249*^9, 3.450181997802948*^9}, {3.450425167443362*^9, 
   3.450425169446677*^9}, {3.450431281675249*^9, 3.4504312977439938`*^9}, {
   3.450431542837304*^9, 3.4504315542387238`*^9}, {3.450431595314699*^9, 
   3.4504315986863337`*^9}, {3.4504316784308987`*^9, 3.450431682289762*^9}, {
   3.450432924889942*^9, 3.45043295697278*^9}, {3.4504381971609917`*^9, 
   3.450438197416296*^9}, {3.4511103722681713`*^9, 3.4511104270466423`*^9}, {
   3.451110709662282*^9, 3.451110735979937*^9}, {3.4511107946410103`*^9, 
   3.451110795694563*^9}, {3.451111048908556*^9, 3.451111076985467*^9}, {
   3.451111634079669*^9, 3.4511116445444736`*^9}, {3.451111760920608*^9, 
   3.451111834129294*^9}, {3.451113829464677*^9, 3.451113829869355*^9}, {
   3.453628246332438*^9, 3.4536282526731787`*^9}, {3.453793659169979*^9, 
   3.453793698592939*^9}, {3.453796915450136*^9, 3.45379693154932*^9}, {
   3.4537970095826883`*^9, 3.453797034627626*^9}, {3.453797080228717*^9, 
   3.453797088959638*^9}, {3.453797441640904*^9, 3.453797581956881*^9}, {
   3.45388332011805*^9, 3.453883331623927*^9}, {3.4538843787675543`*^9, 
   3.4538844071808863`*^9}, {3.453885455218705*^9, 3.453885476529008*^9}, {
   3.453885875857749*^9, 3.4538859009022617`*^9}, {3.453888082604404*^9, 
   3.453888091602549*^9}, {3.453888271171589*^9, 3.4538882715689793`*^9}, {
   3.4538885744237432`*^9, 3.4538886041172028`*^9}, {3.453888645851*^9, 
   3.453888653918611*^9}, {3.453888799145042*^9, 3.453888802783432*^9}, {
   3.4538890333914013`*^9, 3.45388904434172*^9}, {3.453970995854595*^9, 
   3.453971001362088*^9}, {3.453974576753031*^9, 3.453974578766137*^9}, {
   3.453976121234303*^9, 3.453976183664352*^9}, {3.453977207250311*^9, 
   3.453977208912054*^9}, 3.453977247519973*^9, {3.4539841322725973`*^9, 
   3.4539841381182003`*^9}, {3.4539847608114758`*^9, 
   3.4539847979305973`*^9}, {3.453984916546425*^9, 3.453984917597385*^9}, {
   3.4539849713019323`*^9, 3.453984983074889*^9}, 3.453985748638741*^9, 
   3.453985848157455*^9, {3.4540563935229893`*^9, 3.454056395219021*^9}, {
   3.454153352167131*^9, 3.454153352525552*^9}, {3.45415574817804*^9, 
   3.454155779934325*^9}, {3.4541573819060097`*^9, 3.454157442453836*^9}, 
   3.454157476929741*^9}],

Cell[BoxData[
 RowBox[{"RefreshJava", "[", "]"}]], "Input",
 CellChangeTimes->{{3.454161173017482*^9, 3.454161176073903*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "WORKAROUND", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"StartEvaluation", "[", "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"runCommand", " ", "=", " ", 
      RowBox[{"StringReplace", "[", 
       RowBox[{
       "\"\<java -cp $CLASSPATH$ -Djava.library.path=$LIBPATH$ \
-Xmx$MEMORY$m\>\"", ",", " ", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"\"\<$CLASSPATH$\>\"", " ", "\[Rule]", " ", "cp"}], ",", 
          " ", "\[IndentingNewLine]", " ", 
          RowBox[{
          "\"\<$LIBPATH$\>\"", " ", "\[Rule]", " ", 
           "\"\</sw/linux/cplex111/cplex111/bin/x86-64_debian4.0_4.1/\>\""}], 
          ",", " ", 
          RowBox[{"\"\<$MEMORY$\>\"", "\[Rule]", 
           RowBox[{"ToString", "[", "Memory", "]"}]}]}], "}"}]}], "]"}]}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{
     "bin", " ", "=", " ", 
      "\"\<de.uka.algo.dynclustering.eval.StartEvaluation\>\""}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Return", "[", 
      RowBox[{"Run", "[", 
       RowBox[{
       "runCommand", ",", " ", "bin", ",", " ", "argPath", ",", " ", 
        "resultPath"}], "]"}], "]"}], ";"}], "\[IndentingNewLine]", 
    ")"}]}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4540693432706957`*^9, 3.454069633513152*^9}, {
   3.454069667347196*^9, 3.45406972344232*^9}, {3.454069854522101*^9, 
   3.454069907668397*^9}, {3.454069946652492*^9, 3.454069995498914*^9}, {
   3.454070041520093*^9, 3.454070047226308*^9}, {3.454157172325603*^9, 
   3.454157232106073*^9}, {3.4541572992824574`*^9, 3.454157326173712*^9}, 
   3.454157376598084*^9, 3.454157543536633*^9, 3.454159925212327*^9, {
   3.4541605582225323`*^9, 3.4541605626598873`*^9}, 3.45416060238008*^9, {
   3.4541607757908087`*^9, 3.454160776259719*^9}, {3.454308248069723*^9, 
   3.454308344423587*^9}, {3.454309156483232*^9, 3.454309157210918*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"algoSelect", " ", "=", " ", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\"\<StaticNewman\>\"", ",", " ", 
       RowBox[{"Checkbox", "[", 
        RowBox[{"Dynamic", "[", "useStaticNewman", "]"}], "]"}]}], "}"}], ",",
      "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<StaticNewman2\>\"", ",", " ", 
       RowBox[{"Checkbox", "[", 
        RowBox[{"Dynamic", "[", "useStaticNewman2", "]"}], "]"}]}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<Newman\>\"", ",", " ", 
       RowBox[{"Checkbox", "[", 
        RowBox[{"Dynamic", "[", "useNewman", "]"}], "]"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<Newman2\>\"", ",", " ", 
       RowBox[{"Checkbox", "[", 
        RowBox[{"Dynamic", "[", "useNewman2", "]"}], "]"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<StaticBlondel\>\"", ",", " ", 
       RowBox[{"Checkbox", "[", 
        RowBox[{"Dynamic", "[", "useStaticBlondel", "]"}], "]"}]}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<TDStaticBlondel\>\"", ",", " ", 
       RowBox[{"Checkbox", "[", 
        RowBox[{"Dynamic", "[", "useTDStaticBlondel", "]"}], "]"}]}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<Blondel\>\"", ",", " ", 
       RowBox[{"Checkbox", "[", 
        RowBox[{"Dynamic", "[", "useBlondel", "]"}], "]"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<PartialILP\>\"", ",", " ", 
       RowBox[{"Checkbox", "[", 
        RowBox[{"Dynamic", "[", "usePartialILP", "]"}], "]"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<EOO\>\"", ",", " ", 
       RowBox[{"Checkbox", "[", 
        RowBox[{"Dynamic", "[", "useEOO", "]"}], "]"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<Randomly\>\"", ",", " ", 
       RowBox[{"Checkbox", "[", 
        RowBox[{"Dynamic", "[", "useRandomly", "]"}], "]"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<Reference\>\"", ",", " ", 
       RowBox[{"Checkbox", "[", 
        RowBox[{"Dynamic", "[", "useReference", "]"}], "]"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<Singleton\>\"", ",", " ", 
       RowBox[{"Checkbox", "[", 
        RowBox[{"Dynamic", "[", "useSingleton", "]"}], "]"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<1-Clustering\>\"", ",", " ", 
       RowBox[{"Checkbox", "[", 
        RowBox[{"Dynamic", "[", "useOneClustering", "]"}], "]"}]}], "}"}]}], 
    "\[IndentingNewLine]", "}"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4469884443495483`*^9, 3.446988475460627*^9}, {
   3.446988518701371*^9, 3.446988551547059*^9}, {3.4469886504142*^9, 
   3.446988703306451*^9}, {3.446988745493877*^9, 3.4469887471951303`*^9}, {
   3.4469887885342607`*^9, 3.446988824659626*^9}, {3.446989166244516*^9, 
   3.4469891811403713`*^9}, {3.4471758007423897`*^9, 
   3.4471758257575207`*^9}, {3.447255064537943*^9, 3.447255069856052*^9}, {
   3.447257196522147*^9, 3.4472571983196487`*^9}, {3.4472582792904053`*^9, 
   3.447258318154427*^9}, 3.447258533821816*^9, {3.4472614319337797`*^9, 
   3.4472614437027493`*^9}, {3.447515139945167*^9, 3.4475151537429867`*^9}, {
   3.4475153735473633`*^9, 3.447515376111176*^9}, {3.447568629014229*^9, 
   3.4475686665800056`*^9}, {3.447599106758422*^9, 3.447599109054492*^9}, {
   3.449386414890723*^9, 3.449386431916206*^9}, {3.453615801713572*^9, 
   3.453615806239325*^9}, {3.453622906641122*^9, 3.453622927681758*^9}, 
   3.453622970906084*^9, {3.4951807665063543`*^9, 3.4951807966993933`*^9}, {
   3.495181243358535*^9, 3.495181243612154*^9}, {3.495181605101924*^9, 
   3.4951816051345654`*^9}, {3.495266450230319*^9, 3.4952664503013783`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"qISelect", " ", "=", " ", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\"\<Modularity\>\"", ",", " ", 
       RowBox[{"Checkbox", "[", 
        RowBox[{"Dynamic", "[", "useModularity", "]"}], "]"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<Coverage\>\"", ",", " ", 
       RowBox[{"Checkbox", "[", 
        RowBox[{"Dynamic", "[", "useCoverage", "]"}], "]"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<Sig. Cov.\>\"", ",", " ", 
       RowBox[{"Checkbox", "[", 
        RowBox[{"Dynamic", "[", "useSignificanceCoverage", "]"}], "]"}]}], 
      "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<Performance\>\"", ",", " ", 
       RowBox[{"Checkbox", "[", 
        RowBox[{"Dynamic", "[", "usePerformance", "]"}], "]"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<Sig. Perf.\>\"", ",", " ", 
       RowBox[{"Checkbox", "[", 
        RowBox[{"Dynamic", "[", "useSignificancePerformance", "]"}], "]"}]}], 
      "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<InterCC\>\"", ",", " ", 
       RowBox[{"Checkbox", "[", 
        RowBox[{"Dynamic", "[", "useInterClusterConductance", "]"}], "]"}]}], 
      "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<IntraCC\>\"", ",", " ", 
       RowBox[{"Checkbox", "[", 
        RowBox[{"Dynamic", "[", "useIntraClusterConductance", "]"}], "]"}]}], 
      "}"}]}], "\[IndentingNewLine]", "}"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4471776210715017`*^9, 3.447177669735581*^9}, {
  3.447177804479273*^9, 3.4471778490845747`*^9}, {3.447177887928678*^9, 
  3.447177907245152*^9}, {3.447178714047613*^9, 3.447178752805924*^9}, {
  3.447569543659616*^9, 3.4475695476749163`*^9}, {3.447569951318329*^9, 
  3.44756996736275*^9}, {3.447570325293251*^9, 3.447570342298038*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"dMSelect", " ", "=", " ", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\"\<Rand\>\"", ",", " ", 
       RowBox[{"Checkbox", "[", 
        RowBox[{"Dynamic", "[", "useRand", "]"}], "]"}], ",", " ", 
       RowBox[{"Checkbox", "[", 
        RowBox[{"Dynamic", "[", "useGraphRand", "]"}], "]"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<Jaccard\>\"", ",", " ", 
       RowBox[{"Checkbox", "[", 
        RowBox[{"Dynamic", "[", "useJaccard", "]"}], "]"}], ",", " ", 
       RowBox[{"Checkbox", "[", 
        RowBox[{"Dynamic", "[", "useGraphJaccard", "]"}], "]"}]}], "}"}], ",",
      "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<Fowlkes Mallows\>\"", ",", " ", 
       RowBox[{"Checkbox", "[", 
        RowBox[{"Dynamic", "[", "useFowlkesMallows", "]"}], "]"}], ",", " ", 
       RowBox[{"Checkbox", "[", 
        RowBox[{"Dynamic", "[", "useFowlkesMallowsGraph", "]"}], "]"}]}], 
      "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<Fred Jain\>\"", ",", " ", 
       RowBox[{"Checkbox", "[", 
        RowBox[{"Dynamic", "[", "useFredJain", "]"}], "]"}], ",", " ", 
       RowBox[{"Checkbox", "[", 
        RowBox[{"Dynamic", "[", "useFredJainGraph", "]"}], "]"}]}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<Maximum Match\>\"", ",", " ", 
       RowBox[{"Checkbox", "[", 
        RowBox[{"Dynamic", "[", "useMaximumMatch", "]"}], "]"}], ",", " ", 
       RowBox[{"Checkbox", "[", 
        RowBox[{"Dynamic", "[", "useMaximumMatchGraph", "]"}], "]"}]}], 
      "}"}]}], "\[IndentingNewLine]", "}"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.447178774817444*^9, 3.4471788229106894`*^9}, {
  3.447178904312675*^9, 3.447178921997449*^9}, {3.447341716105744*^9, 
  3.4473417291299553`*^9}, {3.447581758108296*^9, 3.447581768626833*^9}, {
  3.4475830155889463`*^9, 3.447583021692684*^9}, {3.447599021431033*^9, 
  3.447599050078814*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"algoSelectPanel", " ", "=", 
   RowBox[{"Dynamic", "[", "\[IndentingNewLine]", 
    RowBox[{"Panel", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Text", "@", 
       RowBox[{"Grid", "[", 
        RowBox[{
         RowBox[{"Prepend", "[", 
          RowBox[{"algoSelect", ",", 
           RowBox[{"{", 
            RowBox[{"\"\<algorithm\>\"", ",", "\"\<use\>\""}], "}"}]}], "]"}],
          ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"None", ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"Lighter", "[", 
               RowBox[{"Yellow", ",", ".9"}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"White", ",", 
                RowBox[{"Lighter", "[", 
                 RowBox[{
                  RowBox[{"Blend", "[", 
                   RowBox[{"{", 
                    RowBox[{"Blue", ",", "Green"}], "}"}], "]"}], ",", ".8"}],
                  "]"}]}], "}"}]}], "}"}]}], "}"}]}], ",", 
         RowBox[{"Dividers", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"Darker", "[", 
               RowBox[{"Gray", ",", ".6"}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"Lighter", "[", 
                RowBox[{"Gray", ",", ".5"}], "]"}], "}"}], ",", 
              RowBox[{"Darker", "[", 
               RowBox[{"Gray", ",", ".6"}], "]"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"Darker", "[", 
               RowBox[{"Gray", ",", ".6"}], "]"}], ",", 
              RowBox[{"Darker", "[", 
               RowBox[{"Gray", ",", ".6"}], "]"}], ",", 
              RowBox[{"{", "False", "}"}], ",", 
              RowBox[{"Darker", "[", 
               RowBox[{"Gray", ",", ".6"}], "]"}]}], "}"}]}], "}"}]}], ",", 
         RowBox[{"Alignment", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"{", 
            RowBox[{"Left", ",", "Right", ",", 
             RowBox[{"{", "Left", "}"}]}], "}"}], "}"}]}], ",", 
         RowBox[{"ItemSize", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"{", 
            RowBox[{"10", ",", "3", ",", "5", ",", "5"}], "}"}], "}"}]}], ",", 
         RowBox[{"Frame", "\[Rule]", 
          RowBox[{"Darker", "[", 
           RowBox[{"Gray", ",", ".6"}], "]"}]}], ",", 
         RowBox[{"ItemStyle", "\[Rule]", "14"}], ",", 
         RowBox[{"Spacings", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"Automatic", ",", ".8"}], "}"}]}]}], "]"}]}], 
      "\[IndentingNewLine]", "\"\< Algorithms \\n\>\""}], "]"}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.446988415642858*^9, 3.4469884319740057`*^9}, {
   3.4469884872821293`*^9, 3.446988502910985*^9}, {3.446988585537299*^9, 
   3.446988594032486*^9}, {3.446988725072123*^9, 3.4469887347901287`*^9}, {
   3.446989201235421*^9, 3.446989217469812*^9}, 3.44717758572164*^9, {
   3.450452197507868*^9, 3.450452205925312*^9}, {3.450452343925332*^9, 
   3.450452346707387*^9}, 3.45045323456503*^9},
 CellID->1897771943],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"qIPanel", " ", "=", " ", 
    RowBox[{"Dynamic", "[", "\[IndentingNewLine]", 
     RowBox[{"Panel", "[", 
      RowBox[{
       RowBox[{"Text", "@", 
        RowBox[{"Grid", "[", 
         RowBox[{
          RowBox[{"Prepend", "[", 
           RowBox[{"qISelect", ",", 
            RowBox[{"{", 
             RowBox[{"\"\<Quality Indices\>\"", ",", "\"\<use\>\""}], "}"}]}],
            "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"None", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Lighter", "[", 
                RowBox[{"Yellow", ",", ".9"}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"White", ",", 
                 RowBox[{"Lighter", "[", 
                  RowBox[{
                   RowBox[{"Blend", "[", 
                    RowBox[{"{", 
                    RowBox[{"Blue", ",", "Green"}], "}"}], "]"}], ",", ".8"}],
                   "]"}]}], "}"}]}], "}"}]}], "}"}]}], ",", 
          RowBox[{"Dividers", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Darker", "[", 
                RowBox[{"Gray", ",", ".6"}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"Lighter", "[", 
                 RowBox[{"Gray", ",", ".5"}], "]"}], "}"}], ",", 
               RowBox[{"Darker", "[", 
                RowBox[{"Gray", ",", ".6"}], "]"}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Darker", "[", 
                RowBox[{"Gray", ",", ".6"}], "]"}], ",", 
               RowBox[{"Darker", "[", 
                RowBox[{"Gray", ",", ".6"}], "]"}], ",", 
               RowBox[{"{", "False", "}"}], ",", 
               RowBox[{"Darker", "[", 
                RowBox[{"Gray", ",", ".6"}], "]"}]}], "}"}]}], "}"}]}], ",", 
          RowBox[{"Alignment", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"{", 
             RowBox[{"Left", ",", "Right", ",", 
              RowBox[{"{", "Left", "}"}]}], "}"}], "}"}]}], ",", 
          RowBox[{"ItemSize", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"{", 
             RowBox[{"10", ",", "3", ",", "5", ",", "5"}], "}"}], "}"}]}], 
          ",", 
          RowBox[{"Frame", "\[Rule]", 
           RowBox[{"Darker", "[", 
            RowBox[{"Gray", ",", ".6"}], "]"}]}], ",", 
          RowBox[{"ItemStyle", "\[Rule]", "14"}], ",", 
          RowBox[{"Spacings", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"Automatic", ",", ".8"}], "}"}]}]}], "]"}]}], 
       "\[IndentingNewLine]", "\"\<Quality Indices \\n\>\""}], "]"}], 
     "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]"}]], "Input",\

 InitializationCell->True,
 CellChangeTimes->{{3.447177551477109*^9, 3.44717758069639*^9}, {
   3.44717769619473*^9, 3.447177724616506*^9}, {3.4471777632094593`*^9, 
   3.4471777633272953`*^9}, {3.447178880289502*^9, 3.447178880848262*^9}, 
   3.450452211277717*^9, {3.4504523375320797`*^9, 3.450452339831841*^9}, {
   3.450453240607215*^9, 3.450453241668725*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"dMPanel", " ", "=", " ", 
   RowBox[{"Dynamic", "[", "\[IndentingNewLine]", 
    RowBox[{"Panel", "[", 
     RowBox[{
      RowBox[{"Text", "@", 
       RowBox[{"Grid", "[", 
        RowBox[{
         RowBox[{"Prepend", "[", 
          RowBox[{"dMSelect", ",", 
           RowBox[{"{", 
            RowBox[{
            "\"\<Distance Measure\>\"", ",", "\"\<N\>\"", ",", "\"\<G\>\""}], 
            "}"}]}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"None", ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"Lighter", "[", 
               RowBox[{"Yellow", ",", ".9"}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"White", ",", 
                RowBox[{"Lighter", "[", 
                 RowBox[{
                  RowBox[{"Blend", "[", 
                   RowBox[{"{", 
                    RowBox[{"Blue", ",", "Green"}], "}"}], "]"}], ",", ".8"}],
                  "]"}]}], "}"}]}], "}"}]}], "}"}]}], ",", 
         RowBox[{"Dividers", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"Darker", "[", 
               RowBox[{"Gray", ",", ".6"}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"Lighter", "[", 
                RowBox[{"Gray", ",", ".5"}], "]"}], "}"}], ",", 
              RowBox[{"Darker", "[", 
               RowBox[{"Gray", ",", ".6"}], "]"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"Darker", "[", 
               RowBox[{"Gray", ",", ".6"}], "]"}], ",", 
              RowBox[{"Darker", "[", 
               RowBox[{"Gray", ",", ".6"}], "]"}], ",", 
              RowBox[{"{", "False", "}"}], ",", 
              RowBox[{"Darker", "[", 
               RowBox[{"Gray", ",", ".6"}], "]"}]}], "}"}]}], "}"}]}], ",", 
         RowBox[{"Alignment", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"{", 
            RowBox[{"Left", ",", "Right", ",", 
             RowBox[{"{", "Left", "}"}]}], "}"}], "}"}]}], ",", 
         RowBox[{"ItemSize", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"{", 
            RowBox[{"10", ",", "3", ",", "5", ",", "5"}], "}"}], "}"}]}], ",", 
         RowBox[{"Frame", "\[Rule]", 
          RowBox[{"Darker", "[", 
           RowBox[{"Gray", ",", ".6"}], "]"}]}], ",", 
         RowBox[{"ItemStyle", "\[Rule]", "14"}], ",", 
         RowBox[{"Spacings", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"Automatic", ",", ".8"}], "}"}]}]}], "]"}]}], 
      "\[IndentingNewLine]", "\"\<DistanceMeasures \\n\>\""}], "]"}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.447178860340357*^9, 3.447178885233569*^9}, {
   3.4471789459880943`*^9, 3.447178958048725*^9}, {3.447571594811948*^9, 
   3.447571627833148*^9}, 3.4504522139137487`*^9, {3.450452330910804*^9, 
   3.4504523329006357`*^9}, {3.45045324513986*^9, 3.45045324553367*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Partial", " ", "ILP", " ", "Panel"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"partialILPTraversalSize", " ", "=", " ", "10"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"partialILPWeightA", " ", "=", " ", "1.0"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"partialILPWeightB", " ", "=", " ", "1.0"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"partialILPPanel", " ", "=", " ", 
     RowBox[{"Dynamic", "[", "\[IndentingNewLine]", 
      RowBox[{"Panel", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Row", "[", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Column", "[", 
            RowBox[{"{", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"PopupView", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"\"\<LpSolve\>\"", ",", "\"\<Cplex\>\""}], "}"}], 
                ",", " ", 
                RowBox[{"Dynamic", "[", "solver", "]"}]}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"PopupView", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "\"\<Modularity\>\"", ",", " ", "\"\<Performance\>\"", ",", 
                  " ", "\"\<WModularity\>\"", ",", " ", 
                  "\"\<WPerformance\>\""}], "}"}], ",", " ", 
                RowBox[{"Dynamic", "[", "objectiveFunction", "]"}]}], "]"}], 
              ",", "\[IndentingNewLine]", 
              RowBox[{"PopupView", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"\"\<NoMerge\>\"", ",", " ", "\"\<Merge\>\""}], 
                 "}"}], ",", " ", 
                RowBox[{"Dynamic", "[", "partialILPVariant", "]"}]}], "]"}]}],
              "\[IndentingNewLine]", "}"}], "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{"Column", "[", 
            RowBox[{"{", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"PopupView", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "\"\<BreakUp\>\"", ",", "\"\<BoundedNeighborhood\>\"", ",", 
                  "\"\<Neighborhood\>\""}], "}"}], ",", 
                RowBox[{"Dynamic", "[", "partialILPUpdateStrategy", "]"}]}], 
               "]"}], ",", "\[IndentingNewLine]", 
              RowBox[{"PopupView", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "\"\<MultiSourceBFS\>\"", ",", 
                  "\"\<MultiSourcePrioritySearch\>\""}], "}"}], ",", 
                RowBox[{"Dynamic", "[", "partialILPTraversalStrategy", "]"}], 
                ",", 
                RowBox[{"Enabled", "\[Rule]", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "3"}], "}"}], ",", 
                    "partialILPUpdateStrategy"}], "]"}], ",", "True", ",", 
                   "False"}], "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
              RowBox[{"PopupView", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "\"\<Degree\>\"", ",", "\"\<Distance\>\"", ",", 
                  "\"\<DistanceDegree\>\"", ",", " ", 
                  "\"\<DistanceBeforeDegree\>\"", ",", " ", "\"\<Stack\>\""}],
                  "}"}], ",", 
                RowBox[{"Dynamic", "[", "partialILPPriority", "]"}], ",", 
                RowBox[{"Enabled", "\[Rule]", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "3"}], "}"}], ",", 
                    "partialILPUpdateStrategy"}], "]"}], " ", "&&", " ", 
                    RowBox[{
                    "partialILPTraversalStrategy", " ", "\[Equal]", " ", 
                    "2"}]}], ",", "True", ",", "False"}], "]"}]}]}], "]"}], 
              ",", "\[IndentingNewLine]", 
              RowBox[{"Row", "[", 
               RowBox[{"{", "\[IndentingNewLine]", 
                RowBox[{"\"\<Size/Distance\>\"", ",", "\[IndentingNewLine]", 
                 RowBox[{"InputField", "[", 
                  RowBox[{
                   RowBox[{"Dynamic", "[", "partialILPTraversalSize", "]"}], 
                   ",", "Number", ",", 
                   RowBox[{"FieldSize", "\[Rule]", "3"}], ",", 
                   RowBox[{"Enabled", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "3"}], "}"}], ",", 
                    "partialILPUpdateStrategy"}], "]"}], ",", " ", "True", 
                    ",", " ", "False"}], "]"}]}]}], "]"}], ",", 
                 "\[IndentingNewLine]", "\"\<Weight A\>\"", ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"InputField", "[", 
                  RowBox[{
                   RowBox[{"Dynamic", "[", "partialILPWeightA", "]"}], ",", 
                   "Number", ",", 
                   RowBox[{"FieldSize", "\[Rule]", "3"}], ",", 
                   RowBox[{"Enabled", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    "partialILPTraversalStrategy", " ", "\[Equal]", " ", 
                    "2"}], ",", " ", "True", ",", " ", "False"}], "]"}]}]}], 
                  "]"}], ",", "\[IndentingNewLine]", "\"\<Weight B\>\"", ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"InputField", "[", 
                  RowBox[{
                   RowBox[{"Dynamic", "[", "partialILPWeightB", "]"}], ",", 
                   "Number", ",", 
                   RowBox[{"FieldSize", "\[Rule]", "3"}], ",", 
                   RowBox[{"Enabled", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    "partialILPTraversalStrategy", " ", "\[Equal]", " ", 
                    "2"}], ",", " ", "True", ",", " ", "False"}], "]"}]}]}], 
                  "]"}]}], "\[IndentingNewLine]", "}"}], "]"}]}], 
             "\[IndentingNewLine]", "}"}], "]"}]}], "\[IndentingNewLine]", 
          "}"}], "]"}], ",", "\[IndentingNewLine]", "\"\<PartialILP\>\"", ",", 
        RowBox[{"Enabled", "\[Rule]", "usePartialILP"}]}], 
       "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", "]"}]}], 
    ";"}]}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.447176567718114*^9, 3.447176601324294*^9}, {
   3.447176746616168*^9, 3.447176782203117*^9}, {3.447176849245222*^9, 
   3.4471768895066423`*^9}, {3.4471769808448277`*^9, 3.447177035723373*^9}, {
   3.44717711979701*^9, 3.4471771585962553`*^9}, {3.4471772096161947`*^9, 
   3.447177323022561*^9}, {3.4471774949292707`*^9, 3.447177496500862*^9}, {
   3.447179000709152*^9, 3.4471790085978203`*^9}, {3.447179055911358*^9, 
   3.4471791380950108`*^9}, {3.447179202278824*^9, 3.4471792050935802`*^9}, {
   3.447179237055594*^9, 3.447179252438882*^9}, {3.44717928522565*^9, 
   3.4471793416157*^9}, {3.447257704676989*^9, 3.4472577054025707`*^9}, {
   3.447330578908476*^9, 3.447330581160428*^9}, {3.4473317250369377`*^9, 
   3.447331730687451*^9}, {3.447332206540756*^9, 3.447332214776669*^9}, {
   3.447337639643139*^9, 3.447337645874357*^9}, {3.450088835404931*^9, 
   3.450088864730418*^9}, 3.450452217884288*^9, {3.4504523215794573`*^9, 
   3.450452324603492*^9}, {3.450453251260004*^9, 3.4504532514111357`*^9}, {
   3.452409338620027*^9, 3.4524093969133453`*^9}, {3.452410898066362*^9, 
   3.452410903863042*^9}, {3.4529496188087263`*^9, 3.452949624159088*^9}, {
   3.452950654869896*^9, 3.4529507188821898`*^9}, {3.4529507677959843`*^9, 
   3.452950798940538*^9}, {3.452950859029606*^9, 3.452950936756254*^9}, {
   3.4529509926273212`*^9, 3.452951015515883*^9}, {3.4529511977505617`*^9, 
   3.452951212133521*^9}, {3.452952779148857*^9, 3.4529527805242357`*^9}, {
   3.452953475782593*^9, 3.452953494103387*^9}, {3.452953903078616*^9, 
   3.4529539058996563`*^9}, {3.4543257602437267`*^9, 3.454325760999649*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"BLondel", " ", "Panel"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"blondelTraversalSize", " ", "=", " ", "10"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"blondelWeightA", " ", "=", " ", "1.0"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"blondelWeightB", " ", "=", " ", "1.0"}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"blondelPanel", " ", "=", " ", 
     RowBox[{"Dynamic", "[", "\[IndentingNewLine]", 
      RowBox[{"Panel", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Row", "[", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Column", "[", "\[IndentingNewLine]", 
            RowBox[{"{", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"PopupView", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "\"\<Array\>\"", ",", "\"\<InvArray\>\"", ",", " ", 
                  "\"\<Random\>\""}], "}"}], ",", " ", 
                RowBox[{"Dynamic", "[", "nodeOrderStrategy", "]"}]}], "]"}], 
              ",", "\[IndentingNewLine]", 
              RowBox[{"PopupView", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"\"\<Affected\>\"", ",", "\"\<Neigbors\>\""}], "}"}],
                 ",", " ", 
                RowBox[{"Dynamic", "[", "updatePolicy", "]"}]}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"PopupView", "[", 
               RowBox[{
                RowBox[{"{", "\"\<FirstPeak\>\"", "}"}], ",", 
                RowBox[{"Dynamic", "[", "stoppingCriterion", "]"}]}], "]"}], 
              ","}], "\[IndentingNewLine]", "}"}], "\[IndentingNewLine]", 
            "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{"Column", "[", 
            RowBox[{"{", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"PopupView", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "\"\<BreakUp\>\"", ",", "\"\<BoundedNeighborhood\>\"", ",", 
                  "\"\<Neighborhood\>\""}], "}"}], ",", 
                RowBox[{"Dynamic", "[", "blondelUpdateStrategy", "]"}]}], 
               "]"}], ",", "\[IndentingNewLine]", 
              RowBox[{"PopupView", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "\"\<MultiSourceBFS\>\"", ",", 
                  "\"\<MultiSourcePrioritySearch\>\""}], "}"}], ",", 
                RowBox[{"Dynamic", "[", "blondelTraversalStrategy", "]"}], 
                ",", 
                RowBox[{"Enabled", "\[Rule]", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "3"}], "}"}], ",", 
                    "blondelUpdateStrategy"}], "]"}], ",", "True", ",", 
                   "False"}], "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
              RowBox[{"PopupView", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "\"\<Degree\>\"", ",", "\"\<Distance\>\"", ",", 
                  "\"\<DistanceDegree\>\"", ",", " ", 
                  "\"\<DistanceBeforeDegree\>\"", ",", " ", "\"\<Stack\>\""}],
                  "}"}], ",", 
                RowBox[{"Dynamic", "[", "blondelPriority", "]"}], ",", 
                RowBox[{"Enabled", "\[Rule]", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "3"}], "}"}], ",", 
                    "blondelUpdateStrategy"}], "]"}], " ", "&&", " ", 
                    RowBox[{
                    "blondelTraversalStrategy", " ", "\[Equal]", " ", "2"}]}],
                    ",", "True", ",", "False"}], "]"}]}]}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Row", "[", 
               RowBox[{"{", "\[IndentingNewLine]", 
                RowBox[{"\"\<Size/Distance\>\"", ",", "\[IndentingNewLine]", 
                 RowBox[{"InputField", "[", 
                  RowBox[{
                   RowBox[{"Dynamic", "[", "blondelTraversalSize", "]"}], ",",
                    "Number", ",", 
                   RowBox[{"FieldSize", "\[Rule]", "3"}], ",", 
                   RowBox[{"Enabled", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "3"}], "}"}], ",", 
                    "blondelUpdateStrategy"}], "]"}], ",", " ", "True", ",", 
                    " ", "False"}], "]"}]}]}], "]"}], ",", 
                 "\[IndentingNewLine]", "\"\<Weight A\>\"", ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"InputField", "[", 
                  RowBox[{
                   RowBox[{"Dynamic", "[", "blondelWeightA", "]"}], ",", 
                   "Number", ",", 
                   RowBox[{"FieldSize", "\[Rule]", "3"}], ",", 
                   RowBox[{"Enabled", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    "blondelTraversalStrategy", " ", "\[Equal]", " ", "2"}], 
                    ",", " ", "True", ",", " ", "False"}], "]"}]}]}], "]"}], 
                 ",", "\[IndentingNewLine]", "\"\<Weight B\>\"", ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"InputField", "[", 
                  RowBox[{
                   RowBox[{"Dynamic", "[", "blondelWeightB", "]"}], ",", 
                   "Number", ",", 
                   RowBox[{"FieldSize", "\[Rule]", "3"}], ",", 
                   RowBox[{"Enabled", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    "blondelTraversalStrategy", " ", "\[Equal]", " ", "2"}], 
                    ",", " ", "True", ",", " ", "False"}], "]"}]}]}], "]"}]}],
                 "\[IndentingNewLine]", "}"}], "]"}]}], "\[IndentingNewLine]",
              "}"}], "]"}]}], "\[IndentingNewLine]", "}"}], "]"}], ",", 
        "\[IndentingNewLine]", "\"\<Blondel\>\"", ",", "\[IndentingNewLine]", 
        
        RowBox[{"Enabled", "\[Rule]", "useBlondel"}]}], "\[IndentingNewLine]",
        "]"}], "\[IndentingNewLine]", "]"}]}], ";"}], 
   "\[IndentingNewLine]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.44733173763048*^9, 3.447331918239168*^9}, {
   3.4473319695383253`*^9, 3.447332019056529*^9}, {3.447507793094718*^9, 
   3.4475077957562523`*^9}, 3.450452220948851*^9, {3.450452312899118*^9, 
   3.4504523161946077`*^9}, {3.4504532556178827`*^9, 3.450453255793745*^9}, {
   3.452949273453474*^9, 3.4529493332881947`*^9}, {3.452949391375494*^9, 
   3.452949391868911*^9}, {3.4529495030162897`*^9, 3.4529495138796577`*^9}, {
   3.45295055015317*^9, 3.452950585891039*^9}, {3.452950821771729*^9, 
   3.4529508269403877`*^9}, {3.452952128865591*^9, 3.452952147911949*^9}, {
   3.452952795511676*^9, 3.452952797141097*^9}, {3.4543257707799788`*^9, 
   3.454325771439273*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Static", " ", "Blondel", " ", "Panel"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"staticBlondelPanel", " ", "=", " ", 
    RowBox[{"Dynamic", "[", "\[IndentingNewLine]", 
     RowBox[{"Panel", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Column", "[", "\[IndentingNewLine]", 
        RowBox[{"{", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"PopupView", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
             "\"\<Array\>\"", ",", "\"\<InvArray\>\"", ",", 
              "\"\<Random\>\""}], "}"}], ",", 
            RowBox[{"Dynamic", "[", "staticNodeOrderStrategy", "]"}]}], "]"}],
           ",", "\[IndentingNewLine]", 
          RowBox[{"PopupView", "[", 
           RowBox[{
            RowBox[{"{", "\"\<firstPeak\>\"", "}"}], ",", 
            RowBox[{"Dynamic", "[", "staticStoppingCriterion", "]"}]}], 
           "]"}]}], "\[IndentingNewLine]", "}"}], "\[IndentingNewLine]", 
        "]"}], ",", "\[IndentingNewLine]", "\"\<Static Blondel\>\"", ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Enabled", "\[Rule]", "useStaticBlondel"}]}], 
      "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", "]"}]}], 
   ";"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.447499284698431*^9, 3.447499387129644*^9}, {
   3.447998741192985*^9, 3.447998767175817*^9}, {3.447998806778219*^9, 
   3.4479988115425587`*^9}, 3.45045222313349*^9, {3.450452306032999*^9, 
   3.450452309081704*^9}, 3.450453259681839*^9, {3.452949545822934*^9, 
   3.452949551102725*^9}, {3.49518116191171*^9, 3.49518116308193*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"TDStaticBlondel", " ", "Panel"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"tDStaticBlondelAlpha", " ", "=", " ", "0.5"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"tDStaticBlondelPanel", " ", "=", " ", 
     RowBox[{"Dynamic", "[", "\[IndentingNewLine]", 
      RowBox[{"Panel", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Column", "[", "\[IndentingNewLine]", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"PopupView", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
              "\"\<Array\>\"", ",", "\"\<InvArray\>\"", ",", 
               "\"\<Random\>\""}], "}"}], ",", 
             RowBox[{
             "Dynamic", "[", "tDStaticBlondelNodeOrderStrategy", "]"}]}], 
            "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{"PopupView", "[", 
            RowBox[{
             RowBox[{"{", "\"\<firstPeak\>\"", "}"}], ",", 
             RowBox[{
             "Dynamic", "[", "tDStaticBlondelStoppingCriterion", "]"}]}], 
            "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{"Row", "[", 
            RowBox[{"{", 
             RowBox[{"\"\< \[Alpha] \>\"", ",", 
              RowBox[{"InputField", "[", 
               RowBox[{
                RowBox[{"Dynamic", "[", "tDStaticBlondelAlpha", "]"}], ",", 
                "Number", ",", 
                RowBox[{"FieldSize", "\[Rule]", "3"}]}], "]"}]}], "}"}], 
            "]"}]}], "\[IndentingNewLine]", "}"}], "\[IndentingNewLine]", 
         "]"}], ",", "\[IndentingNewLine]", "\"\<TDStaticBlondel\>\"", ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Enabled", "\[Rule]", "useTDStaticBlondel"}]}], 
       "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", "]"}]}], 
    ";"}]}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.447499284698431*^9, 3.447499387129644*^9}, {
   3.447998741192985*^9, 3.447998767175817*^9}, {3.447998806778219*^9, 
   3.4479988115425587`*^9}, 3.45045222313349*^9, {3.450452306032999*^9, 
   3.450452309081704*^9}, 3.450453259681839*^9, {3.452949545822934*^9, 
   3.452949551102725*^9}, {3.495180911156909*^9, 3.495181005647122*^9}, {
   3.495181230785788*^9, 3.49518124247235*^9}, {3.4951814223938828`*^9, 
   3.495181520878706*^9}, {3.495181563463867*^9, 3.495181568286652*^9}, {
   3.4951816051878967`*^9, 3.495181605501173*^9}, {3.495266450402926*^9, 
   3.495266458554123*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Newman", " ", "Panel"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"newmanTraversalSize", " ", "=", " ", "10"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"newmanWeightA", " ", "=", " ", "1.0"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"newmanWeightB", " ", "=", " ", "1.0"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"newmanPanel", " ", "=", " ", 
     RowBox[{"Dynamic", "[", "\[IndentingNewLine]", 
      RowBox[{"Panel", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Column", "[", "\[IndentingNewLine]", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"PopupView", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
              "\"\<Backtrack\>\"", ",", "\"\<StonePit\>\"", ",", 
               "\"\<BreakUp\>\"", ",", "\"\<BoundedNeighborhood\>\"", ",", 
               "\"\<Neighborhood\>\""}], "}"}], ",", 
             RowBox[{"Dynamic", "[", "newmanUpdateStrategy", "]"}]}], "]"}], 
           ",", "\[IndentingNewLine]", 
           RowBox[{"PopupView", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
              "\"\<MultiSourceBFS\>\"", ",", 
               "\"\<MultiSourcePrioritySearch\>\""}], "}"}], ",", 
             RowBox[{"Dynamic", "[", "newmanTraversalStrategy", "]"}], ",", 
             RowBox[{"Enabled", "\[Rule]", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"MemberQ", "[", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"4", ",", "5"}], "}"}], ",", 
                  "newmanUpdateStrategy"}], "]"}], ",", "True", ",", 
                "False"}], "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{"PopupView", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
              "\"\<Degree\>\"", ",", "\"\<Distance\>\"", ",", 
               "\"\<DistanceDegree\>\"", ",", " ", 
               "\"\<DistanceBeforeDegree\>\"", ",", " ", "\"\<Stack\>\""}], 
              "}"}], ",", 
             RowBox[{"Dynamic", "[", "newmanPriority", "]"}], ",", 
             RowBox[{"Enabled", "\[Rule]", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"MemberQ", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "5"}], "}"}], ",", 
                   "newmanUpdateStrategy"}], "]"}], " ", "&&", " ", 
                 RowBox[{
                 "newmanTraversalStrategy", " ", "\[Equal]", " ", "2"}]}], 
                ",", "True", ",", "False"}], "]"}]}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Row", "[", 
            RowBox[{"{", "\[IndentingNewLine]", 
             RowBox[{"\"\<Size/Distance\>\"", ",", "\[IndentingNewLine]", 
              RowBox[{"InputField", "[", 
               RowBox[{
                RowBox[{"Dynamic", "[", "newmanTraversalSize", "]"}], ",", 
                "Number", ",", 
                RowBox[{"FieldSize", "\[Rule]", "3"}], ",", 
                RowBox[{"Enabled", "\[Rule]", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"4", ",", "5"}], "}"}], ",", 
                    "newmanUpdateStrategy"}], "]"}], ",", " ", "True", ",", 
                   " ", "False"}], "]"}]}]}], "]"}], ",", 
              "\[IndentingNewLine]", "\"\<Weight A\>\"", ",", 
              "\[IndentingNewLine]", 
              RowBox[{"InputField", "[", 
               RowBox[{
                RowBox[{"Dynamic", "[", "newmanWeightA", "]"}], ",", "Number",
                 ",", 
                RowBox[{"FieldSize", "\[Rule]", "3"}], ",", 
                RowBox[{"Enabled", "\[Rule]", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{
                   "newmanTraversalStrategy", " ", "\[Equal]", " ", "2"}], 
                   ",", " ", "True", ",", " ", "False"}], "]"}]}]}], "]"}], 
              ",", "\[IndentingNewLine]", "\"\<Weight B\>\"", ",", 
              "\[IndentingNewLine]", 
              RowBox[{"InputField", "[", 
               RowBox[{
                RowBox[{"Dynamic", "[", "newmanWeightB", "]"}], ",", "Number",
                 ",", 
                RowBox[{"FieldSize", "\[Rule]", "3"}], ",", 
                RowBox[{"Enabled", "\[Rule]", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{
                   "newmanTraversalStrategy", " ", "\[Equal]", " ", "2"}], 
                   ",", " ", "True", ",", " ", "False"}], "]"}]}]}], "]"}]}], 
             "\[IndentingNewLine]", "}"}], "]"}]}], "\[IndentingNewLine]", 
          "}"}], "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
        "\"\<Newman\>\"", ",", "\[IndentingNewLine]", 
        RowBox[{"Enabled", "\[Rule]", "useNewman"}]}], "\[IndentingNewLine]", 
       "]"}], "\[IndentingNewLine]", "]"}]}], ";"}]}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.448110949587311*^9, 3.448111000539036*^9}, {
   3.448111052141334*^9, 3.448111070146566*^9}, {3.4500888105696783`*^9, 
   3.4500888620586567`*^9}, {3.450088893235547*^9, 3.4500889047530603`*^9}, 
   3.4504522257320967`*^9, {3.4504522598260403`*^9, 3.450452270042123*^9}, {
   3.450453265650588*^9, 3.450453265825244*^9}, {3.4508573481029053`*^9, 
   3.450857366640709*^9}, {3.4508574274804688`*^9, 3.4508576110835733`*^9}, {
   3.450857651239283*^9, 3.450857910332775*^9}, {3.450858159672858*^9, 
   3.45085818617045*^9}, {3.45085822787014*^9, 3.450858235287403*^9}, {
   3.450858271557132*^9, 3.4508583217565517`*^9}, {3.4508583780734*^9, 
   3.4508584522486467`*^9}, {3.450858518100644*^9, 3.450858523823053*^9}, {
   3.450859068977015*^9, 3.450859130150435*^9}, {3.45085916505656*^9, 
   3.450859165697072*^9}, 3.45085919706026*^9, {3.4508737296460257`*^9, 
   3.4508737338580647`*^9}, {3.4514015284561462`*^9, 3.451401582462673*^9}, {
   3.45140242511657*^9, 3.451402426378487*^9}, {3.4514814771822453`*^9, 
   3.451481556743478*^9}, {3.451481645810581*^9, 3.451481657512048*^9}, 
   3.4514817124927187`*^9, 3.45148175586639*^9, {3.45294969914535*^9, 
   3.452949703809449*^9}, 3.454325782976454*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Newman2", " ", "Panel"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"newman2TraversalSize", " ", "=", " ", "10"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"newman2WeightA", " ", "=", " ", "1.0"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"newman2WeightB", " ", "=", " ", "1.0"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"newman2Panel", " ", "=", " ", 
     RowBox[{"Dynamic", "[", "\[IndentingNewLine]", 
      RowBox[{"Panel", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Column", "[", "\[IndentingNewLine]", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"PopupView", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
              "\"\<Backtrack\>\"", ",", "\"\<StonePit\>\"", ",", 
               "\"\<BreakUp\>\"", ",", "\"\<BoundedNeighborhood\>\"", ",", 
               "\"\<Neighborhood\>\""}], "}"}], ",", 
             RowBox[{"Dynamic", "[", "newman2UpdateStrategy", "]"}]}], "]"}], 
           ",", "\[IndentingNewLine]", 
           RowBox[{"PopupView", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
              "\"\<MultiSourceBFS\>\"", ",", 
               "\"\<MultiSourcePrioritySearch\>\""}], "}"}], ",", 
             RowBox[{"Dynamic", "[", "newman2TraversalStrategy", "]"}], ",", 
             RowBox[{"Enabled", "\[Rule]", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"MemberQ", "[", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"4", ",", "5"}], "}"}], ",", 
                  "newman2UpdateStrategy"}], "]"}], ",", "True", ",", 
                "False"}], "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{"PopupView", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
              "\"\<Degree\>\"", ",", "\"\<Distance\>\"", ",", 
               "\"\<DistanceDegree\>\"", ",", " ", 
               "\"\<DistanceBeforeDegree\>\"", ",", " ", "\"\<Stack\>\""}], 
              "}"}], ",", 
             RowBox[{"Dynamic", "[", "newman2Priority", "]"}], ",", 
             RowBox[{"Enabled", "\[Rule]", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"MemberQ", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "5"}], "}"}], ",", 
                   "newman2UpdateStrategy"}], "]"}], " ", "&&", " ", 
                 RowBox[{
                 "newman2TraversalStrategy", " ", "\[Equal]", " ", "2"}]}], 
                ",", "True", ",", "False"}], "]"}]}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Row", "[", 
            RowBox[{"{", "\[IndentingNewLine]", 
             RowBox[{"\"\<Size/Distance\>\"", ",", "\[IndentingNewLine]", 
              RowBox[{"InputField", "[", 
               RowBox[{
                RowBox[{"Dynamic", "[", "newman2TraversalSize", "]"}], ",", 
                "Number", ",", 
                RowBox[{"FieldSize", "\[Rule]", "3"}], ",", 
                RowBox[{"Enabled", "\[Rule]", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"4", ",", "5"}], "}"}], ",", 
                    "newman2UpdateStrategy"}], "]"}], ",", " ", "True", ",", 
                   " ", "False"}], "]"}]}]}], "]"}], ",", 
              "\[IndentingNewLine]", "\"\<Weight A\>\"", ",", 
              "\[IndentingNewLine]", 
              RowBox[{"InputField", "[", 
               RowBox[{
                RowBox[{"Dynamic", "[", "newman2WeightA", "]"}], ",", 
                "Number", ",", 
                RowBox[{"FieldSize", "\[Rule]", "3"}], ",", 
                RowBox[{"Enabled", "\[Rule]", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{
                   "newman2TraversalStrategy", " ", "\[Equal]", " ", "2"}], 
                   ",", " ", "True", ",", " ", "False"}], "]"}]}]}], "]"}], 
              ",", "\[IndentingNewLine]", "\"\<Weight B\>\"", ",", 
              "\[IndentingNewLine]", 
              RowBox[{"InputField", "[", 
               RowBox[{
                RowBox[{"Dynamic", "[", "newman2WeightB", "]"}], ",", 
                "Number", ",", 
                RowBox[{"FieldSize", "\[Rule]", "3"}], ",", 
                RowBox[{"Enabled", "\[Rule]", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{
                   "newman2TraversalStrategy", " ", "\[Equal]", " ", "2"}], 
                   ",", " ", "True", ",", " ", "False"}], "]"}]}]}], "]"}]}], 
             "\[IndentingNewLine]", "}"}], "]"}]}], "\[IndentingNewLine]", 
          "}"}], "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
        "\"\<Newman2\>\"", ",", "\[IndentingNewLine]", 
        RowBox[{"Enabled", "\[Rule]", "useNewman2"}]}], "\[IndentingNewLine]",
        "]"}], "\[IndentingNewLine]", "]"}]}], ";"}]}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.448110949587311*^9, 3.448111000539036*^9}, {
   3.448111052141334*^9, 3.448111070146566*^9}, {3.4500888105696783`*^9, 
   3.4500888620586567`*^9}, {3.450088893235547*^9, 3.4500889047530603`*^9}, 
   3.4504522257320967`*^9, {3.4504522598260403`*^9, 3.450452270042123*^9}, {
   3.450453265650588*^9, 3.450453265825244*^9}, {3.4508573481029053`*^9, 
   3.450857366640709*^9}, {3.4508574274804688`*^9, 3.4508576110835733`*^9}, {
   3.450857651239283*^9, 3.450857910332775*^9}, {3.450858159672858*^9, 
   3.45085818617045*^9}, {3.45085822787014*^9, 3.450858235287403*^9}, {
   3.450858271557132*^9, 3.4508583217565517`*^9}, {3.4508583780734*^9, 
   3.4508584522486467`*^9}, {3.450858518100644*^9, 3.450858523823053*^9}, {
   3.450859068977015*^9, 3.450859130150435*^9}, {3.45085916505656*^9, 
   3.450859165697072*^9}, 3.45085919706026*^9, {3.4508737296460257`*^9, 
   3.4508737338580647`*^9}, {3.4514015284561462`*^9, 3.451401582462673*^9}, {
   3.45140242511657*^9, 3.451402426378487*^9}, {3.4514814771822453`*^9, 
   3.451481556743478*^9}, {3.451481645810581*^9, 3.451481657512048*^9}, 
   3.4514817124927187`*^9, 3.45148175586639*^9, {3.45294969914535*^9, 
   3.452949703809449*^9}, {3.453615635246997*^9, 3.453615670564968*^9}, 
   3.4536157730847883`*^9, 3.453794601098258*^9, 3.454325784466174*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"EOO", " ", "Panel"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"maxOps", " ", "=", " ", "10"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"eooPanel", " ", "=", " ", 
     RowBox[{"Dynamic", "[", "\[IndentingNewLine]", 
      RowBox[{"Panel", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Column", "[", "\[IndentingNewLine]", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"PopupView", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
              "\"\<Optimizer\>\"", ",", "\"\<SimulatedAnnealing\>\"", ",", 
               "\"\<Minimizer\>\""}], "}"}], ",", " ", 
             RowBox[{"Dynamic", "[", "EOOStrategy", "]"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"PopupView", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"\"\<Coverage\>\"", ",", "\"\<Modularity\>\""}], "}"}], 
             ",", " ", 
             RowBox[{"Dynamic", "[", "EOOQI", "]"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Row", "[", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"Checkbox", "[", 
               RowBox[{"Dynamic", "[", "allowMerge", "]"}], "]"}], ",", 
              "\"\<Merge\>\"", ",", 
              RowBox[{"Checkbox", "[", 
               RowBox[{"Dynamic", "[", "allowShift", "]"}], "]"}], ",", 
              "\"\<Shift\>\"", ",", 
              RowBox[{"Checkbox", "[", 
               RowBox[{"Dynamic", "[", "allowSplit", "]"}], "]"}], ",", 
              "\"\<Split\>\""}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{"Row", "[", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"InputField", "[", 
               RowBox[{
                RowBox[{"Dynamic", "[", "maxOps", "]"}], ",", "Number", ",", 
                RowBox[{"FieldSize", "\[Rule]", "3"}]}], "]"}], ",", 
              "\"\< Max Ops\>\""}], "}"}], "]"}]}], "\[IndentingNewLine]", 
          "}"}], "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
        " ", "\"\<EOO\>\"", ",", " ", 
        RowBox[{"Enabled", "\[Rule]", "useEOO"}]}], "\[IndentingNewLine]", 
       "]"}], "\[IndentingNewLine]", "]"}]}], ";"}]}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4493859678639812`*^9, 3.449386033313369*^9}, {
   3.449386080798669*^9, 3.4493861214630203`*^9}, {3.449386178668147*^9, 
   3.44938629292171*^9}, {3.4493863276727962`*^9, 3.449386336159831*^9}, {
   3.449386482762994*^9, 3.449386503194333*^9}, {3.449386543386241*^9, 
   3.449386554752574*^9}, {3.4493873954123297`*^9, 3.4493874115541067`*^9}, {
   3.44938768959221*^9, 3.4493877440054417`*^9}, {3.449388104341646*^9, 
   3.449388162746793*^9}, {3.449485005229616*^9, 3.449485008880782*^9}, 
   3.450452229071251*^9, {3.450452298500681*^9, 3.450452300843096*^9}, 
   3.450453270442904*^9, {3.452949765501937*^9, 3.452949773028808*^9}, {
   3.452950076354163*^9, 3.45295008505497*^9}, {3.452950515240697*^9, 
   3.452950516925618*^9}, 3.4543257855543528`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"main", " ", "panel"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"Memory", " ", "=", " ", "2000"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"timeStepAggregation", " ", "=", " ", "1"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"mainPanel", " ", "=", " ", 
     RowBox[{"Dynamic", "[", "\[IndentingNewLine]", 
      RowBox[{"Panel", "[", "\[IndentingNewLine]", 
       RowBox[{"Column", "[", "\[IndentingNewLine]", 
        RowBox[{"{", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Row", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Slider", "[", 
              RowBox[{
               RowBox[{"Dynamic", "[", "Memory", "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"500", ",", "32000", ",", "500"}], "}"}]}], "]"}], 
             ",", " ", "\"\<Memory: \>\"", ",", " ", 
             RowBox[{"Dynamic", "[", "Memory", "]"}], ",", " ", 
             "\"\< MB  \>\"", ",", " ", "\"\<        \>\"", ",", " ", 
             RowBox[{"InputField", "[", 
              RowBox[{
               RowBox[{"Dynamic", "[", "timeStepAggregation", "]"}], ",", 
               "Number", ",", " ", 
               RowBox[{"FieldSize", "\[Rule]", "3"}]}], "]"}], ",", " ", 
             "\"\< Time Step Aggregation\>\""}], "}"}], " ", "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Row", "[", 
           RowBox[{"{", 
            RowBox[{"\"\<Graph Path: \>\"", ",", " ", 
             RowBox[{"InputField", "[", 
              RowBox[{
               RowBox[{"Dynamic", "[", "graphPath", "]"}], ",", " ", "String",
                ",", " ", 
               RowBox[{"FieldSize", "\[Rule]", "80"}]}], "]"}], ",", " ", 
             RowBox[{"FileNameSetter", "[", 
              RowBox[{"Dynamic", "[", "graphPath", "]"}], "]"}]}], "}"}], 
           "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"Button", "[", 
           RowBox[{"\"\<New Evaluation\>\"", ",", 
            RowBox[{"evalFrontend", "=", 
             RowBox[{"NewEvaluation", "[", "]"}]}]}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Row", "[", "\[IndentingNewLine]", 
           RowBox[{"{", "\[IndentingNewLine]", 
            RowBox[{
            "algoSelectPanel", ",", "\[IndentingNewLine]", "qIPanel", ",", 
             "\[IndentingNewLine]", "dMPanel", ",", "\[IndentingNewLine]", 
             RowBox[{"Column", "[", 
              RowBox[{"{", 
               RowBox[{
               "partialILPPanel", ",", " ", "blondelPanel", ",", " ", 
                "staticBlondelPanel", ",", " ", "tDStaticBlondelPanel", ",", 
                " ", "newmanPanel", ",", " ", "newman2Panel", ",", " ", 
                "eooPanel"}], "}"}], "]"}]}], "\[IndentingNewLine]", "}"}], 
           "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"Button", "[", 
           RowBox[{"\"\<Add Selected\>\"", ",", 
            RowBox[{"AddSelected", "[", "]"}]}], "]"}]}], 
         "\[IndentingNewLine]", "}"}], "\[IndentingNewLine]", "]"}], 
       "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", "]"}]}], 
    ";"}]}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.446988683269013*^9, 3.4469886870404873`*^9}, {
   3.446988941595872*^9, 3.446988988881847*^9}, {3.4469890454805307`*^9, 
   3.44698915913943*^9}, {3.447176609643325*^9, 3.447176612876184*^9}, {
   3.447177433870717*^9, 3.447177434467353*^9}, {3.447177467727099*^9, 
   3.447177486019682*^9}, {3.4471777473482723`*^9, 3.447177753451839*^9}, {
   3.447177948014222*^9, 3.447178110509523*^9}, {3.447178834911344*^9, 
   3.44717883732456*^9}, {3.447179030555937*^9, 3.4471790360370617`*^9}, {
   3.447257482486154*^9, 3.447257485686408*^9}, {3.447261929891324*^9, 
   3.447261943434153*^9}, {3.4472635718904343`*^9, 3.447263576105068*^9}, {
   3.447264686079528*^9, 3.4472646872650747`*^9}, {3.447332026207962*^9, 
   3.447332028799426*^9}, {3.447499439059827*^9, 3.44749944261123*^9}, {
   3.4481110818754663`*^9, 3.448111083402999*^9}, {3.4493000218716793`*^9, 
   3.449300055708427*^9}, {3.4493001598115187`*^9, 3.449300197330255*^9}, {
   3.4493172218812637`*^9, 3.449317233127303*^9}, {3.449317456881531*^9, 
   3.449317468851778*^9}, {3.449386298713217*^9, 3.449386300024891*^9}, {
   3.4493886114288063`*^9, 3.449388613010529*^9}, {3.449397182003433*^9, 
   3.449397203125849*^9}, {3.450451644034951*^9, 3.450451659714736*^9}, {
   3.4504522316697063`*^9, 3.450452236050097*^9}, {3.45045227560229*^9, 
   3.450452282506517*^9}, 3.450453277442109*^9, {3.450453400012547*^9, 
   3.4504534157466717`*^9}, {3.4504534947110023`*^9, 3.450453498849937*^9}, 
   3.450453664393139*^9, {3.451110756502728*^9, 3.451110789972529*^9}, {
   3.451110855814795*^9, 3.45111087726683*^9}, {3.451110928455379*^9, 
   3.451110952372142*^9}, {3.453615681334126*^9, 3.453615683805887*^9}, {
   3.45379759889692*^9, 3.453797623953315*^9}, {3.453895447706565*^9, 
   3.453895451919511*^9}, {3.453976263561108*^9, 3.453976263625877*^9}, {
   3.4539763110586033`*^9, 3.453976440132393*^9}, {3.453976833772794*^9, 
   3.453976834113863*^9}, {3.453976893624591*^9, 3.453976893998541*^9}, {
   3.453977590074048*^9, 3.453977599054501*^9}, {3.453983518392139*^9, 
   3.453983527767241*^9}, 3.4539837865774193`*^9, {3.454155809230996*^9, 
   3.454155809381507*^9}, {3.4541574542173853`*^9, 3.454157454791547*^9}, {
   3.454313332887793*^9, 3.4543133371085253`*^9}, {3.4543133809897013`*^9, 
   3.4543133916404963`*^9}, {3.454404610713431*^9, 3.454404627270048*^9}, {
   3.454404706154395*^9, 3.4544047073935966`*^9}, {3.455447470511215*^9, 
   3.45544756126818*^9}, {3.4554479403735647`*^9, 3.455447978405097*^9}, {
   3.455448278097932*^9, 3.4554483052389812`*^9}, {3.455448345038625*^9, 
   3.455448405521048*^9}, {3.455448455928769*^9, 3.455448504519231*^9}, {
   3.455448624299852*^9, 3.455448637591072*^9}, {3.495181175418537*^9, 
   3.495181180904181*^9}, 3.495181230030776*^9, 3.495181605047678*^9, 
   3.495266458652946*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"NewEvaluation", "[", "]"}], " ", ":=", " ", 
  RowBox[{"(", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"argPath", " ", "=", " ", 
     RowBox[{"StringReplace", "[", 
      RowBox[{"\"\<$ROOT/dynamicClustering/tmp/args.ser\>\"", ",", 
       RowBox[{"\"\<$ROOT\>\"", "->", 
        RowBox[{
        "$HomeDirectory", " ", "<>", " ", 
         "\"\</clusteringWorkspaceTest\>\""}]}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"resultPath", " ", "=", " ", 
     RowBox[{"StringReplace", "[", 
      RowBox[{"\"\<$ROOT/dynamicClustering/tmp/results.ser\>\"", ",", 
       RowBox[{"\"\<$ROOT\>\"", "->", 
        RowBox[{
        "$HomeDirectory", " ", "<>", " ", 
         "\"\</clusteringWorkspaceTest\>\""}]}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"RefreshJava", "[", "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"evalFrontend", " ", "=", " ", 
     RowBox[{
     "JavaNew", "[", 
      "\"\<de.uka.algo.dynclustering.eval.FakeEvaluationFrontend\>\"", 
      "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"Return", "[", "evalFrontend", "]"}], ";"}], 
   "\[IndentingNewLine]", ")"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.449317099523698*^9, 3.449317121526948*^9}, {
   3.449317414584654*^9, 3.449317423124424*^9}, 3.454065750178267*^9, {
   3.4541432748257427`*^9, 3.4541432784067917`*^9}, {3.454309175865966*^9, 
   3.4543091761550503`*^9}, {3.4952767091547956`*^9, 3.495276709327389*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"AddSelected", "[", "]"}], " ", ":=", " ", 
  RowBox[{"(", "\[IndentingNewLine]", 
   RowBox[{"(*", " ", "algos", " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"evalFrontend", "@", 
     RowBox[{"useStaticNewman", "[", "useStaticNewman", "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"evalFrontend", "@", 
     RowBox[{"useStaticNewman2", "[", "useStaticNewman2", "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"evalFrontend", "@", 
     RowBox[{"useNewman", "[", 
      RowBox[{
      "useNewman", ",", " ", "newmanUpdateStrategy", ",", " ", 
       "newmanTraversalStrategy", ",", " ", "newmanPriority", ",", " ", 
       "newmanTraversalSize", ",", " ", "newmanWeightA", ",", " ", 
       "newmanWeightB"}], " ", "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"evalFrontend", "@", 
     RowBox[{"useNewman2", "[", 
      RowBox[{
      "useNewman2", ",", " ", "newman2UpdateStrategy", ",", " ", 
       "newman2TraversalStrategy", ",", " ", "newman2Priority", ",", " ", 
       "newman2TraversalSize", ",", " ", "newman2WeightA", ",", " ", 
       "newman2WeightB"}], " ", "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"evalFrontend", "@", 
     RowBox[{"useStaticBlondel", "[", 
      RowBox[{
      "useStaticBlondel", ",", " ", "staticNodeOrderStrategy", ",", " ", 
       "staticStoppingCriterion"}], "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"evalFrontend", "@", 
     RowBox[{"useTDStaticBlondel", "[", 
      RowBox[{
      "useTDStaticBlondel", ",", " ", "tDStaticBlondelNodeOrderStrategy", ",",
        " ", "tDStaticBlondelStoppingCriterion", ",", " ", 
       "tDStaticBlondelAlpha"}], "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"evalFrontend", "@", 
     RowBox[{"useBlondel", "[", 
      RowBox[{
      "useBlondel", ",", " ", "nodeOrderStrategy", ",", " ", "updatePolicy", 
       ",", " ", "stoppingCriterion", ",", " ", "blondelUpdateStrategy", ",", 
       " ", "blondelTraversalStrategy", ",", "blondelPriority", ",", 
       "blondelTraversalSize", ",", "blondelWeightA", ",", " ", 
       "blondelWeightB"}], "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"evalFrontend", "@", 
     RowBox[{"usePartialILP", "[", 
      RowBox[{
      "usePartialILP", ",", " ", "solver", ",", " ", "objectiveFunction", ",",
        "partialILPVariant", ",", " ", "partialILPUpdateStrategy", ",", " ", 
       "partialILPTraversalStrategy", ",", " ", "partialILPPriority", ",", 
       "partialILPTraversalSize", ",", " ", "partialILPWeightA", ",", " ", 
       "partialILPWeightB"}], "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"evalFrontend", "@", 
     RowBox[{"useEOO", "[", 
      RowBox[{
      "useEOO", ",", "EOOStrategy", ",", "EOOQI", ",", "maxOps", ",", " ", 
       "allowMerge", ",", "allowShift", ",", "allowSplit"}], " ", "]"}]}], 
    ";", "\[IndentingNewLine]", 
    RowBox[{"evalFrontend", "@", 
     RowBox[{"useRandomly", "[", "useRandomly", "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"evalFrontend", "@", 
     RowBox[{"useReference", "[", "useReference", "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"evalFrontend", "@", 
     RowBox[{"useSingleton", "[", "useSingleton", "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"evalFrontend", "@", 
     RowBox[{"useOneClustering", "[", "useOneClustering", "]"}]}], ";", 
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"(*", " ", 
     RowBox[{"NEXT", " ", "TURN"}], " ", "*)"}], "\[IndentingNewLine]", 
    RowBox[{"evalFrontend", "@", 
     RowBox[{"nextTurn", "[", "]"}]}], ";"}], "\[IndentingNewLine]", 
   ")"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4493171480853367`*^9, 3.449317185441905*^9}, {
   3.449317396523067*^9, 3.449317397999078*^9}, {3.4493176553563957`*^9, 
   3.449317655530588*^9}, {3.4493863959464912`*^9, 3.4493864071976013`*^9}, {
   3.4493864536876307`*^9, 3.449386455949399*^9}, {3.4493865212647142`*^9, 
   3.449386577052908*^9}, {3.4493883299602833`*^9, 3.449388331696334*^9}, {
   3.450088954113659*^9, 3.450088956367406*^9}, 3.450859104797077*^9, 
   3.450859167397946*^9, {3.4508597746981783`*^9, 3.450859827880246*^9}, {
   3.4524108276773*^9, 3.452410831507049*^9}, {3.452951901903472*^9, 
   3.452951904467992*^9}, {3.452951963024768*^9, 3.452952018061717*^9}, {
   3.4529535329391127`*^9, 3.4529535758748837`*^9}, {3.452953880120453*^9, 
   3.452953888237105*^9}, {3.452953942815407*^9, 3.452953948132083*^9}, {
   3.453615699021071*^9, 3.453615717650867*^9}, 3.453616147713483*^9, {
   3.453622956503132*^9, 3.453622960916705*^9}, {3.4547608481661253`*^9, 
   3.454760863158208*^9}, 3.454762058349298*^9, {3.495181115086853*^9, 
   3.4951811414635143`*^9}, {3.495181230257929*^9, 3.495181243092792*^9}, {
   3.4951816050567217`*^9, 3.495181605085754*^9}, {3.4952664501155653`*^9, 
   3.495266458887295*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SerializeArgs", "[", "]"}], "\[NonBreakingSpace]", ":=", " ", 
  RowBox[{"(", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"serializer", " ", "=", " ", 
     RowBox[{
     "JavaNew", "[", "\"\<de.uka.algo.dynclustering.eval.Serializer\>\"", 
      "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"serializer", "@", 
     RowBox[{"serializeArgs", "[", 
      RowBox[{"evalFrontend", ",", " ", "argPath"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", ")"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.454143370327325*^9, 3.454143420882403*^9}, {
  3.454143526957625*^9, 3.45414355602985*^9}, {3.454143607429599*^9, 
  3.4541436102214813`*^9}, {3.4541445681492233`*^9, 3.454144579402871*^9}, {
  3.4543091284910793`*^9, 3.454309132727955*^9}, {3.454762211015547*^9, 
  3.454762215661097*^9}, {3.454762515853786*^9, 3.454762521242692*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DeserializeResults", "[", "]"}], " ", ":=", " ", 
  RowBox[{"(", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"serializer", " ", "=", " ", 
     RowBox[{
     "JavaNew", "[", "\"\<de.uka.algo.dynclustering.eval.Serializer\>\"", 
      "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"Return", "[", 
     RowBox[{"serializer", "@", 
      RowBox[{"deserializeResults", "[", "resultPath", "]"}]}], "]"}], ";"}], 
   "\[IndentingNewLine]", ")"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.454153828654304*^9, 3.45415385090254*^9}, {
  3.454159653026862*^9, 3.454159672104495*^9}, {3.454309196890985*^9, 
  3.454309198040012*^9}, {3.454309241825596*^9, 3.454309242984356*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"RunEvaluation", "[", "]"}], ":=", 
  RowBox[{"(", "\[IndentingNewLine]", 
   RowBox[{"(*", " ", "QIs", " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"evalFrontend", "@", 
     RowBox[{"useModularity", "[", "useModularity", "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"evalFrontend", "@", 
     RowBox[{"useCoverage", "[", "useCoverage", "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"evalFrontend", "@", 
     RowBox[{
     "useSignificanceCoverage", "[", "useSignificanceCoverage", "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"evalFrontend", "@", 
     RowBox[{"usePerformance", "[", "usePerformance", "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"evalFrontend", "@", 
     RowBox[{
     "useSignificancePerformance", "[", "useSignificancePerformance", "]"}]}],
     ";", "\[IndentingNewLine]", 
    RowBox[{"evalFrontend", "@", 
     RowBox[{
     "useInterClusterConductance", "[", "useInterClusterConductance", "]"}]}],
     ";", "\[IndentingNewLine]", 
    RowBox[{"evalFrontend", "@", 
     RowBox[{
     "useIntraClusterConductance", "[", "useIntraClusterConductance", "]"}]}],
     ";", "\[IndentingNewLine]", 
    RowBox[{"(*", " ", "DMs", " ", "*)"}], "\[IndentingNewLine]", 
    RowBox[{"evalFrontend", "@", 
     RowBox[{"useRand", "[", 
      RowBox[{"useRand", ",", " ", "useGraphRand"}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"evalFrontend", "@", 
     RowBox[{"useJaccard", "[", 
      RowBox[{"useJaccard", ",", " ", "useGraphJaccard"}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"evalFrontend", "@", 
     RowBox[{"useFowlkesMallows", "[", 
      RowBox[{"useFowlkesMallows", ",", " ", "useFowlkesMallowsGraph"}], 
      "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"evalFrontend", "@", 
     RowBox[{"useFredJain", "[", 
      RowBox[{"useFredJain", ",", " ", "useFredJainGraph"}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"evalFrontend", "@", 
     RowBox[{"useMaximumMatch", "[", 
      RowBox[{"useMaximumMatch", ",", " ", "useMaximumMatchGraph"}], "]"}]}], 
    ";", "\[IndentingNewLine]", 
    RowBox[{"(*", " ", "Graph", " ", "*)"}], "\[IndentingNewLine]", 
    RowBox[{"evalFrontend", "@", 
     RowBox[{"setGraph", "[", "graphPath", "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"evalFrontend", "@", 
     RowBox[{"setTimeStepAggregation", "[", "timeStepAggregation", "]"}]}], 
    ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"(*", " ", "WORKAROUND", " ", "*)"}], "\[IndentingNewLine]", 
    RowBox[{"SerializeArgs", "[", "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"exitCode", " ", "=", " ", 
     RowBox[{"StartEvaluation", "[", "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"success", " ", "=", " ", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"exitCode", " ", "\[Equal]", " ", "0"}], ",", " ", "True", ",",
        " ", "False"}], "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{"success", ",", " ", 
      RowBox[{"results", " ", "=", " ", 
       RowBox[{"DeserializeResults", "[", "]"}]}], ",", 
      RowBox[{"results", " ", "=", " ", "None"}]}], "]"}], ";", 
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"(*", " ", "end", " ", "*)"}], "\[IndentingNewLine]", 
    RowBox[{"clusteringHistory", " ", "=", " ", 
     RowBox[{"results", "@", "clusteringHistory"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"algos", " ", "=", " ", 
     RowBox[{"results", "@", "algoNames"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"qis", " ", "=", " ", 
     RowBox[{"results", "@", "qINames"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"dms", " ", "=", " ", 
     RowBox[{"results", "@", "dMNames"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"Return", "[", "results", "]"}], ";"}], "\[IndentingNewLine]", 
   ")"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4472560847832813`*^9, 3.447256196410184*^9}, {
   3.447256350121306*^9, 3.4472563548954678`*^9}, {3.447256391658504*^9, 
   3.4472564155712433`*^9}, {3.447257169745923*^9, 3.447257189631318*^9}, {
   3.447257224305388*^9, 3.447257228318739*^9}, {3.447257323345557*^9, 
   3.447257337228942*^9}, {3.447257386180257*^9, 3.447257390432242*^9}, {
   3.447258061689617*^9, 3.447258108432294*^9}, {3.4472581473449173`*^9, 
   3.4472581835846252`*^9}, {3.4472582626197777`*^9, 3.447258267872398*^9}, {
   3.44725856042467*^9, 3.447258576642312*^9}, {3.447261459376316*^9, 
   3.447261508043539*^9}, {3.4472615423805933`*^9, 3.447261559598837*^9}, {
   3.447261729998241*^9, 3.4472617719355183`*^9}, {3.447261840180353*^9, 
   3.4472618599723587`*^9}, {3.447262113748644*^9, 3.447262115891678*^9}, {
   3.447264661733864*^9, 3.447264661905128*^9}, {3.447330025510092*^9, 
   3.447330032762615*^9}, {3.447330594123398*^9, 3.447330596682192*^9}, {
   3.447331064015435*^9, 3.447331093217289*^9}, {3.447331245244923*^9, 
   3.447331247969715*^9}, {3.447331402276772*^9, 3.447331408754529*^9}, {
   3.447332220078086*^9, 3.4473322222901783`*^9}, {3.4473322703317213`*^9, 
   3.447332273539329*^9}, {3.447338737796892*^9, 3.4473387394426413`*^9}, {
   3.4473399925586443`*^9, 3.4473400005726213`*^9}, {3.447341627733465*^9, 
   3.4473417057085752`*^9}, {3.447341741878153*^9, 3.447341759116115*^9}, {
   3.447499974069538*^9, 3.447499982770396*^9}, {3.447507720360817*^9, 
   3.447507730826146*^9}, {3.447507781419221*^9, 3.44750778540094*^9}, {
   3.4475151727410803`*^9, 3.447515182044503*^9}, {3.447568695346251*^9, 
   3.447568705575572*^9}, {3.447569532797104*^9, 3.447569567143649*^9}, {
   3.447569922329892*^9, 3.447569939605068*^9}, {3.4475702781134377`*^9, 
   3.4475703140051727`*^9}, {3.447570348369904*^9, 3.447570366632743*^9}, {
   3.447581786760056*^9, 3.447581795521759*^9}, {3.447582996717122*^9, 
   3.447582999034442*^9}, {3.447599068669655*^9, 3.4475990872856197`*^9}, {
   3.4479987030143642`*^9, 3.4479987077102757`*^9}, {3.4480986808273783`*^9, 
   3.448098681904647*^9}, {3.4481114966128597`*^9, 3.448111500374617*^9}, {
   3.449230795900524*^9, 3.449230826737186*^9}, {3.449232234754188*^9, 
   3.4492322368254004`*^9}, {3.44923235101092*^9, 3.449232358144202*^9}, {
   3.449233030048978*^9, 3.449233078910705*^9}, {3.449317087922667*^9, 
   3.449317088453079*^9}, {3.4493171822122593`*^9, 3.449317183432993*^9}, {
   3.449317401562356*^9, 3.449317406381275*^9}, {3.449317649145906*^9, 
   3.449317651126376*^9}, {3.449485309109035*^9, 3.449485315408291*^9}, {
   3.4494853677799683`*^9, 3.4494853711782627`*^9}, {3.45103217146527*^9, 
   3.45103221070333*^9}, {3.454143343415921*^9, 3.4541433436294203`*^9}, {
   3.454143619306857*^9, 3.454143632295525*^9}, {3.454153766106605*^9, 
   3.4541538085454397`*^9}, {3.454155474343298*^9, 3.454155514765765*^9}, {
   3.454157121600822*^9, 3.45415712452936*^9}, {3.454309598698545*^9, 
   3.454309599979559*^9}, {3.454309633194806*^9, 3.4543096376845407`*^9}, {
   3.454309696124382*^9, 3.454309700473958*^9}, {3.454310900011882*^9, 
   3.454310935384654*^9}, {3.454311739227518*^9, 3.454311761825955*^9}, {
   3.454312278701486*^9, 3.454312297258675*^9}, {3.454762064094028*^9, 
   3.4547621058432093`*^9}, 3.454762956972631*^9, {3.4547630126896477`*^9, 
   3.454763033989667*^9}, {3.454763148587935*^9, 3.4547631540394697`*^9}, {
   3.455448719664007*^9, 3.4554487368335743`*^9}, {3.4554488943573513`*^9, 
   3.455448900234508*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"GetMeasure", "[", 
   RowBox[{"algoName_", ",", " ", "measureName_"}], "]"}], ":=", " ", 
  RowBox[{"(", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"list", " ", "=", 
     RowBox[{"results", "@", 
      RowBox[{"listMeasure", "[", 
       RowBox[{"algoName", ",", "measureName"}], "]"}]}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"array", " ", "=", " ", 
     RowBox[{"list", "@", 
      RowBox[{"toArray", "[", "]"}]}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"Return", "[", "array", "]"}]}], "\[IndentingNewLine]", 
   ")"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4473377404477673`*^9, 3.447337742181806*^9}, {
  3.447337775286055*^9, 3.4473378420327187`*^9}, {3.4473383353494577`*^9, 
  3.4473383446158857`*^9}, {3.447338502586487*^9, 3.447338507736895*^9}, {
  3.447338784240587*^9, 3.4473387911852694`*^9}, {3.447338835100168*^9, 
  3.4473388448080177`*^9}, {3.447512244963091*^9, 3.447512260587867*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"GetGraphProperty", "[", "propertyName_", "]"}], ":=", " ", 
  RowBox[{"(", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"list", " ", "=", " ", 
     RowBox[{"results", "@", 
      RowBox[{"listGraphProperty", "[", "propertyName", "]"}]}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"array", " ", "=", " ", 
     RowBox[{"list", "@", 
      RowBox[{"toArray", "[", "]"}]}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"Return", "[", "array", "]"}]}], "\[IndentingNewLine]", 
   ")"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.447342217673252*^9, 3.447342259888298*^9}, {
  3.447512253534013*^9, 3.4475122558905983`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"GetTMax", "[", "]"}], ":=", 
   RowBox[{"results", "@", 
    RowBox[{"getTMax", "[", "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.453789017040743*^9, 3.453789036678781*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"GetTotalRuntime", "[", "]"}], ":=", 
   RowBox[{"results", "@", "totalRuntime"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.453793745593725*^9, 3.453793757250675*^9}, {
  3.454311862480418*^9, 3.454311867581547*^9}, {3.4543967513844347`*^9, 
  3.4543967528683987`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"GetMean", "[", 
   RowBox[{"algoName_", ",", " ", "measureName_"}], "]"}], " ", ":=", " ", 
  RowBox[{"Mean", "[", 
   RowBox[{"GetMeasure", "[", 
    RowBox[{"algoName", ",", "measureName"}], "]"}], "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.450614609429041*^9, 3.450614642534564*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"GetVariance", "[", 
   RowBox[{"algoName_", ",", " ", "measureName_"}], "]"}], " ", ":=", " ", 
  RowBox[{"Variance", "[", 
   RowBox[{"GetMeasure", "[", 
    RowBox[{"algoName", ",", "measureName"}], "]"}], "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.450614392322402*^9, 3.450614396685461*^9}, {
  3.4537749902486258`*^9, 3.453775005267004*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"GetMax", "[", 
   RowBox[{"algoName_", ",", " ", "measureName_"}], "]"}], " ", ":=", " ", 
  RowBox[{"Max", "[", 
   RowBox[{"GetMeasure", "[", 
    RowBox[{"algoName", ",", "measureName"}], "]"}], "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.450614392322402*^9, 3.450614396685461*^9}, {
  3.4537749902486258`*^9, 3.453775005267004*^9}, {3.453775377868808*^9, 
  3.453775384658654*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"GetMin", "[", 
   RowBox[{"algoName_", ",", " ", "measureName_"}], "]"}], " ", ":=", " ", 
  RowBox[{"Min", "[", 
   RowBox[{"GetMeasure", "[", 
    RowBox[{"algoName", ",", "measureName"}], "]"}], "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.450614392322402*^9, 3.450614396685461*^9}, {
  3.4537749902486258`*^9, 3.453775005267004*^9}, {3.453775381123231*^9, 
  3.4537753864908237`*^9}}],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{"*", " ", "Plots"}], " ", "**)"}]], "Input",
 CellChangeTimes->{{3.447344131848365*^9, 3.447344135767187*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"QualityPlot", "[", 
   RowBox[{"list_", ",", "legend_"}], "]"}], ":=", 
  RowBox[{"ListLinePlot", "[", 
   RowBox[{"list", ",", 
    RowBox[{"Filling", "\[Rule]", "None"}], ",", " ", 
    RowBox[{"PlotLegend", "\[Rule]", "legend"}], ",", " ", 
    RowBox[{"LegendShadow", "\[Rule]", "None"}], ",", 
    RowBox[{"LegendSpacing", "\[Rule]", "0.01"}], ",", 
    RowBox[{"LegendSize", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0.3"}], "}"}]}], ",", 
    RowBox[{"LegendPosition", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "1"}], ",", 
       RowBox[{"-", "1"}]}], "}"}]}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "1"}], ",", "1"}], "}"}]}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "Large"}]}], "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.447250514997526*^9, 3.447250519364451*^9}, {
   3.4472505580637817`*^9, 3.447250558268962*^9}, {3.447250660501272*^9, 
   3.44725069961622*^9}, {3.4472507382647133`*^9, 3.447250744045727*^9}, {
   3.4472507797710648`*^9, 3.4472508061264133`*^9}, {3.447251145417869*^9, 
   3.4472511536459084`*^9}, {3.447251478914337*^9, 3.4472516559986486`*^9}, {
   3.447251857257658*^9, 3.44725187318253*^9}, {3.447251947654565*^9, 
   3.447251951782391*^9}, {3.447251995976616*^9, 3.4472520114951067`*^9}, {
   3.447252065119624*^9, 3.4472520653990726`*^9}, {3.447252100815207*^9, 
   3.44725212562246*^9}, {3.447252174753249*^9, 3.4472522461091747`*^9}, {
   3.447252297752159*^9, 3.44725229813546*^9}, {3.447252358458358*^9, 
   3.4472525579595413`*^9}, {3.447253029418442*^9, 3.4472530892462053`*^9}, {
   3.447253125603649*^9, 3.447253129063354*^9}, {3.447253216482895*^9, 
   3.447253223656953*^9}, {3.447253385185667*^9, 3.447253395839644*^9}, {
   3.447253604899014*^9, 3.447253624115314*^9}, {3.447253787492415*^9, 
   3.447253788111291*^9}, {3.447339093371951*^9, 3.4473391268958607`*^9}, 
   3.447339836226871*^9, {3.447340524340617*^9, 3.447340536039657*^9}, {
   3.447340780786353*^9, 3.447340875761434*^9}, {3.447341160095414*^9, 
   3.447341160553844*^9}, {3.447341408530939*^9, 3.447341453640945*^9}, 
   3.4473438041116333`*^9, 3.447344137985712*^9, {3.454398478987192*^9, 
   3.4543984818406*^9}, 3.495533805796974*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"GraphPropertyPlot", "[", 
   RowBox[{"list_", ",", "legend_"}], "]"}], ":=", " ", 
  RowBox[{"ListLinePlot", "[", 
   RowBox[{"list", ",", 
    RowBox[{"Filling", "\[Rule]", "None"}], ",", " ", 
    RowBox[{"PlotLegend", "\[Rule]", "legend"}], ",", 
    RowBox[{"LegendShadow", "\[Rule]", "None"}], ",", 
    RowBox[{"LegendSpacing", "\[Rule]", "0.01"}], ",", 
    RowBox[{"LegendSize", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"2", ",", "0.38"}], "}"}]}], ",", 
    RowBox[{"LegendPosition", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "1"}], ",", 
       RowBox[{"-", "1"}]}], "}"}]}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "Large"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       RowBox[{"Max", "[", "list", "]"}]}], "}"}]}]}], "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.447342326635436*^9, 3.4473423486951723`*^9}, {
   3.4473424138314667`*^9, 3.447342440818736*^9}, {3.44734247357087*^9, 
   3.447342474696265*^9}, {3.447343816532063*^9, 3.447343820402191*^9}, {
   3.447343851401144*^9, 3.447343855232828*^9}, {3.4475815078375673`*^9, 
   3.447581527113881*^9}, {3.447581583570717*^9, 3.447581601761017*^9}, 
   3.449397067171829*^9, {3.454398508897949*^9, 3.4543985113993053`*^9}, 
   3.495533204150385*^9, 3.495533315283855*^9, 3.495533401524274*^9, 
   3.4955338055782146`*^9, 3.495533926244615*^9, 3.4955340188154297`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"ClusterPlot", "[", "algoList_", "]"}], ":=", " ", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "data", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"data", " ", "=", " ", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"GetMeasure", "[", 
         RowBox[{
          RowBox[{"Part", "[", 
           RowBox[{"algoList", ",", "i"}], "]"}], ",", "\"\<k\>\""}], "]"}], 
        ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          RowBox[{"Length", "[", "algoList", "]"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ListLinePlot", "[", "\[IndentingNewLine]", 
      RowBox[{"data", ",", "\[IndentingNewLine]", 
       RowBox[{"PlotRange", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"0", ",", 
          RowBox[{"Max", "[", "data", "]"}]}], "}"}]}], ",", " ", 
       RowBox[{"PlotLegend", "\[Rule]", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{"StringJoin", "[", 
             RowBox[{"#", " ", "<>", " ", "\"\< Cluster Count\>\""}], "]"}], 
            ")"}], "&"}], "/@", "algoList"}], ")"}]}], ",", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], ",", 
       RowBox[{"LegendShadow", "\[Rule]", "None"}], ",", 
       RowBox[{"LegendSpacing", "\[Rule]", "0.01"}], ",", 
       RowBox[{"LegendSize", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"2", ",", "0.38"}], "}"}]}], ",", 
       RowBox[{"LegendPosition", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "1"}], ",", 
          RowBox[{"-", "1"}]}], "}"}]}], ",", " ", 
       RowBox[{"LegendTextSpace", "\[Rule]", " ", "20"}], ",", 
       RowBox[{"ImageSize", "\[Rule]", "Large"}]}], "\[IndentingNewLine]", 
      "]"}]}]}], "\[IndentingNewLine]", "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.447582281565753*^9, 3.447582407664296*^9}, {
   3.447582481404025*^9, 3.447582526081925*^9}, 3.4475825882267714`*^9, {
   3.447582741128111*^9, 3.447582741274789*^9}, {3.4475828408446083`*^9, 
   3.447582891446364*^9}, {3.449396929624035*^9, 3.449396929943939*^9}, {
   3.449396973810153*^9, 3.449396981029924*^9}, 3.4493970593124247`*^9, {
   3.449397099686264*^9, 3.449397100349731*^9}, {3.4500962045288477`*^9, 
   3.450096221610779*^9}, {3.4500963103058357`*^9, 3.45009632869116*^9}, {
   3.450862144971096*^9, 3.450862149837262*^9}, {3.454325487354343*^9, 
   3.4543255434086313`*^9}, {3.454325575360162*^9, 3.454325576071413*^9}, {
   3.454398515539448*^9, 3.4543985178889627`*^9}, 3.49553320417762*^9, 
   3.4955333152875023`*^9, 3.495533401575688*^9, 3.4955338056207037`*^9, 
   3.495533926282703*^9, 3.495534018860858*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"RuntimePlot", "[", "algoList_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"tuples", ",", "data", ",", "legend"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"tuples", " ", "=", 
      RowBox[{"Tuples", "[", 
       RowBox[{"{", 
        RowBox[{"algoList", ",", 
         RowBox[{"{", "\"\<Runtime\>\"", "}"}]}], "}"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"data", " ", "=", " ", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"GetMeasure", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Part", "[", 
           RowBox[{
            RowBox[{"Part", "[", 
             RowBox[{"tuples", ",", "i"}], "]"}], ",", "1"}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Part", "[", 
           RowBox[{
            RowBox[{"Part", "[", 
             RowBox[{"tuples", ",", "i"}], "]"}], ",", "2"}], "]"}]}], 
         "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          RowBox[{"Length", "[", "tuples", "]"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"legend", " ", "=", "  ", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"StringJoin", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Part", "[", 
           RowBox[{
            RowBox[{"Part", "[", 
             RowBox[{"tuples", ",", "i"}], "]"}], ",", "1"}], "]"}], ",", 
          "\[IndentingNewLine]", "\"\< \>\"", ",", "\[IndentingNewLine]", 
          RowBox[{"Part", "[", 
           RowBox[{
            RowBox[{"Part", "[", 
             RowBox[{"tuples", ",", "i"}], "]"}], ",", "2"}], "]"}], ",", 
          "\[IndentingNewLine]", "\"\< \\t avg \>\"", ",", " ", 
          RowBox[{"ToString", "[", 
           RowBox[{"GetMean", "[", 
            RowBox[{
             RowBox[{"Part", "[", 
              RowBox[{
               RowBox[{"Part", "[", 
                RowBox[{"tuples", ",", "i"}], "]"}], ",", "1"}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Part", "[", 
              RowBox[{
               RowBox[{"Part", "[", 
                RowBox[{"tuples", ",", "i"}], "]"}], ",", "2"}], "]"}]}], 
            "]"}], "]"}]}], "\[IndentingNewLine]", "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          RowBox[{"Length", "[", "tuples", "]"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ListLogPlot", "[", 
      RowBox[{"data", ",", 
       RowBox[{"PlotLegend", "\[Rule]", "legend"}], ",", "  ", 
       RowBox[{"LegendShadow", "\[Rule]", "None"}], ",", 
       RowBox[{"LegendPosition", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "1"}], ",", 
          RowBox[{"-", "1"}]}], "}"}]}], ",", 
       RowBox[{"LegendSize", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"2", ",", "0.38"}], "}"}]}], ",", " ", 
       RowBox[{"LegendTextSpace", "\[Rule]", " ", "20"}], ",", 
       RowBox[{"ImageSize", "\[Rule]", "Large"}]}], "]"}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.447516304609161*^9, 3.4475163384613333`*^9}, {
   3.4475163758152237`*^9, 3.447516394845797*^9}, {3.4475164257582827`*^9, 
   3.447516523670692*^9}, {3.447516609088522*^9, 3.447516611614533*^9}, {
   3.447516845612505*^9, 3.447516854998433*^9}, {3.4475169020100307`*^9, 
   3.447516918842823*^9}, {3.447567744565948*^9, 3.447567744973522*^9}, {
   3.449389564160036*^9, 3.449389564650117*^9}, {3.4493896314676027`*^9, 
   3.449389644510619*^9}, {3.44938968732802*^9, 3.4493896954361687`*^9}, {
   3.4493899034989443`*^9, 3.4493899163002872`*^9}, 3.4493899516527853`*^9, {
   3.449389992183514*^9, 3.449390012693578*^9}, {3.449390050173086*^9, 
   3.449390053527205*^9}, {3.4493900859763193`*^9, 3.449390088187937*^9}, {
   3.4493968074337397`*^9, 3.44939680852757*^9}, {3.449396852754038*^9, 
   3.4493968551698303`*^9}, {3.4493970256271143`*^9, 3.449397025969433*^9}, {
   3.449397096267531*^9, 3.449397096599874*^9}, {3.45061469278259*^9, 
   3.45061469721277*^9}, {3.4506147421763783`*^9, 3.45061475686954*^9}, 
   3.45061481486479*^9, 3.450614873038406*^9, {3.4506170223794203`*^9, 
   3.4506170579488153`*^9}, {3.450617173739797*^9, 3.450617185762226*^9}, {
   3.450617229815116*^9, 3.450617231034265*^9}, {3.4543985232611303`*^9, 
   3.4543985257795773`*^9}, 3.49553320418443*^9, 3.4955333152929163`*^9, 
   3.495533401609118*^9, 3.4955338056790447`*^9, {3.495533906192445*^9, 
   3.495533926122634*^9}, 3.4955340186478777`*^9, {3.495534250414782*^9, 
   3.4955342526534367`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"QualityComparePlot", "[", 
    RowBox[{"algoList_", ",", "qIList_"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"tuples", ",", "data", ",", " ", "legend"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"tuples", " ", "=", " ", 
       RowBox[{"Tuples", "[", 
        RowBox[{"{", 
         RowBox[{"algoList", ",", "qIList"}], "}"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"data", " ", "=", " ", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"GetMeasure", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Part", "[", 
            RowBox[{
             RowBox[{"Part", "[", 
              RowBox[{"tuples", ",", "i"}], "]"}], ",", "1"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Part", "[", 
            RowBox[{
             RowBox[{"Part", "[", 
              RowBox[{"tuples", ",", "i"}], "]"}], ",", "2"}], "]"}]}], 
          "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{"i", ",", "1", ",", 
           RowBox[{"Length", "[", "tuples", "]"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"legend", " ", "=", "  ", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"StringJoin", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Part", "[", 
            RowBox[{
             RowBox[{"Part", "[", 
              RowBox[{"tuples", ",", "i"}], "]"}], ",", "1"}], "]"}], ",", 
           "\[IndentingNewLine]", "\"\< : \>\"", ",", "\[IndentingNewLine]", 
           RowBox[{"Part", "[", 
            RowBox[{
             RowBox[{"Part", "[", 
              RowBox[{"tuples", ",", "i"}], "]"}], ",", "2"}], "]"}], ",", 
           "\[IndentingNewLine]", "\"\< \\t avg \>\"", ",", " ", 
           RowBox[{"ToString", "[", 
            RowBox[{"GetMean", "[", 
             RowBox[{
              RowBox[{"Part", "[", 
               RowBox[{
                RowBox[{"Part", "[", 
                 RowBox[{"tuples", ",", "i"}], "]"}], ",", "1"}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Part", "[", 
               RowBox[{
                RowBox[{"Part", "[", 
                 RowBox[{"tuples", ",", "i"}], "]"}], ",", "2"}], "]"}]}], 
             "]"}], "]"}]}], "\[IndentingNewLine]", "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{"i", ",", "1", ",", 
           RowBox[{"Length", "[", "tuples", "]"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"ListLinePlot", "[", 
       RowBox[{"data", ",", 
        RowBox[{"Filling", "\[Rule]", "None"}], ",", " ", 
        RowBox[{"PlotLegend", "\[Rule]", "legend"}], ",", " ", 
        RowBox[{"LegendShadow", "\[Rule]", "None"}], ",", 
        RowBox[{"LegendPosition", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "1"}], ",", 
           RowBox[{"-", "1"}]}], "}"}]}], ",", 
        RowBox[{"LegendSize", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"2", ",", "0.38"}], "}"}]}], ",", " ", 
        RowBox[{"LegendTextSpace", "\[Rule]", " ", "20"}], ",", 
        RowBox[{"PlotRange", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Max", "[", "data", "]"}], ",", 
           RowBox[{"Min", "[", "data", "]"}]}], "}"}]}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "Large"}], ",", 
        RowBox[{"PlotMarkers", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Automatic", ",", "Tiny"}], "}"}]}]}], " ", "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.447344151536333*^9, 3.4473442343532476`*^9}, {
   3.4473444459340153`*^9, 3.4473444530900593`*^9}, {3.447344535805955*^9, 
   3.4473445473637533`*^9}, {3.4473446671252403`*^9, 
   3.4473447091719913`*^9}, {3.447344779746757*^9, 3.447344784547701*^9}, {
   3.44734488343499*^9, 3.447344946506833*^9}, {3.447344988966655*^9, 
   3.44734499973072*^9}, {3.4473451001967487`*^9, 3.447345116499405*^9}, {
   3.447345158551833*^9, 3.4473451773230658`*^9}, {3.447345231713776*^9, 
   3.447345235435811*^9}, {3.447345283390151*^9, 3.4473456837732487`*^9}, {
   3.447509242695932*^9, 3.447509334648726*^9}, {3.4475094192913513`*^9, 
   3.447509421513476*^9}, {3.447513230526692*^9, 3.447513235768107*^9}, {
   3.447513349553567*^9, 3.447513357494322*^9}, {3.4475133898199453`*^9, 
   3.4475133968089533`*^9}, {3.4475134354893103`*^9, 3.447513491649947*^9}, {
   3.4475695034953012`*^9, 3.447569503654015*^9}, 3.449397052258954*^9, {
   3.450095523514152*^9, 3.4500955321006002`*^9}, {3.450617303507584*^9, 
   3.450617303989851*^9}, {3.450862039210517*^9, 3.4508620401697817`*^9}, {
   3.453013011623685*^9, 3.453013012259193*^9}, {3.45301503006563*^9, 
   3.453015032289072*^9}, {3.45301513320107*^9, 3.453015134606641*^9}, {
   3.453015883852503*^9, 3.45301588516282*^9}, {3.453617986710891*^9, 
   3.453618021626678*^9}, 3.453618874001025*^9, {3.4543985315743933`*^9, 
   3.454398538525591*^9}, 3.4955332041918983`*^9, 3.495533315297853*^9, 
   3.4955334016390457`*^9, 3.4955338057226133`*^9, 3.495533926166356*^9, 
   3.495534018717071*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SmoothQualityComparePlot", "[", 
    RowBox[{"algoList_", ",", "qIList_", ",", " ", "range_"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"tuples", ",", "data", ",", " ", "legend"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"tuples", " ", "=", " ", 
       RowBox[{"Tuples", "[", 
        RowBox[{"{", 
         RowBox[{"algoList", ",", "qIList"}], "}"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"data", " ", "=", " ", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"MovingAverage", "[", 
          RowBox[{
           RowBox[{"GetMeasure", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Part", "[", 
              RowBox[{
               RowBox[{"Part", "[", 
                RowBox[{"tuples", ",", "i"}], "]"}], ",", "1"}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Part", "[", 
              RowBox[{
               RowBox[{"Part", "[", 
                RowBox[{"tuples", ",", "i"}], "]"}], ",", "2"}], "]"}]}], 
            "\[IndentingNewLine]", "]"}], ",", "range"}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{"i", ",", "1", ",", 
           RowBox[{"Length", "[", "tuples", "]"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"legend", " ", "=", "  ", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"StringJoin", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Part", "[", 
            RowBox[{
             RowBox[{"Part", "[", 
              RowBox[{"tuples", ",", "i"}], "]"}], ",", "1"}], "]"}], ",", 
           "\[IndentingNewLine]", "\"\< : \>\"", ",", "\[IndentingNewLine]", 
           RowBox[{"Part", "[", 
            RowBox[{
             RowBox[{"Part", "[", 
              RowBox[{"tuples", ",", "i"}], "]"}], ",", "2"}], "]"}], ",", 
           "\[IndentingNewLine]", "\"\< \\t avg \>\"", ",", " ", 
           RowBox[{"ToString", "[", 
            RowBox[{"GetMean", "[", 
             RowBox[{
              RowBox[{"Part", "[", 
               RowBox[{
                RowBox[{"Part", "[", 
                 RowBox[{"tuples", ",", "i"}], "]"}], ",", "1"}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Part", "[", 
               RowBox[{
                RowBox[{"Part", "[", 
                 RowBox[{"tuples", ",", "i"}], "]"}], ",", "2"}], "]"}]}], 
             "]"}], "]"}]}], "\[IndentingNewLine]", "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{"i", ",", "1", ",", 
           RowBox[{"Length", "[", "tuples", "]"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"ListLinePlot", "[", 
       RowBox[{"data", ",", 
        RowBox[{"Filling", "\[Rule]", "None"}], ",", " ", 
        RowBox[{"PlotLegend", "\[Rule]", "legend"}], ",", " ", 
        RowBox[{"LegendShadow", "\[Rule]", "None"}], ",", 
        RowBox[{"LegendPosition", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "1"}], ",", 
           RowBox[{"-", "1"}]}], "}"}]}], ",", 
        RowBox[{"LegendSize", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"2", ",", "0.38"}], "}"}]}], ",", " ", 
        RowBox[{"LegendTextSpace", "\[Rule]", " ", "20"}], ",", 
        RowBox[{"PlotRange", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Max", "[", "data", "]"}], ",", 
           RowBox[{"Min", "[", "data", "]"}]}], "}"}]}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "Large"}], ",", 
        RowBox[{"PlotMarkers", "\[Rule]", "None"}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}]}], "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.447344151536333*^9, 3.4473442343532476`*^9}, {
   3.4473444459340153`*^9, 3.4473444530900593`*^9}, {3.447344535805955*^9, 
   3.4473445473637533`*^9}, {3.4473446671252403`*^9, 
   3.4473447091719913`*^9}, {3.447344779746757*^9, 3.447344784547701*^9}, {
   3.44734488343499*^9, 3.447344946506833*^9}, {3.447344988966655*^9, 
   3.44734499973072*^9}, {3.4473451001967487`*^9, 3.447345116499405*^9}, {
   3.447345158551833*^9, 3.4473451773230658`*^9}, {3.447345231713776*^9, 
   3.447345235435811*^9}, {3.447345283390151*^9, 3.4473456837732487`*^9}, {
   3.447509242695932*^9, 3.447509334648726*^9}, {3.4475094192913513`*^9, 
   3.447509421513476*^9}, {3.447513230526692*^9, 3.447513235768107*^9}, {
   3.447513349553567*^9, 3.447513357494322*^9}, {3.4475133898199453`*^9, 
   3.4475133968089533`*^9}, {3.4475134354893103`*^9, 3.447513491649947*^9}, {
   3.4475695034953012`*^9, 3.447569503654015*^9}, 3.449397052258954*^9, {
   3.450095523514152*^9, 3.4500955321006002`*^9}, {3.450617303507584*^9, 
   3.450617303989851*^9}, {3.450862039210517*^9, 3.4508620401697817`*^9}, {
   3.453013011623685*^9, 3.453013012259193*^9}, {3.45301503006563*^9, 
   3.453015032289072*^9}, {3.45301513320107*^9, 3.453015134606641*^9}, {
   3.453015883852503*^9, 3.45301588516282*^9}, {3.453617986710891*^9, 
   3.453618021626678*^9}, {3.45361886048853*^9, 3.453618877238509*^9}, {
   3.4536191083229*^9, 3.453619117647682*^9}, {3.453619333267606*^9, 
   3.453619350417259*^9}, {3.453619942555505*^9, 3.4536199434002666`*^9}, {
   3.453620132564293*^9, 3.4536201365445127`*^9}, {3.4536202116374407`*^9, 
   3.453620233325075*^9}, 3.4536203555684757`*^9, {3.453620431999683*^9, 
   3.453620432524604*^9}, {3.4536204736709633`*^9, 3.4536205228343153`*^9}, {
   3.4536205841499577`*^9, 3.453620643715876*^9}, {3.453621656683052*^9, 
   3.453621656978487*^9}, {3.453621714850141*^9, 3.453621715621993*^9}, {
   3.453788213426251*^9, 3.4537882497169237`*^9}, {3.453788328811555*^9, 
   3.453788329690794*^9}, {3.454326207543598*^9, 3.454326214054205*^9}, {
   3.454398546790118*^9, 3.45439854958014*^9}, 3.4955332042007847`*^9, 
   3.495533315302968*^9, 3.495533401664837*^9, 3.495533805728238*^9, 
   3.49553392618216*^9, 3.495534018749239*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CombinedQualityComparePlotOld", "[", 
    RowBox[{"algoList_", ",", "qIList_", ",", " ", "range_"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"tuples", ",", "data", ",", "smoothdata", ",", " ", "legend"}], 
      "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"tuples", " ", "=", " ", 
       RowBox[{"Tuples", "[", 
        RowBox[{"{", 
         RowBox[{"algoList", ",", "qIList"}], "}"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"smoothdata", " ", "=", " ", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"MovingAverage", "[", 
          RowBox[{
           RowBox[{"GetMeasure", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Part", "[", 
              RowBox[{
               RowBox[{"Part", "[", 
                RowBox[{"tuples", ",", "i"}], "]"}], ",", "1"}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Part", "[", 
              RowBox[{
               RowBox[{"Part", "[", 
                RowBox[{"tuples", ",", "i"}], "]"}], ",", "2"}], "]"}]}], 
            "\[IndentingNewLine]", "]"}], ",", "range"}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{"i", ",", "1", ",", 
           RowBox[{"Length", "[", "tuples", "]"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"data", " ", "=", " ", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"GetMeasure", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Part", "[", 
            RowBox[{
             RowBox[{"Part", "[", 
              RowBox[{"tuples", ",", "i"}], "]"}], ",", "1"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Part", "[", 
            RowBox[{
             RowBox[{"Part", "[", 
              RowBox[{"tuples", ",", "i"}], "]"}], ",", "2"}], "]"}]}], 
          "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{"i", ",", "1", ",", 
           RowBox[{"Length", "[", "tuples", "]"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"legend", " ", "=", "  ", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"StringJoin", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Part", "[", 
            RowBox[{
             RowBox[{"Part", "[", 
              RowBox[{"tuples", ",", "i"}], "]"}], ",", "1"}], "]"}], ",", 
           "\[IndentingNewLine]", "\"\< : \>\"", ",", "\[IndentingNewLine]", 
           RowBox[{"Part", "[", 
            RowBox[{
             RowBox[{"Part", "[", 
              RowBox[{"tuples", ",", "i"}], "]"}], ",", "2"}], "]"}], ",", 
           "\[IndentingNewLine]", "\"\< \\t avg \>\"", ",", " ", 
           RowBox[{"ToString", "[", 
            RowBox[{"GetMean", "[", 
             RowBox[{
              RowBox[{"Part", "[", 
               RowBox[{
                RowBox[{"Part", "[", 
                 RowBox[{"tuples", ",", "i"}], "]"}], ",", "1"}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Part", "[", 
               RowBox[{
                RowBox[{"Part", "[", 
                 RowBox[{"tuples", ",", "i"}], "]"}], ",", "2"}], "]"}]}], 
             "]"}], "]"}]}], "\[IndentingNewLine]", "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{"i", ",", "1", ",", 
           RowBox[{"Length", "[", "tuples", "]"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"ListLinePlot", "[", 
       RowBox[{
        RowBox[{"Join", "[", 
         RowBox[{"data", ",", " ", "smoothdata"}], "]"}], ",", 
        RowBox[{"Filling", "\[Rule]", "None"}], ",", " ", 
        RowBox[{"PlotLegend", "\[Rule]", "legend"}], ",", " ", 
        RowBox[{"LegendShadow", "\[Rule]", "None"}], ",", 
        RowBox[{"LegendPosition", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "1"}], ",", 
           RowBox[{"-", "1"}]}], "}"}]}], ",", 
        RowBox[{"LegendSize", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"2", ",", "0.38"}], "}"}]}], ",", " ", 
        RowBox[{"LegendTextSpace", "\[Rule]", " ", "20"}], ",", 
        RowBox[{"PlotRange", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Max", "[", "data", "]"}], ",", 
           RowBox[{"Min", "[", "data", "]"}]}], "}"}]}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "Large"}], ",", 
        RowBox[{"PlotMarkers", "\[Rule]", "None"}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}]}], "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.447344151536333*^9, 3.4473442343532476`*^9}, {
   3.4473444459340153`*^9, 3.4473444530900593`*^9}, {3.447344535805955*^9, 
   3.4473445473637533`*^9}, {3.4473446671252403`*^9, 
   3.4473447091719913`*^9}, {3.447344779746757*^9, 3.447344784547701*^9}, {
   3.44734488343499*^9, 3.447344946506833*^9}, {3.447344988966655*^9, 
   3.44734499973072*^9}, {3.4473451001967487`*^9, 3.447345116499405*^9}, {
   3.447345158551833*^9, 3.4473451773230658`*^9}, {3.447345231713776*^9, 
   3.447345235435811*^9}, {3.447345283390151*^9, 3.4473456837732487`*^9}, {
   3.447509242695932*^9, 3.447509334648726*^9}, {3.4475094192913513`*^9, 
   3.447509421513476*^9}, {3.447513230526692*^9, 3.447513235768107*^9}, {
   3.447513349553567*^9, 3.447513357494322*^9}, {3.4475133898199453`*^9, 
   3.4475133968089533`*^9}, {3.4475134354893103`*^9, 3.447513491649947*^9}, {
   3.4475695034953012`*^9, 3.447569503654015*^9}, 3.449397052258954*^9, {
   3.450095523514152*^9, 3.4500955321006002`*^9}, {3.450617303507584*^9, 
   3.450617303989851*^9}, {3.450862039210517*^9, 3.4508620401697817`*^9}, {
   3.453013011623685*^9, 3.453013012259193*^9}, {3.45301503006563*^9, 
   3.453015032289072*^9}, {3.45301513320107*^9, 3.453015134606641*^9}, {
   3.453015883852503*^9, 3.45301588516282*^9}, {3.453617986710891*^9, 
   3.453618021626678*^9}, {3.45361886048853*^9, 3.453618877238509*^9}, {
   3.4536191083229*^9, 3.453619117647682*^9}, {3.453619333267606*^9, 
   3.453619350417259*^9}, {3.453619942555505*^9, 3.4536199434002666`*^9}, {
   3.453620132564293*^9, 3.4536201365445127`*^9}, {3.4536202116374407`*^9, 
   3.453620233325075*^9}, 3.4536203555684757`*^9, {3.453620431999683*^9, 
   3.453620432524604*^9}, {3.4536204736709633`*^9, 3.4536205228343153`*^9}, {
   3.4536205841499577`*^9, 3.453620643715876*^9}, {3.453621656683052*^9, 
   3.453621656978487*^9}, {3.453621714850141*^9, 3.453621715621993*^9}, {
   3.453624004355915*^9, 3.453624057157119*^9}, {3.45362416222781*^9, 
   3.4536241686683064`*^9}, {3.453624616493022*^9, 3.453624622572309*^9}, {
   3.453624653207761*^9, 3.453624671157916*^9}, {3.45372158973672*^9, 
   3.453721590176956*^9}, {3.453789096122081*^9, 3.453789098743032*^9}, {
   3.453789177260223*^9, 3.453789177653831*^9}, 3.45389294823392*^9, {
   3.454398555719863*^9, 3.454398560382106*^9}, 3.495533204245199*^9, 
   3.4955333153089657`*^9, 3.4955334016707907`*^9, 3.495533805737762*^9, 
   3.495533926190515*^9, 3.4955340187553883`*^9}],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{"*", " ", "DISTANCE"}], " ", "**)"}]], "Input",
 CellChangeTimes->{{3.453722234001275*^9, 3.453722240624817*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DistanceComparePlot", "[", 
   RowBox[{"algoList_", ",", "dMList_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"tuples", ",", "data", ",", " ", "legend"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"tuples", " ", "=", " ", 
      RowBox[{"Tuples", "[", 
       RowBox[{"{", 
        RowBox[{"algoList", ",", "dMList"}], "}"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"data", " ", "=", " ", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"GetMeasure", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Part", "[", 
           RowBox[{
            RowBox[{"Part", "[", 
             RowBox[{"tuples", ",", "i"}], "]"}], ",", "1"}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Part", "[", 
           RowBox[{
            RowBox[{"Part", "[", 
             RowBox[{"tuples", ",", "i"}], "]"}], ",", "2"}], "]"}]}], 
         "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          RowBox[{"Length", "[", "tuples", "]"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"legend", " ", "=", "  ", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"StringJoin", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Part", "[", 
           RowBox[{
            RowBox[{"Part", "[", 
             RowBox[{"tuples", ",", "i"}], "]"}], ",", "1"}], "]"}], ",", 
          "\[IndentingNewLine]", "\"\< : \>\"", ",", "\[IndentingNewLine]", 
          RowBox[{"Part", "[", 
           RowBox[{
            RowBox[{"Part", "[", 
             RowBox[{"tuples", ",", "i"}], "]"}], ",", "2"}], "]"}], ",", 
          "\[IndentingNewLine]", "\"\< \\t avg \>\"", ",", " ", 
          RowBox[{"ToString", "[", 
           RowBox[{"GetMean", "[", 
            RowBox[{
             RowBox[{"Part", "[", 
              RowBox[{
               RowBox[{"Part", "[", 
                RowBox[{"tuples", ",", "i"}], "]"}], ",", "1"}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Part", "[", 
              RowBox[{
               RowBox[{"Part", "[", 
                RowBox[{"tuples", ",", "i"}], "]"}], ",", "2"}], "]"}]}], 
            "]"}], "]"}]}], "\[IndentingNewLine]", "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          RowBox[{"Length", "[", "tuples", "]"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ListLinePlot", "[", 
      RowBox[{"data", ",", 
       RowBox[{"Filling", "\[Rule]", "None"}], ",", " ", 
       RowBox[{"PlotLegend", "\[Rule]", "legend"}], ",", " ", 
       RowBox[{"LegendShadow", "\[Rule]", "None"}], ",", 
       RowBox[{"LegendPosition", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "1"}], ",", 
          RowBox[{"-", "1"}]}], "}"}]}], ",", 
       RowBox[{"LegendSize", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"2", ",", "0.38"}], "}"}]}], ",", " ", 
       RowBox[{"LegendTextSpace", "\[Rule]", " ", "20"}], ",", 
       RowBox[{"PlotRange", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"0", ",", 
          RowBox[{"Max", "[", "data", "]"}]}], "}"}]}], ",", 
       RowBox[{"ImageSize", "\[Rule]", "Large"}], ",", 
       RowBox[{"PlotMarkers", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Automatic", ",", "Tiny"}], "}"}]}]}], "]"}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.447571013655821*^9, 3.4475710288219433`*^9}, {
   3.447571108224043*^9, 3.447571109605528*^9}, 3.44939714430721*^9, {
   3.450095728175057*^9, 3.4500957350203876`*^9}, {3.450617312595365*^9, 
   3.450617313988042*^9}, 3.450862072188416*^9, {3.4530135962889767`*^9, 
   3.453013596890226*^9}, {3.453015026043627*^9, 3.453015026385352*^9}, 
   3.45362334645658*^9, {3.454398567094117*^9, 3.454398570292027*^9}, 
   3.495533204250936*^9, 3.495533315314185*^9, 3.4955334016759043`*^9, 
   3.49553380574413*^9, 3.495533926195509*^9, 3.495534018773679*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SmoothDistanceComparePlot", "[", 
   RowBox[{"algoList_", ",", "dMList_", ",", " ", "range_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"tuples", ",", "data", ",", " ", "legend"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"tuples", " ", "=", " ", 
      RowBox[{"Tuples", "[", 
       RowBox[{"{", 
        RowBox[{"algoList", ",", "dMList"}], "}"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"data", " ", "=", " ", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"MovingAverage", "[", 
         RowBox[{
          RowBox[{"GetMeasure", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Part", "[", 
             RowBox[{
              RowBox[{"Part", "[", 
               RowBox[{"tuples", ",", "i"}], "]"}], ",", "1"}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"Part", "[", 
             RowBox[{
              RowBox[{"Part", "[", 
               RowBox[{"tuples", ",", "i"}], "]"}], ",", "2"}], "]"}]}], 
           "\[IndentingNewLine]", "]"}], ",", "range"}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          RowBox[{"Length", "[", "tuples", "]"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"legend", " ", "=", "  ", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"StringJoin", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Part", "[", 
           RowBox[{
            RowBox[{"Part", "[", 
             RowBox[{"tuples", ",", "i"}], "]"}], ",", "1"}], "]"}], ",", 
          "\[IndentingNewLine]", "\"\< : \>\"", ",", "\[IndentingNewLine]", 
          RowBox[{"Part", "[", 
           RowBox[{
            RowBox[{"Part", "[", 
             RowBox[{"tuples", ",", "i"}], "]"}], ",", "2"}], "]"}], ",", 
          "\[IndentingNewLine]", "\"\< \\t avg \>\"", ",", " ", 
          RowBox[{"ToString", "[", 
           RowBox[{"GetMean", "[", 
            RowBox[{
             RowBox[{"Part", "[", 
              RowBox[{
               RowBox[{"Part", "[", 
                RowBox[{"tuples", ",", "i"}], "]"}], ",", "1"}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Part", "[", 
              RowBox[{
               RowBox[{"Part", "[", 
                RowBox[{"tuples", ",", "i"}], "]"}], ",", "2"}], "]"}]}], 
            "]"}], "]"}]}], "\[IndentingNewLine]", "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          RowBox[{"Length", "[", "tuples", "]"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ListLinePlot", "[", 
      RowBox[{"data", ",", 
       RowBox[{"Filling", "\[Rule]", "None"}], ",", " ", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], ",", 
       RowBox[{"PlotLegend", "\[Rule]", "legend"}], ",", " ", 
       RowBox[{"LegendShadow", "\[Rule]", "None"}], ",", 
       RowBox[{"LegendPosition", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "1"}], ",", 
          RowBox[{"-", "1"}]}], "}"}]}], ",", 
       RowBox[{"LegendSize", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"2", ",", "0.38"}], "}"}]}], ",", " ", 
       RowBox[{"LegendTextSpace", "\[Rule]", " ", "20"}], ",", 
       RowBox[{"PlotRange", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"0", ",", 
          RowBox[{"Max", "[", "data", "]"}]}], "}"}]}], ",", 
       RowBox[{"ImageSize", "\[Rule]", "Large"}]}], "  ", "]"}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.447571013655821*^9, 3.4475710288219433`*^9}, {
   3.447571108224043*^9, 3.447571109605528*^9}, 3.44939714430721*^9, {
   3.450095728175057*^9, 3.4500957350203876`*^9}, {3.450617312595365*^9, 
   3.450617313988042*^9}, 3.450862072188416*^9, {3.4530135962889767`*^9, 
   3.453013596890226*^9}, {3.453015026043627*^9, 3.453015026385352*^9}, {
   3.453621392516724*^9, 3.453621430149065*^9}, {3.453621474278666*^9, 
   3.453621511773378*^9}, {3.453621648427137*^9, 3.4536216488344727`*^9}, {
   3.453621722918599*^9, 3.4536217233983173`*^9}, 3.453623340844543*^9, {
   3.453800611742036*^9, 3.453800612092822*^9}, {3.453800674365458*^9, 
   3.453800678619129*^9}, {3.453800758550983*^9, 3.453800768148755*^9}, {
   3.453800866011416*^9, 3.453800869314928*^9}, {3.453801095002246*^9, 
   3.4538010964878807`*^9}, {3.453801144824819*^9, 3.453801146407523*^9}, {
   3.453801350829946*^9, 3.45380135118865*^9}, {3.453801430086555*^9, 
   3.453801434435974*^9}, 3.453801466176785*^9, {3.453801712100864*^9, 
   3.453801717273634*^9}, {3.453801853458269*^9, 3.453801855264078*^9}, {
   3.454398577767399*^9, 3.4543985807640867`*^9}, 3.495533204315392*^9, {
   3.495533278349659*^9, 3.4955332804313097`*^9}, 3.495533315343961*^9, 
   3.495533401716785*^9, 3.495533805753624*^9, 3.495533926200145*^9, 
   3.49553401878839*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"CombinedDistanceComparePlot", "[", 
   RowBox[{"algoList_", ",", "dMList_", ",", " ", "range_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "tuples", ",", "data", ",", " ", "smoothData", ",", " ", "legend", ",", 
      " ", "rawPlot", ",", " ", "smoothPlot"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"tuples", " ", "=", " ", 
      RowBox[{"Tuples", "[", 
       RowBox[{"{", 
        RowBox[{"algoList", ",", "dMList"}], "}"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"data", " ", "=", " ", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"GetMeasure", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Part", "[", 
           RowBox[{
            RowBox[{"Part", "[", 
             RowBox[{"tuples", ",", "i"}], "]"}], ",", "1"}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Part", "[", 
           RowBox[{
            RowBox[{"Part", "[", 
             RowBox[{"tuples", ",", "i"}], "]"}], ",", "2"}], "]"}]}], 
         "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          RowBox[{"Length", "[", "tuples", "]"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"smoothData", " ", "=", " ", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"MovingAverage", "[", 
         RowBox[{
          RowBox[{"GetMeasure", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Part", "[", 
             RowBox[{
              RowBox[{"Part", "[", 
               RowBox[{"tuples", ",", "i"}], "]"}], ",", "1"}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"Part", "[", 
             RowBox[{
              RowBox[{"Part", "[", 
               RowBox[{"tuples", ",", "i"}], "]"}], ",", "2"}], "]"}]}], 
           "\[IndentingNewLine]", "]"}], ",", " ", "range"}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          RowBox[{"Length", "[", "tuples", "]"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"legend", " ", "=", "  ", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"StringJoin", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Part", "[", 
           RowBox[{
            RowBox[{"Part", "[", 
             RowBox[{"tuples", ",", "i"}], "]"}], ",", "1"}], "]"}], ",", 
          "\[IndentingNewLine]", "\"\< : \>\"", ",", "\[IndentingNewLine]", 
          RowBox[{"Part", "[", 
           RowBox[{
            RowBox[{"Part", "[", 
             RowBox[{"tuples", ",", "i"}], "]"}], ",", "2"}], "]"}], ",", 
          "\[IndentingNewLine]", "\"\< \\t avg \>\"", ",", " ", 
          RowBox[{"ToString", "[", 
           RowBox[{"GetMean", "[", 
            RowBox[{
             RowBox[{"Part", "[", 
              RowBox[{
               RowBox[{"Part", "[", 
                RowBox[{"tuples", ",", "i"}], "]"}], ",", "1"}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Part", "[", 
              RowBox[{
               RowBox[{"Part", "[", 
                RowBox[{"tuples", ",", "i"}], "]"}], ",", "2"}], "]"}]}], 
            "]"}], "]"}]}], "\[IndentingNewLine]", "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          RowBox[{"Length", "[", "tuples", "]"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"rawPlot", " ", "=", " ", 
      RowBox[{"ListLinePlot", "[", 
       RowBox[{"data", ",", 
        RowBox[{"Filling", "\[Rule]", "None"}], ",", " ", 
        RowBox[{"PlotLegend", "\[Rule]", "legend"}], ",", " ", 
        RowBox[{"LegendShadow", "\[Rule]", "None"}], ",", 
        RowBox[{"LegendPosition", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "1"}], ",", 
           RowBox[{"-", "0.9"}]}], "}"}]}], ",", 
        RowBox[{"LegendSize", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"2", ",", "0.38"}], "}"}]}], ",", " ", 
        RowBox[{"LegendTextSpace", "\[Rule]", " ", "20"}], ",", 
        RowBox[{"PlotRange", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"0", ",", 
           RowBox[{"Max", "[", "data", "]"}]}], "}"}]}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "Large"}], ",", 
        RowBox[{"PlotMarkers", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Automatic", ",", "Tiny"}], "}"}]}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"smoothPlot", " ", "=", " ", 
      RowBox[{"ListLinePlot", "[", 
       RowBox[{"smoothData", ",", 
        RowBox[{"Filling", "\[Rule]", "None"}], ",", " ", 
        RowBox[{"PlotRange", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"0", ",", 
           RowBox[{"Max", "[", "data", "]"}]}], "}"}]}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "Large"}], ",", 
        RowBox[{"PlotMarkers", "\[Rule]", "None"}], ",", " ", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"Thickness", "[", "0.003", "]"}]}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"combinedPlot", " ", "=", " ", 
      RowBox[{"Show", "[", 
       RowBox[{"rawPlot", ",", " ", "smoothPlot", ",", " ", 
        RowBox[{"PlotRange", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"0", ",", 
           RowBox[{"Max", "[", "data", "]"}]}], "}"}]}]}], "]"}]}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.447571013655821*^9, 3.4475710288219433`*^9}, {
   3.447571108224043*^9, 3.447571109605528*^9}, 3.44939714430721*^9, {
   3.450095728175057*^9, 3.4500957350203876`*^9}, {3.450617312595365*^9, 
   3.450617313988042*^9}, 3.450862072188416*^9, {3.4530135962889767`*^9, 
   3.453013596890226*^9}, {3.453015026043627*^9, 3.453015026385352*^9}, 
   3.45362334645658*^9, {3.4537217074948387`*^9, 3.4537218530198793`*^9}, {
   3.453721925031094*^9, 3.453721942244165*^9}, {3.453722342265911*^9, 
   3.453722359376067*^9}, {3.453722464409658*^9, 3.453722491976034*^9}, {
   3.4537226084944344`*^9, 3.453722616067287*^9}, {3.453722735445167*^9, 
   3.453722745738811*^9}, 3.454398589545465*^9, 3.495533203957129*^9, 
   3.495533315239236*^9, 3.4955334014211903`*^9, {3.4955336536500483`*^9, 
   3.4955336556860456`*^9}, 3.4955339262067966`*^9, 3.495534018795658*^9}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Clustering", " ", "History"}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.4510320096998158`*^9, 3.451032017002364*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"MergeSplitPlot", "[", "]"}], ":=", " ", 
  RowBox[{"(", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"currentMergeCount", " ", "=", " ", 
     RowBox[{"clusteringHistory", "@", 
      RowBox[{"listCurrentMergeCount", "[", "]"}]}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"currentMergeCount", " ", "=", " ", 
     RowBox[{"currentMergeCount", "@", 
      RowBox[{"toArray", "[", "]"}]}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"currentSplitCount", " ", "=", " ", 
     RowBox[{"clusteringHistory", "@", 
      RowBox[{"listCurrentSplitCount", "[", "]"}]}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"currentSplitCount", " ", "=", " ", 
     RowBox[{"currentSplitCount", "@", 
      RowBox[{"toArray", "[", "]"}]}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"ListLinePlot", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"currentMergeCount", ",", " ", "currentSplitCount"}], "}"}], 
      ",", 
      RowBox[{"ImageSize", "\[Rule]", "Large"}], ",", 
      RowBox[{"PlotStyle", "\[Rule]", 
       RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], ",", 
      RowBox[{"PlotRange", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"0", ",", 
         RowBox[{"Max", "[", 
          RowBox[{"{", 
           RowBox[{"currentMergeCount", ",", " ", "currentSplitCount"}], 
           "}"}], "]"}]}], "}"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{"PlotLegend", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"\"\<Merge\>\"", ",", "\"\<Split\>\""}], "}"}]}], ",", " ", 
      RowBox[{"LegendPosition", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "1"}], ",", 
         RowBox[{"-", "0.9"}]}], "}"}]}], ",", 
      RowBox[{"LegendSize", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"2", ",", "0.1"}], "}"}]}], ",", " ", 
      RowBox[{"LegendTextSpace", "\[Rule]", " ", "20"}], ",", " ", 
      RowBox[{"LegendShadow", "\[Rule]", "None"}]}], "\[IndentingNewLine]", 
     "]"}]}], "\[IndentingNewLine]", ")"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4510320226422377`*^9, 3.4510321324117317`*^9}, {
  3.4510322331986723`*^9, 3.451032359251792*^9}, {3.451032683632485*^9, 
  3.451032685316112*^9}, {3.451034876171261*^9, 3.451034924304841*^9}, {
  3.451153087532744*^9, 3.4511530935565147`*^9}, {3.45439860074019*^9, 
  3.45439860091986*^9}, {3.4543993423326607`*^9, 3.454399346162512*^9}, {
  3.454400747935226*^9, 3.454400768372382*^9}, {3.4544042505286283`*^9, 
  3.4544042964641743`*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Mean", " ", "Bar", " ", "Charts"}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.450618422901498*^9, 3.4506184238430653`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MeanRuntimeChart", "[", "algoList_", "]"}], ":=", 
   RowBox[{"BarChart", "[", 
    RowBox[{"RuntimeAverageList", "[", "algoList", "]"}], "]"}]}], 
  "\[IndentingNewLine]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.450617732831706*^9, 3.450617862087305*^9}, {
  3.450617892768948*^9, 3.450617902149879*^9}, {3.450617944152248*^9, 
  3.4506179522786283`*^9}, {3.450618051280591*^9, 3.450618061967638*^9}, {
  3.450618268990294*^9, 3.450618282099677*^9}, {3.450618351732362*^9, 
  3.450618355259982*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Mean", " ", "Lists"}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.4506184289819508`*^9, 3.450618430059287*^9}}],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"MeanRuntimeList", "[", "algoList_", "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"tuples", ",", " ", "data"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"tuples", " ", "=", 
       RowBox[{"Tuples", "[", 
        RowBox[{"{", 
         RowBox[{"algoList", ",", 
          RowBox[{"{", "\"\<Runtime\>\"", "}"}]}], "}"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"data", " ", "=", " ", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"Mean", "[", 
          RowBox[{"GetMeasure", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Part", "[", 
             RowBox[{
              RowBox[{"Part", "[", 
               RowBox[{"tuples", ",", "i"}], "]"}], ",", "1"}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"Part", "[", 
             RowBox[{
              RowBox[{"Part", "[", 
               RowBox[{"tuples", ",", "i"}], "]"}], ",", "2"}], "]"}]}], 
           "\[IndentingNewLine]", "]"}], "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{"i", ",", "1", ",", 
           RowBox[{"Length", "[", "tuples", "]"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Return", "[", "data", "]"}]}]}], "\[IndentingNewLine]", 
    "]"}]}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.450618186999844*^9, 3.450618249144108*^9}, {
   3.4506183645122347`*^9, 3.450618366453491*^9}, 3.450618421256262*^9, {
   3.45061865358731*^9, 3.450618663814521*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "Tables", " ", "*)"}], "\[IndentingNewLine]"}]], "Input",\

 CellChangeTimes->{{3.4506184468548517`*^9, 3.450618471322641*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"MeanRuntimeTable", "[", "algoList_", "]"}], ":=", " ", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"tuples", ",", " ", "data", ",", " ", "table"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"tuples", " ", "=", 
      RowBox[{"Tuples", "[", 
       RowBox[{"{", 
        RowBox[{"algoList", ",", 
         RowBox[{"{", "\"\<Runtime\>\"", "}"}]}], "}"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"data", " ", "=", " ", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"Mean", "[", 
         RowBox[{"GetMeasure", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Part", "[", 
            RowBox[{
             RowBox[{"Part", "[", 
              RowBox[{"tuples", ",", "i"}], "]"}], ",", "1"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Part", "[", 
            RowBox[{
             RowBox[{"Part", "[", 
              RowBox[{"tuples", ",", "i"}], "]"}], ",", "2"}], "]"}]}], 
          "\[IndentingNewLine]", "]"}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          RowBox[{"Length", "[", "tuples", "]"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"table", " ", "=", 
      RowBox[{"Prepend", "[", " ", 
       RowBox[{
        RowBox[{"Sort", "[", 
         RowBox[{
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"Part", "[", 
               RowBox[{"algoList", ",", "i"}], "]"}], ",", 
              RowBox[{"Part", "[", 
               RowBox[{"data", ",", "i"}], "]"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", "1", ",", 
              RowBox[{"Length", "[", "algoList", "]"}]}], "}"}]}], "]"}], ",",
           " ", 
          RowBox[{
           RowBox[{
            RowBox[{"#1", "[", 
             RowBox[{"[", "2", "]"}], "]"}], ">", 
            RowBox[{"#2", "[", 
             RowBox[{"[", "2", "]"}], "]"}]}], "&"}]}], "]"}], ",", " ", 
        RowBox[{"{", 
         RowBox[{"\"\< \>\"", ",", "\"\<Runtime [ms]\>\""}], "}"}]}], "]"}]}],
      ";", "\[IndentingNewLine]", 
     RowBox[{"Return", "[", "table", "]"}]}]}], "\[IndentingNewLine]", 
   "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4506185663569202`*^9, 3.450618599902895*^9}, {
  3.4506186988276777`*^9, 3.450618773501411*^9}, {3.450618818529851*^9, 
  3.450618915409473*^9}, {3.450619032130291*^9, 3.450619134399454*^9}, {
  3.4506191710101547`*^9, 3.450619191876889*^9}, {3.450683133950872*^9, 
  3.450683163475388*^9}, {3.4544014366808167`*^9, 3.454401443671588*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"MeanQualityTable", "[", 
   RowBox[{"algoList_", ",", " ", "qIList_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"tuples", ",", " ", "data", ",", " ", "table"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"tuples", " ", "=", 
      RowBox[{"Tuples", "[", 
       RowBox[{"{", 
        RowBox[{"algoList", ",", "qIList"}], "}"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"data", " ", "=", " ", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"GetMean", "[", 
         RowBox[{
          RowBox[{"algoList", "[", 
           RowBox[{"[", "i", "]"}], "]"}], ",", " ", 
          RowBox[{"qIList", "[", 
           RowBox[{"[", "j", "]"}], "]"}]}], " ", "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          RowBox[{"Length", "[", "algoList", "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"j", ",", "1", ",", 
          RowBox[{"Length", "[", "qIList", "]"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"table", " ", "=", " ", 
      RowBox[{"Prepend", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"Join", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"algoList", "[", 
              RowBox[{"[", "i", "]"}], "]"}], " ", "}"}], ",", 
            RowBox[{"data", "[", 
             RowBox[{"[", "i", "]"}], "]"}]}], "  ", "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "1", ",", 
            RowBox[{"Length", "[", "algoList", "]"}]}], "}"}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Prepend", "[", 
         RowBox[{"qIList", ",", "\"\< \>\""}], "]"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Return", "[", "table", "]"}]}]}], "\[IndentingNewLine]", 
   "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.450619623150649*^9, 3.4506196419803762`*^9}, {
  3.45067989552034*^9, 3.450679907369604*^9}, {3.4506806109077387`*^9, 
  3.450680613498094*^9}, {3.450681523516528*^9, 3.450681546462391*^9}, {
  3.450681592149233*^9, 3.450681610046215*^9}, {3.450681649046163*^9, 
  3.45068165921181*^9}, {3.450681752704067*^9, 3.450681824783483*^9}, {
  3.450681889508122*^9, 3.450681911175438*^9}, {3.450682132397917*^9, 
  3.450682141310402*^9}, {3.45068218707832*^9, 3.450682427617835*^9}, {
  3.450682465703582*^9, 3.4506824980343113`*^9}, {3.4506825366420727`*^9, 
  3.4506826041303787`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"MeanDistanceTable", "[", 
   RowBox[{"algoList_", ",", " ", "dMList_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"tuples", ",", " ", "data", ",", " ", "table"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"tuples", " ", "=", 
      RowBox[{"Tuples", "[", 
       RowBox[{"{", 
        RowBox[{"algoList", ",", "dMList"}], "}"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"data", " ", "=", " ", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"GetMean", "[", 
         RowBox[{
          RowBox[{"algoList", "[", 
           RowBox[{"[", "i", "]"}], "]"}], ",", " ", 
          RowBox[{"dMList", "[", 
           RowBox[{"[", "j", "]"}], "]"}]}], " ", "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          RowBox[{"Length", "[", "algoList", "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"j", ",", "1", ",", 
          RowBox[{"Length", "[", "dMList", "]"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"table", " ", "=", " ", 
      RowBox[{"Prepend", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"Join", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"algoList", "[", 
              RowBox[{"[", "i", "]"}], "]"}], " ", "}"}], ",", 
            RowBox[{"data", "[", 
             RowBox[{"[", "i", "]"}], "]"}]}], "  ", "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "1", ",", 
            RowBox[{"Length", "[", "algoList", "]"}]}], "}"}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Prepend", "[", 
         RowBox[{"dMList", ",", "\"\< \>\""}], "]"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Return", "[", "table", "]"}]}]}], "\[IndentingNewLine]", 
   "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.450680862656228*^9, 3.4506808764664707`*^9}, {
  3.450681246635697*^9, 3.450681250808097*^9}, {3.450682772601183*^9, 
  3.450682791537068*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"MeanClusterCountTable", "[", "algoList_", " ", "]"}], " ", ":=", 
  " ", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"tuples", ",", " ", "data", ",", " ", "table"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"tuples", " ", "=", " ", 
      RowBox[{"Tuples", "[", 
       RowBox[{"{", 
        RowBox[{"algoList", ",", " ", 
         RowBox[{"{", "\"\<k\>\"", "}"}]}], "}"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"data", " ", "=", " ", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"Mean", "[", 
         RowBox[{"GetMeasure", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Part", "[", 
            RowBox[{
             RowBox[{"Part", "[", 
              RowBox[{"tuples", ",", "i"}], "]"}], ",", "1"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Part", "[", 
            RowBox[{
             RowBox[{"Part", "[", 
              RowBox[{"tuples", ",", "i"}], "]"}], ",", "2"}], "]"}]}], 
          "\[IndentingNewLine]", "]"}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          RowBox[{"Length", "[", "tuples", "]"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"table", " ", "=", 
      RowBox[{"Prepend", "[", " ", 
       RowBox[{
        RowBox[{"Sort", "[", 
         RowBox[{
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"Part", "[", 
               RowBox[{"algoList", ",", "i"}], "]"}], ",", 
              RowBox[{"Part", "[", 
               RowBox[{"data", ",", "i"}], "]"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", "1", ",", 
              RowBox[{"Length", "[", "algoList", "]"}]}], "}"}]}], "]"}], ",",
           " ", 
          RowBox[{
           RowBox[{
            RowBox[{"#1", "[", 
             RowBox[{"[", "2", "]"}], "]"}], ">", 
            RowBox[{"#2", "[", 
             RowBox[{"[", "2", "]"}], "]"}]}], "&"}]}], "]"}], ",", " ", 
        RowBox[{"{", 
         RowBox[{"\"\< \>\"", ",", "\"\<Cluster Count\>\""}], "}"}]}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Return", "[", "table", "]"}]}]}], "\[IndentingNewLine]", 
   "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.49718261759517*^9, 3.497182651700329*^9}, {
   3.49718301796838*^9, 3.497183102750614*^9}, {3.497183148376947*^9, 
   3.497183192647698*^9}, {3.4971835188574142`*^9, 3.497183536837338*^9}, 
   3.497241330081061*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"MeanGrid", "[", 
   RowBox[{"algoList_", ",", "qIList_", ",", "dMList_"}], "]"}], ":=", 
  RowBox[{"Grid", "[", "\[IndentingNewLine]", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"Grid", "[", 
       RowBox[{
        RowBox[{"MeanRuntimeTable", "[", "algoList", "]"}], ",", 
        RowBox[{"Frame", "\[Rule]", "All"}]}], "]"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"Grid", "[", 
       RowBox[{
        RowBox[{"MeanClusterCountTable", "[", "algoList", "]"}], ",", " ", 
        RowBox[{"Frame", "\[Rule]", "All"}]}], "]"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"Grid", "[", 
       RowBox[{
        RowBox[{"MeanQualityTable", "[", 
         RowBox[{"algoList", ",", "qIList"}], "]"}], ",", 
        RowBox[{"Frame", "\[Rule]", "All"}]}], "]"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"Grid", "[", 
       RowBox[{
        RowBox[{"MeanDistanceTable", "[", 
         RowBox[{"algoList", ",", "dMList"}], "]"}], ",", 
        RowBox[{"Frame", "\[Rule]", "All"}]}], "]"}], "}"}]}], 
    "\[IndentingNewLine]", "}"}], "\[IndentingNewLine]", "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.450619269466153*^9, 3.450619285425149*^9}, {
  3.450619357724309*^9, 3.450619434572166*^9}, {3.450682634347971*^9, 
  3.45068276012606*^9}, {3.450682877816168*^9, 3.450682880118081*^9}, {
  3.497183549535224*^9, 3.4971835824252768`*^9}, {3.4972424119392023`*^9, 
  3.4972424129768543`*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", "Variance", " ", "*)"}]], "Input",
 CellChangeTimes->{{3.4537749076267757`*^9, 3.4537749129747467`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"RuntimeVarianceTable", "[", "algoList_", "]"}], ":=", " ", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"tuples", ",", " ", "data", ",", " ", "table"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"tuples", " ", "=", 
      RowBox[{"Tuples", "[", 
       RowBox[{"{", 
        RowBox[{"algoList", ",", 
         RowBox[{"{", "\"\<Runtime\>\"", "}"}]}], "}"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"data", " ", "=", " ", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"Variance", "[", 
         RowBox[{"GetMeasure", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Part", "[", 
            RowBox[{
             RowBox[{"Part", "[", 
              RowBox[{"tuples", ",", "i"}], "]"}], ",", "1"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Part", "[", 
            RowBox[{
             RowBox[{"Part", "[", 
              RowBox[{"tuples", ",", "i"}], "]"}], ",", "2"}], "]"}]}], 
          "\[IndentingNewLine]", "]"}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          RowBox[{"Length", "[", "tuples", "]"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"table", " ", "=", 
      RowBox[{"Prepend", "[", " ", 
       RowBox[{
        RowBox[{"Sort", "[", 
         RowBox[{
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"Part", "[", 
               RowBox[{"algoList", ",", "i"}], "]"}], ",", 
              RowBox[{"Part", "[", 
               RowBox[{"data", ",", "i"}], "]"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", "1", ",", 
              RowBox[{"Length", "[", "algoList", "]"}]}], "}"}]}], "]"}], ",",
           " ", 
          RowBox[{
           RowBox[{
            RowBox[{"#1", "[", 
             RowBox[{"[", "2", "]"}], "]"}], ">", 
            RowBox[{"#2", "[", 
             RowBox[{"[", "2", "]"}], "]"}]}], "&"}]}], "]"}], ",", " ", 
        RowBox[{"{", 
         RowBox[{"\"\< \>\"", ",", "\"\<Runtime [ms]\>\""}], "}"}]}], "]"}]}],
      ";", "\[IndentingNewLine]", 
     RowBox[{"Return", "[", "table", "]"}]}]}], "\[IndentingNewLine]", 
   "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4506185663569202`*^9, 3.450618599902895*^9}, {
  3.4506186988276777`*^9, 3.450618773501411*^9}, {3.450618818529851*^9, 
  3.450618915409473*^9}, {3.450619032130291*^9, 3.450619134399454*^9}, {
  3.4506191710101547`*^9, 3.450619191876889*^9}, {3.450683133950872*^9, 
  3.450683163475388*^9}, {3.453774602284346*^9, 3.453774636858672*^9}, {
  3.454401495605274*^9, 3.454401502166247*^9}, {3.497184623883745*^9, 
  3.4971846262661963`*^9}, {3.497241849274156*^9, 3.497241856020976*^9}, {
  3.497243130275634*^9, 3.497243137549508*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"ClusterCountVarianceTable", "[", "algoList_", "]"}], ":=", " ", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"tuples", ",", " ", "data", ",", " ", "table"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"tuples", " ", "=", 
      RowBox[{"Tuples", "[", 
       RowBox[{"{", 
        RowBox[{"algoList", ",", 
         RowBox[{"{", "\"\<k\>\"", "}"}]}], "}"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"data", " ", "=", " ", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"Variance", "[", 
         RowBox[{"GetMeasure", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Part", "[", 
            RowBox[{
             RowBox[{"Part", "[", 
              RowBox[{"tuples", ",", "i"}], "]"}], ",", "1"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Part", "[", 
            RowBox[{
             RowBox[{"Part", "[", 
              RowBox[{"tuples", ",", "i"}], "]"}], ",", "2"}], "]"}]}], 
          "\[IndentingNewLine]", "]"}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          RowBox[{"Length", "[", "tuples", "]"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"table", " ", "=", 
      RowBox[{"Prepend", "[", " ", 
       RowBox[{
        RowBox[{"Sort", "[", 
         RowBox[{
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"Part", "[", 
               RowBox[{"algoList", ",", "i"}], "]"}], ",", 
              RowBox[{"Part", "[", 
               RowBox[{"data", ",", "i"}], "]"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", "1", ",", 
              RowBox[{"Length", "[", "algoList", "]"}]}], "}"}]}], "]"}], ",",
           " ", 
          RowBox[{
           RowBox[{
            RowBox[{"#1", "[", 
             RowBox[{"[", "2", "]"}], "]"}], ">", 
            RowBox[{"#2", "[", 
             RowBox[{"[", "2", "]"}], "]"}]}], "&"}]}], "]"}], ",", " ", 
        RowBox[{"{", 
         RowBox[{"\"\< \>\"", ",", "\"\<Cluster Count\>\""}], "}"}]}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Return", "[", "table", "]"}]}]}], "\[IndentingNewLine]", 
   "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.497184630534593*^9, 3.497184650953146*^9}, 
   3.497241273575656*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"QualityVarianceTable", "[", 
   RowBox[{"algoList_", ",", " ", "qIList_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"tuples", ",", " ", "data", ",", " ", "table"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"tuples", " ", "=", 
      RowBox[{"Tuples", "[", 
       RowBox[{"{", 
        RowBox[{"algoList", ",", "qIList"}], "}"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"data", " ", "=", " ", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"GetVariance", "[", 
         RowBox[{
          RowBox[{"algoList", "[", 
           RowBox[{"[", "i", "]"}], "]"}], ",", " ", 
          RowBox[{"qIList", "[", 
           RowBox[{"[", "j", "]"}], "]"}]}], " ", "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          RowBox[{"Length", "[", "algoList", "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"j", ",", "1", ",", 
          RowBox[{"Length", "[", "qIList", "]"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"table", " ", "=", " ", 
      RowBox[{"Prepend", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"Join", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"algoList", "[", 
              RowBox[{"[", "i", "]"}], "]"}], " ", "}"}], ",", 
            RowBox[{"data", "[", 
             RowBox[{"[", "i", "]"}], "]"}]}], "  ", "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "1", ",", 
            RowBox[{"Length", "[", "algoList", "]"}]}], "}"}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Prepend", "[", 
         RowBox[{"qIList", ",", "\"\< \>\""}], "]"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Return", "[", "table", "]"}]}]}], "\[IndentingNewLine]", 
   "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.450619623150649*^9, 3.4506196419803762`*^9}, {
  3.45067989552034*^9, 3.450679907369604*^9}, {3.4506806109077387`*^9, 
  3.450680613498094*^9}, {3.450681523516528*^9, 3.450681546462391*^9}, {
  3.450681592149233*^9, 3.450681610046215*^9}, {3.450681649046163*^9, 
  3.45068165921181*^9}, {3.450681752704067*^9, 3.450681824783483*^9}, {
  3.450681889508122*^9, 3.450681911175438*^9}, {3.450682132397917*^9, 
  3.450682141310402*^9}, {3.45068218707832*^9, 3.450682427617835*^9}, {
  3.450682465703582*^9, 3.4506824980343113`*^9}, {3.4506825366420727`*^9, 
  3.4506826041303787`*^9}, {3.4537749435646772`*^9, 3.4537749471467037`*^9}, {
  3.4537750235565033`*^9, 3.453775025474555*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DistanceVarianceTable", "[", 
   RowBox[{"algoList_", ",", " ", "dMList_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"tuples", ",", " ", "data", ",", " ", "table"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"tuples", " ", "=", 
      RowBox[{"Tuples", "[", 
       RowBox[{"{", 
        RowBox[{"algoList", ",", "dMList"}], "}"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"data", " ", "=", " ", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"GetVariance", "[", 
         RowBox[{
          RowBox[{"algoList", "[", 
           RowBox[{"[", "i", "]"}], "]"}], ",", " ", 
          RowBox[{"dMList", "[", 
           RowBox[{"[", "j", "]"}], "]"}]}], " ", "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          RowBox[{"Length", "[", "algoList", "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"j", ",", "1", ",", 
          RowBox[{"Length", "[", "dMList", "]"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"table", " ", "=", " ", 
      RowBox[{"Prepend", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"Join", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"algoList", "[", 
              RowBox[{"[", "i", "]"}], "]"}], " ", "}"}], ",", 
            RowBox[{"data", "[", 
             RowBox[{"[", "i", "]"}], "]"}]}], "  ", "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "1", ",", 
            RowBox[{"Length", "[", "algoList", "]"}]}], "}"}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Prepend", "[", 
         RowBox[{"dMList", ",", "\"\< \>\""}], "]"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Return", "[", "table", "]"}]}]}], "\[IndentingNewLine]", 
   "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.450680862656228*^9, 3.4506808764664707`*^9}, {
  3.450681246635697*^9, 3.450681250808097*^9}, {3.450682772601183*^9, 
  3.450682791537068*^9}, {3.453775029068656*^9, 3.453775037650453*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"Maximum", " ", "&"}], " ", "Minimum"}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.453775152373448*^9, 3.4537751787842827`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"RuntimeTable", "[", 
   RowBox[{"algoList_", ",", " ", "f_"}], "]"}], ":=", " ", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"tuples", ",", " ", "data", ",", " ", "table"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"tuples", " ", "=", 
      RowBox[{"Tuples", "[", 
       RowBox[{"{", 
        RowBox[{"algoList", ",", 
         RowBox[{"{", "\"\<Runtime\>\"", "}"}]}], "}"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"data", " ", "=", " ", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"f", "[", 
         RowBox[{"GetMeasure", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Part", "[", 
            RowBox[{
             RowBox[{"Part", "[", 
              RowBox[{"tuples", ",", "i"}], "]"}], ",", "1"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Part", "[", 
            RowBox[{
             RowBox[{"Part", "[", 
              RowBox[{"tuples", ",", "i"}], "]"}], ",", "2"}], "]"}]}], 
          "\[IndentingNewLine]", "]"}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          RowBox[{"Length", "[", "tuples", "]"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"table", " ", "=", 
      RowBox[{"Prepend", "[", " ", 
       RowBox[{
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Part", "[", 
             RowBox[{"algoList", ",", "i"}], "]"}], ",", 
            RowBox[{"Part", "[", 
             RowBox[{"data", ",", "i"}], "]"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "1", ",", 
            RowBox[{"Length", "[", "algoList", "]"}]}], "}"}]}], "]"}], ",", 
        " ", 
        RowBox[{"{", 
         RowBox[{"\"\< \>\"", ",", "\"\<Runtime [ms]\>\""}], "}"}]}], "]"}]}],
      ";", "\[IndentingNewLine]", 
     RowBox[{"Return", "[", "table", "]"}]}]}], "\[IndentingNewLine]", 
   "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4506185663569202`*^9, 3.450618599902895*^9}, {
   3.4506186988276777`*^9, 3.450618773501411*^9}, {3.450618818529851*^9, 
   3.450618915409473*^9}, {3.450619032130291*^9, 3.450619134399454*^9}, {
   3.4506191710101547`*^9, 3.450619191876889*^9}, {3.450683133950872*^9, 
   3.450683163475388*^9}, {3.453775200510399*^9, 3.4537752046764812`*^9}, {
   3.453775267987245*^9, 3.4537752684664087`*^9}, {3.453775543948107*^9, 
   3.4537755740441113`*^9}, {3.49718410433943*^9, 3.497184128523168*^9}, 
   3.497241658094695*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"ClusterCountTable", "[", 
   RowBox[{"algoList_", ",", " ", "f_"}], "]"}], ":=", " ", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"tuples", ",", " ", "data", ",", " ", "table"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"tuples", " ", "=", 
      RowBox[{"Tuples", "[", 
       RowBox[{"{", 
        RowBox[{"algoList", ",", 
         RowBox[{"{", "\"\<k\>\"", "}"}]}], "}"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"data", " ", "=", " ", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"f", "[", 
         RowBox[{"GetMeasure", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Part", "[", 
            RowBox[{
             RowBox[{"Part", "[", 
              RowBox[{"tuples", ",", "i"}], "]"}], ",", "1"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Part", "[", 
            RowBox[{
             RowBox[{"Part", "[", 
              RowBox[{"tuples", ",", "i"}], "]"}], ",", "2"}], "]"}]}], 
          "\[IndentingNewLine]", "]"}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          RowBox[{"Length", "[", "tuples", "]"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"table", " ", "=", 
      RowBox[{"Prepend", "[", " ", 
       RowBox[{
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Part", "[", 
             RowBox[{"algoList", ",", "i"}], "]"}], ",", 
            RowBox[{"Part", "[", 
             RowBox[{"data", ",", "i"}], "]"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "1", ",", 
            RowBox[{"Length", "[", "algoList", "]"}]}], "}"}]}], "]"}], ",", 
        " ", 
        RowBox[{"{", 
         RowBox[{"\"\< \>\"", ",", "\"\<Cluster Count\>\""}], "}"}]}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Return", "[", "table", "]"}]}]}], "\[IndentingNewLine]", 
   "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4506185663569202`*^9, 3.450618599902895*^9}, {
   3.4506186988276777`*^9, 3.450618773501411*^9}, {3.450618818529851*^9, 
   3.450618915409473*^9}, {3.450619032130291*^9, 3.450619134399454*^9}, {
   3.4506191710101547`*^9, 3.450619191876889*^9}, {3.450683133950872*^9, 
   3.450683163475388*^9}, {3.453775200510399*^9, 3.4537752046764812`*^9}, {
   3.453775267987245*^9, 3.4537752684664087`*^9}, {3.453775543948107*^9, 
   3.4537755740441113`*^9}, {3.49718410433943*^9, 3.497184128523168*^9}, 
   3.497241658094695*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"QualityTable", "[", 
   RowBox[{"algoList_", ",", " ", "qIList_", ",", "f_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"tuples", ",", " ", "data", ",", " ", "table"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"tuples", " ", "=", 
      RowBox[{"Tuples", "[", 
       RowBox[{"{", 
        RowBox[{"algoList", ",", "qIList"}], "}"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"data", " ", "=", " ", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"f", "[", 
         RowBox[{
          RowBox[{"algoList", "[", 
           RowBox[{"[", "i", "]"}], "]"}], ",", " ", 
          RowBox[{"qIList", "[", 
           RowBox[{"[", "j", "]"}], "]"}]}], " ", "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          RowBox[{"Length", "[", "algoList", "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"j", ",", "1", ",", 
          RowBox[{"Length", "[", "qIList", "]"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"table", " ", "=", " ", 
      RowBox[{"Prepend", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"Join", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"algoList", "[", 
              RowBox[{"[", "i", "]"}], "]"}], " ", "}"}], ",", 
            RowBox[{"data", "[", 
             RowBox[{"[", "i", "]"}], "]"}]}], "  ", "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "1", ",", 
            RowBox[{"Length", "[", "algoList", "]"}]}], "}"}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Prepend", "[", 
         RowBox[{"qIList", ",", "\"\< \>\""}], "]"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Return", "[", "table", "]"}]}]}], "\[IndentingNewLine]", 
   "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.450619623150649*^9, 3.4506196419803762`*^9}, {
   3.45067989552034*^9, 3.450679907369604*^9}, {3.4506806109077387`*^9, 
   3.450680613498094*^9}, {3.450681523516528*^9, 3.450681546462391*^9}, {
   3.450681592149233*^9, 3.450681610046215*^9}, {3.450681649046163*^9, 
   3.45068165921181*^9}, {3.450681752704067*^9, 3.450681824783483*^9}, {
   3.450681889508122*^9, 3.450681911175438*^9}, {3.450682132397917*^9, 
   3.450682141310402*^9}, {3.45068218707832*^9, 3.450682427617835*^9}, {
   3.450682465703582*^9, 3.4506824980343113`*^9}, {3.4506825366420727`*^9, 
   3.4506826041303787`*^9}, {3.4537752337712517`*^9, 3.453775238394479*^9}, {
   3.4537752802829227`*^9, 3.453775281482359*^9}, {3.453775548778647*^9, 
   3.4537755512204733`*^9}, {3.453775582234086*^9, 3.45377558272185*^9}, 
   3.453775771343355*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DistanceTable", "[", 
   RowBox[{"algoList_", ",", " ", "dMList_", ",", " ", "f_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"tuples", ",", " ", "data", ",", " ", "table"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"tuples", " ", "=", 
      RowBox[{"Tuples", "[", 
       RowBox[{"{", 
        RowBox[{"algoList", ",", "dMList"}], "}"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"data", " ", "=", " ", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"f", "[", 
         RowBox[{
          RowBox[{"algoList", "[", 
           RowBox[{"[", "i", "]"}], "]"}], ",", " ", 
          RowBox[{"dMList", "[", 
           RowBox[{"[", "j", "]"}], "]"}]}], " ", "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          RowBox[{"Length", "[", "algoList", "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"j", ",", "1", ",", 
          RowBox[{"Length", "[", "dMList", "]"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"table", " ", "=", " ", 
      RowBox[{"Prepend", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"Join", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"algoList", "[", 
              RowBox[{"[", "i", "]"}], "]"}], " ", "}"}], ",", 
            RowBox[{"data", "[", 
             RowBox[{"[", "i", "]"}], "]"}]}], "  ", "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "1", ",", 
            RowBox[{"Length", "[", "algoList", "]"}]}], "}"}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Prepend", "[", 
         RowBox[{"dMList", ",", "\"\< \>\""}], "]"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Return", "[", "table", "]"}]}]}], "\[IndentingNewLine]", 
   "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.450680862656228*^9, 3.4506808764664707`*^9}, {
   3.450681246635697*^9, 3.450681250808097*^9}, {3.450682772601183*^9, 
   3.450682791537068*^9}, {3.45377524700305*^9, 3.453775284890607*^9}, {
   3.453775553706469*^9, 3.453775555453862*^9}, {3.453775585650351*^9, 
   3.453775586369955*^9}, 3.4537757752455797`*^9}],

Cell[BoxData[
 RowBox[{"(*", " ", "PlotALL", " ", "*)"}]], "Input",
 CellChangeTimes->{{3.453774591651869*^9, 3.453774598335335*^9}}],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"PlotAll", "[", "]"}], ":=", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"smoothingRange", " ", "=", " ", 
      RowBox[{"Round", "[", 
       RowBox[{
        RowBox[{"GetTMax", "[", "]"}], " ", "/", " ", "50"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Return", "[", "\[IndentingNewLine]", 
      RowBox[{"Panel", "[", "\[IndentingNewLine]", 
       RowBox[{"Column", "[", "\[IndentingNewLine]", 
        RowBox[{"{", "\[IndentingNewLine]", 
         RowBox[{"\"\<Graph Properties\>\"", ",", "\[IndentingNewLine]", 
          RowBox[{"Row", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"\"\<Graph: \>\"", " ", "<>", " ", "graphPath"}], ",", 
             " ", 
             RowBox[{
             "\"\<  Time Step Aggregation: \>\"", " ", "<>", " ", 
              "timeStepAggregation"}]}], "}"}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"GraphPropertyPlot", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"GetGraphProperty", "[", "\"\<n\>\"", "]"}], ",", 
              RowBox[{"GetGraphProperty", "[", "\"\<m\>\"", "]"}]}], "}"}], 
            ",", 
            RowBox[{"{", 
             RowBox[{"\"\<n\>\"", ",", "\"\<m\>\""}], "}"}]}], "]"}], ",", 
          "\[IndentingNewLine]", "\"\<Cluster Events\>\"", ",", 
          "\[IndentingNewLine]", 
          RowBox[{"MergeSplitPlot", "[", "]"}], ",", "\[IndentingNewLine]", 
          "\"\<Runtime\>\"", ",", "\[IndentingNewLine]", 
          RowBox[{"RuntimePlot", "[", "algos", "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Row", "[", 
           RowBox[{"{", 
            RowBox[{"\"\<Total Runtime [s]: \>\"", ",", " ", 
             RowBox[{"GetTotalRuntime", "[", "]"}]}], "}"}], "]"}], ",", 
          "\[IndentingNewLine]", "\"\<Cluster Count\>\"", ",", 
          "\[IndentingNewLine]", 
          RowBox[{"ClusterPlot", "[", "algos", "]"}], ",", 
          "\[IndentingNewLine]", "\"\<Quality: Raw Data\>\"", ",", 
          "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"qis", " ", "\[Equal]", " ", 
              RowBox[{"{", "}"}]}], " ", "||", "\[NonBreakingSpace]", 
             RowBox[{"(", 
              RowBox[{"!", " ", "plotRawQuality"}], ")"}]}], ",", "Null", ",", 
            RowBox[{"QCP", " ", "=", " ", 
             RowBox[{"QualityComparePlot", "[", 
              RowBox[{"algos", ",", "qis"}], "]"}]}]}], "]"}], ",", 
          "\[IndentingNewLine]", "\"\<Quality: Smooth Data\>\"", ",", 
          "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"qis", " ", "\[Equal]", " ", 
              RowBox[{"{", "}"}]}], " ", "||", "\[NonBreakingSpace]", 
             RowBox[{"(", 
              RowBox[{"!", " ", "plotSmoothQuality"}], ")"}]}], ",", "Null", 
            ",", 
            RowBox[{"SQCP", " ", "=", 
             RowBox[{"SmoothQualityComparePlot", "[", 
              RowBox[{"algos", ",", "qis", ",", " ", "smoothingRange"}], 
              "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
          "\"\<Distance: Raw Data\>\"", ",", "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"dms", " ", "\[Equal]", 
              RowBox[{"{", "}"}]}], " ", "||", " ", 
             RowBox[{"(", 
              RowBox[{"!", " ", "plotRawDistance"}], ")"}]}], " ", ",", 
            "Null", ",", 
            RowBox[{"DCP", " ", "=", " ", 
             RowBox[{"DistanceComparePlot", "[", 
              RowBox[{"algos", ",", " ", "dms"}], "]"}]}]}], "]"}], ",", 
          "\[IndentingNewLine]", "\"\<Distance: Smooth Data\>\"", ",", 
          "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"dms", " ", "\[Equal]", 
              RowBox[{"{", "}"}]}], " ", "||", "\[NonBreakingSpace]", 
             RowBox[{"(", 
              RowBox[{"!", " ", "plotSmoothDistance"}], ")"}]}], ",", "Null", 
            ",", 
            RowBox[{"SDCP", " ", "=", " ", 
             RowBox[{"SmoothDistanceComparePlot", "[", 
              RowBox[{"algos", ",", " ", "dms", ",", " ", "smoothingRange"}], 
              "]"}]}]}], "]"}]}], "\[IndentingNewLine]", "}"}], 
        "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", "]"}], 
      "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
    ")"}]}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4492336829260273`*^9, 3.4492337990637493`*^9}, {
   3.449233834191533*^9, 3.449233838496731*^9}, {3.449233888209709*^9, 
   3.4492338913350058`*^9}, {3.449233992712352*^9, 3.449234006376532*^9}, {
   3.449234183604636*^9, 3.449234186105548*^9}, {3.44931801096719*^9, 
   3.449318072103203*^9}, {3.449389400711854*^9, 3.4493894165054407`*^9}, {
   3.450683202111472*^9, 3.450683303868272*^9}, {3.450683339437502*^9, 
   3.450683367444687*^9}, 3.450691628245277*^9, {3.453618797908815*^9, 
   3.453618806682831*^9}, {3.453618963840062*^9, 3.453618967828418*^9}, {
   3.453619372917498*^9, 3.453619375812401*^9}, {3.453620884581358*^9, 
   3.453620937819438*^9}, {3.453621035939287*^9, 3.45362106314107*^9}, {
   3.453621119932412*^9, 3.4536211390212183`*^9}, {3.453621222463217*^9, 
   3.453621226595478*^9}, {3.453621303878971*^9, 3.4536213160995197`*^9}, {
   3.453621370209092*^9, 3.453621372591124*^9}, {3.453621537291893*^9, 
   3.453621546185663*^9}, {3.453623255917405*^9, 3.4536232586977787`*^9}, {
   3.4536241825068607`*^9, 3.453624251424589*^9}, {3.453630338868247*^9, 
   3.453630339377482*^9}, {3.453630379648181*^9, 3.4536303801241207`*^9}, {
   3.453630426781301*^9, 3.4536304274797297`*^9}, 3.453630585138516*^9, {
   3.453630634573934*^9, 3.45363063641987*^9}, {3.453631351069206*^9, 
   3.453631351531313*^9}, {3.453721537396729*^9, 3.453721548415784*^9}, {
   3.453721894081938*^9, 3.45372190598295*^9}, {3.453722376779346*^9, 
   3.4537223888992662`*^9}, {3.4537224408217*^9, 3.453722447538843*^9}, {
   3.453722686511622*^9, 3.453722716840317*^9}, {3.453723071417246*^9, 
   3.453723113919709*^9}, {3.453723208838655*^9, 3.453723209052408*^9}, {
   3.4537235896168547`*^9, 3.4537235902787733`*^9}, {3.4537758489553957`*^9, 
   3.453775882256734*^9}, {3.4537759154334803`*^9, 3.453775917703218*^9}, {
   3.453775971063766*^9, 3.453775974511331*^9}, {3.453776458650247*^9, 
   3.4537764663074093`*^9}, {3.4537891855791893`*^9, 
   3.4537891902895393`*^9}, {3.453794488456156*^9, 3.4537945259403973`*^9}, {
   3.453794633844417*^9, 3.453794638660818*^9}, {3.453794750217472*^9, 
   3.453794750860156*^9}, {3.453795160988349*^9, 3.453795177696331*^9}, {
   3.453799499182199*^9, 3.4537995025663*^9}, {3.453799685558443*^9, 
   3.453799701611206*^9}, {3.454323466837059*^9, 3.45432351630639*^9}, {
   3.4543986828519793`*^9, 3.4543987751144953`*^9}, {3.45476690615606*^9, 
   3.45476690973596*^9}, {3.454766978664194*^9, 3.454766995430488*^9}, {
   3.454830876655249*^9, 3.454830878351807*^9}, {3.455000358360421*^9, 
   3.455000389805111*^9}, {3.455000424769951*^9, 3.455000477110642*^9}, {
   3.455520486539136*^9, 3.455520513934808*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"GridAll", "[", "]"}], " ", ":=", " ", 
  RowBox[{"Return", "[", "\[IndentingNewLine]", 
   RowBox[{"Panel", "[", "\[IndentingNewLine]", 
    RowBox[{"Column", "[", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\"\<Graph: \>\"", " ", "<>", " ", "graphPath"}], ",", 
       "\[IndentingNewLine]", "\"\< \>\"", ",", "\[IndentingNewLine]", 
       "\"\<Mean\>\"", ",", "\[IndentingNewLine]", 
       RowBox[{"Grid", "[", 
        RowBox[{
         RowBox[{"MeanRuntimeTable", "[", "algos", "]"}], ",", 
         RowBox[{"Frame", "\[Rule]", "All"}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Grid", "[", 
        RowBox[{
         RowBox[{"MeanClusterCountTable", "[", "algos", "]"}], ",", " ", 
         RowBox[{"Frame", "\[Rule]", "All"}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Grid", "[", 
        RowBox[{
         RowBox[{"MeanQualityTable", "[", 
          RowBox[{"algos", ",", "qis"}], "]"}], ",", " ", 
         RowBox[{"Frame", "\[Rule]", "All"}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Grid", "[", 
        RowBox[{
         RowBox[{"MeanDistanceTable", "[", 
          RowBox[{"algos", ",", "dms"}], "]"}], ",", " ", 
         RowBox[{"Frame", "\[Rule]", "All"}]}], "]"}], ",", 
       "\[IndentingNewLine]", "\"\<Variance\>\"", ",", "\[IndentingNewLine]", 
       
       RowBox[{"Grid", "[", 
        RowBox[{
         RowBox[{"RuntimeVarianceTable", "[", "algos", "]"}], ",", " ", 
         RowBox[{"Frame", "\[Rule]", "All"}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Grid", "[", 
        RowBox[{
         RowBox[{"ClusterCountVarianceTable", "[", "algos", "]"}], ",", " ", 
         RowBox[{"Frame", "\[Rule]", "All"}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Grid", "[", 
        RowBox[{
         RowBox[{"QualityVarianceTable", "[", 
          RowBox[{"algos", ",", "qis"}], "]"}], ",", " ", 
         RowBox[{"Frame", "\[Rule]", "All"}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Grid", "[", 
        RowBox[{
         RowBox[{"DistanceVarianceTable", "[", 
          RowBox[{"algos", ",", "dms"}], "]"}], ",", " ", 
         RowBox[{"Frame", "\[Rule]", "All"}]}], "]"}], ",", 
       "\[IndentingNewLine]", "\"\<Maximum\>\"", ",", "\[IndentingNewLine]", 
       RowBox[{"Grid", "[", 
        RowBox[{
         RowBox[{"RuntimeTable", "[", 
          RowBox[{"algos", ",", " ", "Max"}], "]"}], ",", 
         RowBox[{"Frame", "\[Rule]", "All"}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Grid", "[", 
        RowBox[{
         RowBox[{"ClusterCountTable", "[", 
          RowBox[{"algos", ",", " ", "Max"}], "]"}], ",", 
         RowBox[{"Frame", "\[Rule]", "All"}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Grid", "[", 
        RowBox[{
         RowBox[{"QualityTable", "[", 
          RowBox[{"algos", ",", "qis", ",", " ", "GetMax"}], "]"}], ",", " ", 
         
         RowBox[{"Frame", "\[Rule]", "All"}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Grid", "[", 
        RowBox[{
         RowBox[{"DistanceTable", "[", 
          RowBox[{"algos", ",", "dms", ",", " ", "GetMax"}], "]"}], ",", " ", 
         
         RowBox[{"Frame", "\[Rule]", "All"}]}], "]"}], ",", 
       "\[IndentingNewLine]", "\"\<Minimum\>\"", ",", "\[IndentingNewLine]", 
       RowBox[{"Grid", "[", 
        RowBox[{
         RowBox[{"RuntimeTable", "[", 
          RowBox[{"algos", ",", " ", "Min"}], "]"}], ",", 
         RowBox[{"Frame", "\[Rule]", "All"}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Grid", "[", 
        RowBox[{
         RowBox[{"ClusterCountTable", "[", 
          RowBox[{"algos", ",", " ", "Min"}], "]"}], ",", 
         RowBox[{"Frame", "\[Rule]", "All"}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Grid", "[", 
        RowBox[{
         RowBox[{"QualityTable", "[", 
          RowBox[{"algos", ",", "qis", ",", " ", "GetMin"}], "]"}], ",", " ", 
         
         RowBox[{"Frame", "\[Rule]", "All"}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Grid", "[", 
        RowBox[{
         RowBox[{"DistanceTable", "[", 
          RowBox[{"algos", ",", "dms", ",", " ", "GetMin"}], "]"}], ",", " ", 
         
         RowBox[{"Frame", "\[Rule]", "All"}]}], "]"}], ","}], 
      "\[IndentingNewLine]", "}"}], "\[IndentingNewLine]", "]"}], 
    "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.450691637477435*^9, 3.450691667247911*^9}, {
   3.450693344756043*^9, 3.450693347456197*^9}, {3.4537746727545643`*^9, 
   3.453774678144638*^9}, {3.453774797595031*^9, 3.453774876944971*^9}, {
   3.453775064716975*^9, 3.453775091065806*^9}, {3.453775398663253*^9, 
   3.453775479255995*^9}, {3.453775593116531*^9, 3.4537756320957937`*^9}, {
   3.454324868908931*^9, 3.454324886953703*^9}, {3.497184040844369*^9, 
   3.497184061459833*^9}, {3.497184374407462*^9, 3.49718440948429*^9}, {
   3.4972399266971617`*^9, 3.497239960608493*^9}, 3.497241202613056*^9, {
   3.497241822918261*^9, 3.497241827899293*^9}}],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.455000153450869*^9, 3.455000158089069*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"plotGraphProperties", " ", "=", " ", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"plotClusterEvents", " ", "=", " ", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"plotRuntime", " ", "=", " ", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"plotClusterCount", " ", "=", " ", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"plotRawQuality", " ", "=", " ", "False"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"plotSmoothQuality", " ", "=", " ", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"plotRawDistance", " ", "=", " ", "False"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"plotSmoothDistance", " ", "=", " ", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"plotSelect", " ", "=", " ", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\"\<Graph Properties\>\"", ",", " ", 
       RowBox[{"Checkbox", "[", 
        RowBox[{"Dynamic", "[", "plotGraphProperties", "]"}], "]"}]}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<Cluster Events\>\"", ",", " ", 
       RowBox[{"Checkbox", "[", 
        RowBox[{"Dynamic", "[", "plotClusterEvents", "]"}], "]"}]}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<Runtime\>\"", ",", "  ", 
       RowBox[{"Checkbox", "[", 
        RowBox[{"Dynamic", "[", "plotRuntime", "]"}], "]"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<Cluster Count\>\"", ",", "  ", 
       RowBox[{"Checkbox", "[", 
        RowBox[{"Dynamic", "[", "plotClusterCount", "]"}], "]"}]}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<Quality: Raw Data\>\"", ",", "  ", 
       RowBox[{"Checkbox", "[", 
        RowBox[{"Dynamic", "[", "plotRawQuality", "]"}], "]"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<Quality: Smooth Data\>\"", ",", "  ", 
       RowBox[{"Checkbox", "[", 
        RowBox[{"Dynamic", "[", "plotSmoothQuality", "]"}], "]"}]}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<Distance: Raw Data\>\"", ",", "  ", 
       RowBox[{"Checkbox", "[", 
        RowBox[{"Dynamic", "[", "plotRawDistance", "]"}], "]"}]}], "}"}], ",",
      "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<Distance: Smooth Data\>\"", ",", "  ", 
       RowBox[{"Checkbox", "[", 
        RowBox[{"Dynamic", "[", "plotSmoothDistance", "]"}], "]"}]}], "}"}]}],
     "\[IndentingNewLine]", "}"}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.454999717696685*^9, 3.454999799123054*^9}, {
  3.4549999581391077`*^9, 3.455000123988922*^9}, {3.455000163916567*^9, 
  3.4550002835575867`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"plotSelectPanel", " ", "=", 
    RowBox[{"Dynamic", "[", "\[IndentingNewLine]", 
     RowBox[{"Panel", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Text", "@", 
        RowBox[{"Grid", "[", 
         RowBox[{
          RowBox[{"Prepend", "[", 
           RowBox[{"plotSelect", ",", 
            RowBox[{"{", 
             RowBox[{"\"\<Plot\>\"", ",", "\"\<Draw\>\""}], "}"}]}], "]"}], 
          ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"None", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Lighter", "[", 
                RowBox[{"Yellow", ",", ".9"}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"White", ",", 
                 RowBox[{"Lighter", "[", 
                  RowBox[{
                   RowBox[{"Blend", "[", 
                    RowBox[{"{", 
                    RowBox[{"Blue", ",", "Green"}], "}"}], "]"}], ",", ".8"}],
                   "]"}]}], "}"}]}], "}"}]}], "}"}]}], ",", 
          RowBox[{"Dividers", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Darker", "[", 
                RowBox[{"Gray", ",", ".6"}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"Lighter", "[", 
                 RowBox[{"Gray", ",", ".5"}], "]"}], "}"}], ",", 
               RowBox[{"Darker", "[", 
                RowBox[{"Gray", ",", ".6"}], "]"}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Darker", "[", 
                RowBox[{"Gray", ",", ".6"}], "]"}], ",", 
               RowBox[{"Darker", "[", 
                RowBox[{"Gray", ",", ".6"}], "]"}], ",", 
               RowBox[{"{", "False", "}"}], ",", 
               RowBox[{"Darker", "[", 
                RowBox[{"Gray", ",", ".6"}], "]"}]}], "}"}]}], "}"}]}], ",", 
          RowBox[{"Alignment", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"{", 
             RowBox[{"Left", ",", "Right", ",", 
              RowBox[{"{", "Left", "}"}]}], "}"}], "}"}]}], ",", 
          RowBox[{"ItemSize", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"{", 
             RowBox[{"15", ",", "4"}], "}"}], 
            StyleBox["}", "Input"]}]}], ",", 
          RowBox[{"Frame", "\[Rule]", 
           RowBox[{"Darker", "[", 
            RowBox[{"Gray", ",", ".6"}], "]"}]}], ",", 
          RowBox[{"ItemStyle", "\[Rule]", "14"}], ",", 
          RowBox[{"Spacings", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"Automatic", ",", ".8"}], "}"}]}]}], "]"}]}], 
       "\[IndentingNewLine]", "\"\< Plots \\n\>\""}], "]"}], 
     "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]"}]], "Input",\

 InitializationCell->True,
 CellChangeTimes->{{3.4549996580066*^9, 3.454999695012748*^9}, {
   3.4549997907256527`*^9, 3.454999792532206*^9}, {3.4549999187429123`*^9, 
   3.454999951148548*^9}, 3.455000299528573*^9}],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
  "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**"}], 
  "*****)"}]], "Input",
 CellChangeTimes->{{3.447343976066638*^9, 3.447343985361043*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"see", " ", 
   RowBox[{"DynamicClustering", ".", "nb"}], " ", "for", " ", "the", " ", 
   "input", " ", "panel"}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.4506175029852962`*^9, 3.450617526436043*^9}}],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.4506188579727697`*^9, 3.450618864035178*^9}, {
   3.4506191946915007`*^9, 3.4506192156279097`*^9}, 3.450619281957238*^9}]
},
AutoGeneratedPackage->Automatic,
WindowToolbars->{},
WindowSize->{1146, 885},
WindowMargins->{{Automatic, 19}, {41, Automatic}},
PrintingCopies->1,
PrintingPageRange->{1, Automatic},
FrontEndVersion->"7.0 for Linux x86 (64-bit) (February 25, 2009)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[545, 20, 96, 1, 31, "Input"],
Cell[644, 23, 223, 4, 52, "Input",
 InitializationCell->True],
Cell[870, 29, 166, 3, 31, "Input"],
Cell[1039, 34, 2181, 34, 332, "Input",
 InitializationCell->True],
Cell[3223, 70, 3666, 58, 132, "Input",
 InitializationCell->True],
Cell[6892, 130, 125, 2, 31, "Input"],
Cell[7020, 134, 1975, 42, 172, "Input",
 InitializationCell->True],
Cell[8998, 178, 3999, 86, 312, "Input",
 InitializationCell->True],
Cell[13000, 266, 2008, 45, 192, "Input",
 InitializationCell->True],
Cell[15011, 313, 2057, 45, 152, "Input",
 InitializationCell->True],
Cell[17071, 360, 3167, 75, 152, "Input",
 InitializationCell->True,
 CellID->1897771943],
Cell[20241, 437, 3171, 76, 172, "Input",
 InitializationCell->True],
Cell[23415, 515, 3040, 73, 172, "Input",
 InitializationCell->True],
Cell[26458, 590, 8452, 170, 652, "Input",
 InitializationCell->True],
Cell[34913, 762, 7438, 156, 732, "Input",
 InitializationCell->True],
Cell[42354, 920, 1669, 36, 272, "Input",
 InitializationCell->True],
Cell[44026, 958, 2515, 55, 312, "Input",
 InitializationCell->True],
Cell[46544, 1015, 6474, 134, 552, "Input",
 InitializationCell->True],
Cell[53021, 1151, 6589, 135, 552, "Input",
 InitializationCell->True],
Cell[59613, 1288, 3155, 65, 312, "Input",
 InitializationCell->True],
Cell[62771, 1355, 6093, 109, 492, "Input",
 InitializationCell->True],
Cell[68867, 1466, 1494, 33, 152, "Input",
 InitializationCell->True],
Cell[70364, 1501, 4879, 93, 472, "Input",
 InitializationCell->True],
Cell[75246, 1596, 892, 18, 92, "Input",
 InitializationCell->True],
Cell[76141, 1616, 731, 16, 92, "Input",
 InitializationCell->True],
Cell[76875, 1634, 7432, 134, 652, "Input",
 InitializationCell->True],
Cell[84310, 1770, 983, 21, 112, "Input",
 InitializationCell->True],
Cell[85296, 1793, 681, 16, 112, "Input",
 InitializationCell->True],
Cell[85980, 1811, 252, 7, 31, "Input",
 InitializationCell->True],
Cell[86235, 1820, 342, 8, 31, "Input",
 InitializationCell->True],
Cell[86580, 1830, 346, 8, 31, "Input",
 InitializationCell->True],
Cell[86929, 1840, 405, 9, 31, "Input",
 InitializationCell->True],
Cell[87337, 1851, 444, 10, 31, "Input",
 InitializationCell->True],
Cell[87784, 1863, 446, 10, 31, "Input",
 InitializationCell->True],
Cell[88233, 1875, 150, 3, 31, "Input"],
Cell[88386, 1880, 2313, 43, 52, "Input",
 InitializationCell->True],
Cell[90702, 1925, 1470, 31, 52, "Input",
 InitializationCell->True],
Cell[92175, 1958, 2783, 60, 172, "Input",
 InitializationCell->True],
Cell[94961, 2020, 4747, 103, 372, "Input",
 InitializationCell->True],
Cell[99711, 2125, 5310, 114, 392, "Input",
 InitializationCell->True],
Cell[105024, 2241, 6169, 126, 392, "Input",
 InitializationCell->True],
Cell[111196, 2369, 7266, 150, 512, "Input",
 InitializationCell->True],
Cell[118465, 2521, 153, 3, 31, "Input"],
Cell[118621, 2526, 4156, 98, 372, "Input",
 InitializationCell->True],
Cell[122780, 2626, 5045, 111, 372, "Input",
 InitializationCell->True],
Cell[127828, 2739, 6425, 148, 532, "Input",
 InitializationCell->True],
Cell[134256, 2889, 167, 3, 31, "Input"],
Cell[134426, 2894, 2528, 55, 232, "Input",
 InitializationCell->True],
Cell[136957, 2951, 172, 3, 31, "Input"],
Cell[137132, 2956, 568, 12, 52, "Input",
 InitializationCell->True],
Cell[137703, 2970, 159, 3, 31, "Input"],
Cell[137865, 2975, 1625, 40, 212, "Input",
 InitializationCell->True],
Cell[139493, 3017, 172, 4, 52, "Input"],
Cell[139668, 3023, 2718, 68, 212, "Input",
 InitializationCell->True],
Cell[142389, 3093, 2586, 62, 192, "Input",
 InitializationCell->True],
Cell[144978, 3157, 2150, 56, 192, "Input",
 InitializationCell->True],
Cell[147131, 3215, 2619, 68, 212, "Input",
 InitializationCell->True],
Cell[149753, 3285, 1588, 38, 172, "Input",
 InitializationCell->True],
Cell[151344, 3325, 138, 2, 31, "Input"],
Cell[151485, 3329, 2919, 71, 212, "Input",
 InitializationCell->True],
Cell[154407, 3402, 2458, 65, 212, "Input",
 InitializationCell->True],
Cell[156868, 3469, 2695, 63, 192, "Input",
 InitializationCell->True],
Cell[159566, 3534, 2204, 56, 192, "Input",
 InitializationCell->True],
Cell[161773, 3592, 188, 4, 31, "Input"],
Cell[161964, 3598, 2620, 64, 212, "Input",
 InitializationCell->True],
Cell[164587, 3664, 2622, 64, 212, "Input",
 InitializationCell->True],
Cell[167212, 3730, 2818, 65, 192, "Input",
 InitializationCell->True],
Cell[170033, 3797, 2327, 58, 192, "Input",
 InitializationCell->True],
Cell[172363, 3857, 133, 2, 31, "Input"],
Cell[172499, 3861, 7311, 139, 612, "Input",
 InitializationCell->True],
Cell[179813, 4002, 5204, 118, 592, "Input",
 InitializationCell->True],
Cell[185020, 4122, 92, 1, 31, "Input"],
Cell[185115, 4125, 2850, 72, 372, "Input",
 InitializationCell->True],
Cell[187968, 4199, 3032, 74, 172, "Input",
 InitializationCell->True],
Cell[191003, 4275, 371, 7, 31, "Input"],
Cell[191377, 4284, 251, 5, 31, "Input"],
Cell[191631, 4291, 170, 2, 31, "Input"]
}
]
*)

(* End of internal cache information *)
