(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 7.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[      7238,        193]
NotebookOptionsPosition[      6560,        167]
NotebookOutlinePosition[      6900,        182]
CellTagsIndexPosition[      6857,        179]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"initialPanel", " ", "=", " ", 
   RowBox[{"Panel", "[", "\[IndentingNewLine]", 
    RowBox[{"Column", "[", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<n\>\"", ",", "\[IndentingNewLine]", 
       RowBox[{"Slider", "[", 
        RowBox[{
         RowBox[{"Dynamic", "[", "n", "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "500", ",", "10"}], "}"}]}], "]"}], ",", 
       "\[IndentingNewLine]", "\"\<p_in\>\"", ",", "\[IndentingNewLine]", 
       RowBox[{"Slider", "[", 
        RowBox[{
         RowBox[{"Dynamic", "[", "pIn", "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "1", ",", "0.01"}], "}"}]}], "]"}], ",", 
       "\[IndentingNewLine]", "\"\<p_out\>\"", ",", "\[IndentingNewLine]", 
       RowBox[{"Slider", "[", 
        RowBox[{
         RowBox[{"Dynamic", "[", "pOut", "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "1", ",", "0.01"}], "}"}]}], "]"}]}], 
      "\[IndentingNewLine]", "}"}], "\[IndentingNewLine]", "]"}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.450425677035152*^9, 3.450425684639406*^9}, {
  3.4504262135498953`*^9, 3.450426215605795*^9}, {3.4504263344684963`*^9, 
  3.450426390410191*^9}, {3.450426501642001*^9, 3.450426557559506*^9}, {
  3.450426588578294*^9, 3.450426590566935*^9}, {3.4504266208339787`*^9, 
  3.45042680827265*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"evolutionPanel", " ", "=", " ", 
   RowBox[{"Panel", "[", "\[IndentingNewLine]", 
    RowBox[{"Column", "[", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
      "\"\<Change Nodes <-> Change Edges\>\"", ",", "\[IndentingNewLine]", 
       RowBox[{"Slider", "[", 
        RowBox[{
         RowBox[{"Dynamic", "[", "pChi", "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "500", ",", "0.01"}], "}"}]}], "]"}], ",", 
       "\[IndentingNewLine]", "\"\<Create Node <-> Remove Node\>\"", ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Slider", "[", 
        RowBox[{
         RowBox[{"Dynamic", "[", "pNu", "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "1", ",", "0.01"}], "}"}]}], "]"}]}], 
      "\[IndentingNewLine]", "}"}], "\[IndentingNewLine]", "]"}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.450426251072796*^9, 3.450426257157873*^9}, {
  3.450427960820916*^9, 3.450428065556271*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"generatorPanel", " ", "=", " ", 
   RowBox[{"Panel", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Column", "[", "\[IndentingNewLine]", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{"\"\<t_max\>\"", ",", "\[IndentingNewLine]", 
        RowBox[{"Slider", "[", 
         RowBox[{
          RowBox[{"Dynamic", "[", "tMax", "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", "500", ",", "10"}], "}"}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"TabView", "[", "\[IndentingNewLine]", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"\"\<Initial\>\"", "\[Rule]", 
            RowBox[{"Dynamic", "[", "initialPanel", "]"}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"\"\<Evolution\>\"", " ", "\[Rule]", " ", 
            RowBox[{"Dynamic", "[", "evolutionPanel", "]"}]}]}], 
          "\[IndentingNewLine]", "}"}], "\[IndentingNewLine]", "]"}], ",", 
        "\[IndentingNewLine]", "\"\<Output Directory\>\"", ",", 
        "\[IndentingNewLine]", 
        RowBox[{"InputField", "[", 
         RowBox[{
          RowBox[{"Dynamic", "[", "outDir", "]"}], ",", "String"}], "]"}], 
        ",", "\[IndentingNewLine]", "\"\<File Name\>\"", ",", 
        "\[IndentingNewLine]", 
        RowBox[{"InputField", "[", 
         RowBox[{
          RowBox[{"Dynamic", "[", "fileName", "]"}], ",", "String"}], "]"}], 
        ",", "\[IndentingNewLine]", 
        RowBox[{"Button", "[", "\"\<Generate\>\"", "]"}]}], 
       "\[IndentingNewLine]", "}"}], "\[IndentingNewLine]", "]"}], ",", " ", 
     "\"\<Dynamic Graph Generator\>\""}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.4504255502333927`*^9, 3.450425687957708*^9}, {
  3.45042596610248*^9, 3.450425966796136*^9}, {3.450426208696671*^9, 
  3.4504262811666183`*^9}, {3.450426398391109*^9, 3.4504264109030933`*^9}, {
  3.450426836327918*^9, 3.450426874119615*^9}, {3.450426919526634*^9, 
  3.450426957241548*^9}, {3.450427789616647*^9, 3.450427820154735*^9}, {
  3.450427860333976*^9, 3.4504279012762136`*^9}}],

Cell[BoxData[
 RowBox[{"Dynamic", "[", "generatorPanel", "]"}]], "Input",
 CellChangeTimes->{{3.450426225491687*^9, 3.450426229262476*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", "Defaults", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"n", " ", "=", " ", "60"}], ";", "\[IndentingNewLine]", 
    RowBox[{"outDir", " ", "=", " ", "$HomeDirectory"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"fileName", "=", " ", "\"\<\>\""}], ";"}], "\[IndentingNewLine]", 
   ")"}]}]], "Input",
 CellChangeTimes->{{3.450428222373069*^9, 3.450428295332617*^9}}],

Cell[BoxData[
 DynamicBox[ToBoxes[$CellContext`generatorPanel, StandardForm],
  ImageSizeCache->{258., {178., 200.}}]], "Input",
 CellChangeTimes->{3.450427948840222*^9, 3.4504280824873247`*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Dynamic", "[", "n", "]"}]], "Input",
 CellChangeTimes->{{3.450426469150321*^9, 3.450426477397292*^9}}],

Cell[BoxData[
 DynamicBox[ToBoxes[$CellContext`n, StandardForm],
  ImageSizeCache->{14., {1., 8.}}]], "Output",
 CellChangeTimes->{3.450426477791945*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Dynamic", "[", "pIn", "]"}]], "Input",
 CellChangeTimes->{{3.450426571341175*^9, 3.450426595031584*^9}}],

Cell[BoxData[
 DynamicBox[ToBoxes[$CellContext`pIn, StandardForm],
  ImageSizeCache->{14., {1., 8.}}]], "Output",
 CellChangeTimes->{{3.450426575195416*^9, 3.450426595367165*^9}}]
}, Open  ]]
},
WindowSize->{640, 696},
WindowMargins->{{Automatic, 315}, {3, Automatic}},
FrontEndVersion->"7.0 for Mac OS X x86 (32-bit) (November 10, 2008)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[545, 20, 1402, 30, 178, "Input"],
Cell[1950, 52, 1006, 23, 148, "Input"],
Cell[2959, 77, 2128, 43, 298, "Input"],
Cell[5090, 122, 139, 2, 27, "Input"],
Cell[5232, 126, 461, 10, 103, "Input"],
Cell[5696, 138, 194, 3, 395, InheritFromParent],
Cell[CellGroupData[{
Cell[5915, 145, 126, 2, 27, "Input"],
Cell[6044, 149, 153, 3, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6234, 157, 128, 2, 27, "Input"],
Cell[6365, 161, 179, 3, 27, "Output"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
